'<ADbasic Header, Headerversion 001.001>
' Foldings                       = 123,131
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                 ADWINPRO2TDrv.INC                           #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Driver functions (running on the processor T11)   #
'#            for communicating with the TiCo processor        #
'#                                                             #
'#  ??.03.2006  MG  creation                                   #
'#  18.07.2006  MF  update for xilinix >0.30                   #
'#  19.07.2006  MF  bugfix adbload                             #
'#  19.07.2006  MF  at Set_Par : P2_sleep removed              #
'#  19.07.2006  MF  bugfix Process_start/stop/status           #
'#  20.07.2006  JK  32000000H, 3240E010H replaced by #define   #
'#  20.07.2006  JK             3340E010H replaced by #define   #
'#  20.07.2006  JK  unnecessary parentheses removed            #
'#  21.07.2006  MF  P2_GETDATA , P2_SETDATA                    #
'#  27.07.2006  PR  bugfix in SUB P2_reset_uCore               #
'#  04.08.2006  TN  Proc_No defined 1..n, P2_ADBload as a      #
'#                  FUNCTION with error codes                  #
'#  08.08.2006  TN  P2_ADBload: 33 Longs for pm subtracted for #
'#                             future use and start address 1. #
'#                             1 Long for dm subtracted        #
'#  05.09.2006  MG  P2_Set_Comm_Event                          #
'#  06.09.2006  JK  P2_Start / Stop_Process_No_Comm            #
'#  06.09.2006  JK  P2_Set_Processdelay_No_Comm                #
'#  18.09.2006  MF  P2_SET_PAR_BLOCK                           #
'#  18.09.2006  MF  P2_SET_Mem_BLOCK                           #
'#  18.10.2006  JK  vars and comments translated to English    #
'#  19.12.2006  MG  P2_WorkLoad for separate modules           #
'#  14.02.2007  MF  P2_GetDATA P2_SETDATA DM_extern            #
'#  15.02.2007  MF  P2_TDRV_INIT,P2_GetDATA P2_SETDATA         #
'#  16.02.2007  MF  P2_WorkLoad                                #
'#  20.02.2007  MF  DEBUG_CODE GET/SETDATA                     #
'#  21.02.2007  MF  P2_TDRV_INIT                               #
'#  12.03.2007  MF/JK  P2_Get_TiCo_Status                      #
'#  13.03.2007  MF  Bug P2_get_uCore_Register                  #
'#  28.03.2007  MF  Get/Set_DATA  extern mem                   #
'#                  (required TiCo Core >=52                   #
'#  30.03.2007  MF  P2_Get_TiCo_RingBuffer Set_TiCo_RingBuffer #
'#  04.04.2007  JK  P2_Get_TiCo_RingBuffer, P2_RingBuffer_FULL #
'#  05.04.2007  JK  comment: tdrv_datatable                    #
'#  10.04.2007  JK  DEBUG_CODE : P2_Get / Set_TiCo_RingBuffer  #
'#  14.05.2007  MF  designed for ADbasic 5                     #
'#  16.05.2007  MF  P2_TiCO_START/STOP/RESET                   #
'#  24.05.2007  MF  ADR Com Event changed required Tico >=1.0  #
'#  23.07.2007  ur  tdrv_datatable with 150elements            #
'#  25.07.2007  mf  p2_set_data                                #
'#  26.07.2007  mf  P2_Reset_uCore                             #
'#  02.08.2007  mf  P2_RingBuffer_Empty                        #
'#  16.08.2007  ur  proc_no renamed to tico_no                 #
'#  22.08.2007  mf  P2_Set_TiCo_RingBuffer                     #
'#  06.09.2007  mf  P2_GET_SET_DATA                            #
'#  19.10.2007  mf  SET_COMM_EVENT => SET_Master_EVENT         #
'#  06.12.2007  mf  P2_TiCo_Start_Process                      #
'#  06.12.2007  mf  P2_TiCo_Stop_Process                       #
'#  06.12.2007  mf  P2_TiCo_Set_Processdelay                   #
'#  06.12.2007  mf  P2_TiCo_Get_Processdelay                   #
'#  14.03.2008  mf  P2_GET_DATA_LONG                           #
'#  20.03.2008  gc  names of sub/func parameter revised        #
'#  11.04.2008  mf  no_master removed                          #
'#  06.01.2009  mf  P2_SET_DATA_long exten SRAM kompatibel     #
'#  06.01.2009  mf  P2_Get_DATA_long exten SRAM kompatibel     #
'#  28.01.2009  mf  P2_Get_TiCo_RingBuffer SRAM kompatibel     #
'#  20.03.2009  mf  '''+                                       #
'#  13.05.2009  mf  bugfix P2_SET_TICO_RingBuffer              #
'#  23.10.2009  mf  Check_Type_Long(tdrv_datatable[1])         #
'#  26.01.2010  mf  optimize get_data                          #
'#  28.01.2010  mf  optimize set_data                          #
'#  29.01.2010  mf  P2_TiCo_Reset =>P2_TiCo_Restart            #
'#  09.02.2010  mf  End_Exit by PROZESS_FEHLER                 #
'#  10.02.2010  mf  new function P2_TiCo_Get_Array_Length      #
'#  16.02.2010  mf  System_Array_Debug_Check beta              #
'#  02.03.2010  mf optimize P2_TiCo_Get/Set_Processdelay       #
'#  02.03.2010  mf optimize P2_TiCo_Start/Stop_Proces          #       
'#  11.03.2010  mf p2_TDRV_Init Debug optimize                 #
'#  25.05.2010  mf  optimize p2_work_laod                      #
'#                                                             #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'###############################################################

' -------------- tdrv_datatable --------------------------------
' Many functions / subroutines in this file are requiring and
' using an array called "tdrv_datatable"
' For more information on it, please see in the manual at the
' subroutine "P2_TDRV_INIT()"
' Summarily :
' tdrv_datatable is an array with 150 elements of typ Long.
' It is required for the communication between T11 and TiCo,
' because communication settings are stored in it.
' If communication to several TiCo processor should be done,
' then there are also seperate tdrv_datatables required for
' each TiCo. For example :
'    tdrv_datatable_41    for TiCo number 1 on module 4
'    tdrv_datatable_71    for TiCo number 1 on module 7
' --------------------------------------------------------------

#define TDRV_POFFSET 22 ''<HIDE>

'************************************************
' Hardware
'*************************************************
' Addresses for access on internal TiCo-RAM
#define Addr_TiCo_Set_Write_pointer     3200E000H ''<HIDE>
#define Addr_TiCo_Set_Write_pointer_EXT 32007080H ''<HIDE>
#define Addr_TiCo_Set_Read_pointer      3200E001H ''<HIDE>
#define Addr_TiCo_Set_Read_pointer_EXT  32007085H ''<HIDE>
#define Addr_TiCo_Write_Burst           32000000H ''<HIDE>
#define Addr_TiCo_Write_Burst_Count     3240E010H ''<HIDE>
#define Addr_TiCo_Write_Burst_Count_EXT 32407090H ''<HIDE>
#define Addr_TiCo_Read_Burst_Count      3340E010H ''<HIDE>
#define Addr_TiCo_Read_Burst_Count_EXT  33407090H ''<HIDE>
#define Addr_TiCo_Comm_Event            3280E2E0H ''<HIDE> 'old E24E
#define Addr_TiCo_Master_Event          3280E2E0H ''<HIDE> 'old E24E


#IF PROZESSOR = T11 THEN
import ADwinPro2TDRVLIB.lib
#ENDIF

'********************************************************************
''' sub stop TiCo
''' module_pattern: bit pattern to set the module adresses
'''******************************************************************
SUB P2_TiCo_Stop(module_pattern)
  Poke_Fast_Bus(3280E000h,module_pattern) '
ENDSUB

'********************************************************************
''' sub start TiCo programm must be load befor
''' module_pattern: bit pattern to set the module adresses
'''******************************************************************
SUB P2_TiCo_Start(module_pattern)
  Poke_Fast_Bus(3280E001h,module_pattern) '
ENDSUB

'********************************************************************
''' sub reset TiCo (stop/start) TiCo programm must be load befor
''' module_pattern: bit pattern to set the module adresses
'''******************************************************************
SUB P2_TiCo_Reset(module_pattern) ''<HIDE>
  Poke_Fast_Bus(3280E000h,module_pattern)
  Poke_Fast_Bus(3280E001h,module_pattern) '
ENDSUB


'********************************************************************
''' sub restart TiCo (stop/start) TiCo programm must be load befor
''' module_pattern: bit pattern to set the module adresses
'''******************************************************************
SUB P2_TiCo_Restart(module_pattern) 
  Poke_Fast_Bus(3280E000h,module_pattern)
  Poke_Fast_Bus(3280E001h,module_pattern) '
ENDSUB



'********************************************************************
'   Helper Funktionen only internal use
'********************************************************************
SUB P2_Reset_uCore(module)   ''<HIDE>
  dim mp as long
  Check_Card(module)
  ' generate a falling edge for the core-reset-logic
  Poke_Fast_Bus(3280E000h or shift_left(module,16), 0)
  p2_sleep(100)
  Poke_Fast_Bus(3280E000h or shift_left(module,16), 1)
  mp=shift_left(1,module-1)
  Poke_Fast_Bus(3280E001h,mp) '
  p2_sleep(100)
ENDSUB

FUNCTION P2_get_uCore_Register(module, adr) AS Long ''<HIDE>
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus((adr) or shift_left(module,16), 0)
  READ_FAST_BUS(P2_get_uCore_Register, 1)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION

'******************************************************************************
''' check if exist a pro II module on this address 
'''+ Return 
'''+        0 no module exist
'''+        1 module exist
''' module:   module-address (1..15)
'''****************************************************************************
FUNCTION P2_Test_Version(module) as Long
  DIM test as Long
  Check_Card(module)
  test=p2_check_led(module)
  if (test<>12345678H) then
    P2_Test_Version = 0 'ok
  else
    P2_Test_Version = 1 'error
  endif
ENDFUNCTION

''******************************************************************************
'' Creates a Master Event
'' module:  module-address
'' tico_no: TiCo number (1..n)
'' value:   Eventvalue     (should be set to 1 , is reset by TiCo )
''******************************************************************************
'SUB P2_Set_Master_Event(module, tico_no, value)
'  '''' Check_Card(module) ' is not necessary here, because there is always
'  ' done a Set_Par (or similar action) which already called "Check_Card"
'  Poke_Fast_Bus(Addr_TiCo_Master_Event OR shift_left(module,16), value)
'ENDSUB

'******************************************************************************
''' returns the value of the global variable PAR_x of a TiCo processor of the specified module.
''' module:  module-address (1..15)
''' tico_no: TiCo number (1..n)
''' par_no:  number of parameter to be read
'''****************************************************************************
FUNCTION P2_Get_Par(module, tico_no, par_no) as Long
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Read_pointer OR shift_left(module,16), par_no + TDRV_POFFSET)
  Poke_Fast_Bus(Addr_TiCo_Read_Burst_Count OR shift_left(module,16), 0)
  READ_FAST_BUS(P2_Get_Par, 1)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION

'******************************************************************************
''' get par block transfers a number of global Long variables, which is to be indicated,into an array
''' module:   module-address (1..15)
''' tico_no: TiCo number (1..n)
''' array[]: destination array
''' arraystartindex: startindex in destination array
''' startindex: number of first value to be transferred
''' count: number of variables to be transferred
'''****************************************************************************
SUB P2_Get_Par_Block(module, tico_no, array[], arraystartindex, startindex, count)
  Check_Card(module)
  Check_Type_Long(array[1])
  System_Array_Debug_Check(array,arraystartindex,count)
  
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Read_pointer OR shift_left(module,16), Startindex + TDRV_POFFSET)
  Poke_Fast_Bus(Addr_TiCo_Read_Burst_Count OR shift_left(module,16), count - 1)
  READ_FAST_BUS(array[arraystartindex], count)
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
' only for internal use !!!
' get par block transfers a number of global registers, which is to be indicated,into an array
' module :   module-address
' tico_no: TiCo number (1..n)
' array: destination array
' arraystartindex: startindex in destination array
' startindex: number of first value to be transferred
' count: number of variables to be transferred
'******************************************************************************
SUB P2_Get_Mem_Block(module, tico_no, array[], arraystartindex, startindex, count)   ''<HIDE>
  Check_Card(module)
  System_Array_Debug_Check(array,arraystartindex,count)
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Read_pointer OR shift_left(module,16), Startindex)
  Poke_Fast_Bus(Addr_TiCo_Read_Burst_Count OR shift_left(module,16), count - 1)
  READ_FAST_BUS(array[arraystartindex], count)
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
''' sets a global Long variable to the specified value
''' module:  module-address (1..15)
''' tico_no: TiCo number (1..n)
''' par_no:  number of global Long variable
''' value: Value (-2^31.+2^31-1) of the globale variable
'''****************************************************************************
SUB P2_Set_Par(module, tico_no, par_no, value)
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer OR shift_left(module,16), par_no + TDRV_POFFSET)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or shift_left(module,16), 1)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst       or shift_left(module,16), value)
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
''' set par block transfers an array to a number of global Long variables
''' module:   module-address (1..15)
''' tico_no: TiCo number (1..n)
''' src_array[]: source array
''' src_array_idx: start index in source array
''' par_no: number of first parameter value to be transferred
''' count: number of variables to be transferred
'''****************************************************************************
SUB P2_Set_Par_Block(module, tico_no, src_array[], src_array_idx, par_no, count)
  Check_Card(module)
  System_Array_Debug_Check(src_array,src_array_idx,count)
  
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer OR shift_left(module,16), par_no + TDRV_POFFSET)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or shift_left(module,16), count)
  write_fast_bus(src_array[src_array_idx],count,((Addr_TiCo_Write_Burst) or shift_left(module,16)))
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
' only for internal use !!!
' P2_Set_Mem_Block transfers a number of array values into global registers
' module :   module-address
' tico_no: TiCo number (1..n)
' src_array: source array
' src_array_idx: startindex in source array
' reg_addr: number of first value to be transferred
' count: number of variables to be transferred
'******************************************************************************
SUB P2_Set_Mem_Block(module, tico_no, src_array[], src_array_idx, reg_addr, count)   ''<HIDE>
  Check_Card(module)
  System_Array_Debug_Check(src_array,src_array_idx,count)
  
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer OR shift_left(module,16), reg_addr)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or shift_left(module,16), count)
  write_fast_bus(src_array[src_array_idx],count,((Addr_TiCo_Write_Burst) or shift_left(module,16) ))
  SUB_END_CRITICAL_SECTION
ENDSUB


'******************************************************************************
' module :   module-address
' tico_no: TiCo number (1..n)
' process_no: number of process(1..4)
'******************************************************************************
SUB P2_Set_Processdelay(module, tico_no, process_no, value) ''<HIDE>  
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer OR shift_left(module,16), process_no + 151)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or shift_left(module,16), 1)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst       or shift_left(module,16), value)
  SUB_END_CRITICAL_SECTION
  
  Poke_Fast_Bus(Addr_TiCo_Master_Event OR shift_left(module,16), 1)
ENDSUB


'******************************************************************************
''' sets the Processdelay (cycle time) of a TiCo process on the specified module
''' before use, please first call P2_TDRV_INIT
''' tdrv_datatable : array with 150 elements of type Long 
''' process_no: number of process(1..4)
'''****************************************************************************
SUB P2_TiCo_Set_Processdelay(tdrv_datatable[], process_no,value)
  dim module_s as long
  Check_Type_Long(tdrv_datatable[1])
  module_s=shift_left(tdrv_datatable[85],16)
  
  Check_Card(tdrv_datatable[85])
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer OR module_s, process_no + 151)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or module_s, 1)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst       or module_s, value)
  SUB_END_CRITICAL_SECTION
  
  If (tdrv_datatable[64+process_no] AND 1=0) then
    Poke_Fast_Bus(Addr_TiCo_Master_Event OR module_s, 1)
  endif
ENDSUB

'******************************************************************************
''' returns the Processdelay (cycle time) of a process on a TiCo processor on the specified module.
'''+ before use, please first call P2_TDRV_INIT
''' tdrv_datatable: array with 150 elements of type Long  (see comment at the top
''' process_no: number of process(1..4)
'''******************************************************************************
FUNCTION P2_TiCo_Get_Processdelay(tdrv_datatable[], process_no) as Long
  DIM status as Long
  dim module_s as long
  
  Check_Type_Long(tdrv_datatable[1])
  Check_Card(tdrv_datatable[85])
  module_s=shift_left(tdrv_datatable[85],16)
  
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Read_pointer OR module_s, process_no + 151)
  Poke_Fast_Bus(Addr_TiCo_Read_Burst_Count OR module_s, 0)
  READ_FAST_BUS(status, 1)
  SUB_END_CRITICAL_SECTION
  P2_TiCo_Get_Processdelay=status
ENDFUNCTION

FUNCTION P2_Get_Processdelay(module, tico_no, process_no) as Long ''<HIDE>
  DIM status as Long
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Read_pointer OR shift_left(module,16), process_no + 151)
  Poke_Fast_Bus(Addr_TiCo_Read_Burst_Count OR shift_left(module,16), 0)
  READ_FAST_BUS(status, 1)
  SUB_END_CRITICAL_SECTION
  P2_Get_Processdelay=status
ENDFUNCTION


' ******************************************************************************
' start a process
' module :   module-address
' tico_no: TiCo number (1..n)
' process_no: number of process
'******************************************************************************
SUB P2_Start_Process(module, tico_no, process_no)  ''<HIDE>
 
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer OR shift_left(module,16), process_no + 159)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or shift_left(module,16),1)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst or shift_left(module,16),1)
  SUB_END_CRITICAL_SECTION
 
  Poke_Fast_Bus(Addr_TiCo_Master_Event OR shift_left(module,16), 1)' necessary, if Eventsource is "Timer" or "Extern"

ENDSUB

'******************************************************************************
''' starts a process on a TiCo processor
'''+ before use, please first call P2_TDRV_INIT
''' tdrv_datatable[]: array with 150 elements of type Long  (see comment at the top
''' process_no: number of process(1..4)
'''****************************************************************************
SUB P2_TiCo_Start_Process(tdrv_datatable[], process_no)
  
  dim module_s as long
  Check_Type_Long(tdrv_datatable[1])
  module_s=shift_left(tdrv_datatable[85],16)
  
  Check_Card(tdrv_datatable[85])
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer OR module_s, process_no + 159)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or module_s,1)
  Poke_Fast_Bus(Addr_TiCo_Write_Burst or module_s,1)
  SUB_END_CRITICAL_SECTION
  
  If (tdrv_datatable[64+process_no] AND 1=0) then
    Poke_Fast_Bus(Addr_TiCo_Master_Event OR module_s, 1)' necessary, if Eventsource is "Timer" or "Extern"
  endif
ENDSUB

'******************************************************************************
''' stops a process on a TiCo processor.
'''+ before use, please first call P2_TDRV_INIT
''' tdrv_datatable[]: array with 150 elements of type Long  (see comment at the top
''' process_no: number of process(1..4)
'''****************************************************************************
SUB P2_TiCo_Stop_Process(tdrv_datatable[], process_no)
  
  dim module_s as long 
  DIM status as Long
  Check_Type_Long(tdrv_datatable[1])
  module_s=shift_left(tdrv_datatable[85],16)
  
  Check_Card(tdrv_datatable[85])
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Read_pointer OR module_s, process_no + 159)
  Poke_Fast_Bus(Addr_TiCo_Read_Burst_Count OR module_s, 0)
  READ_FAST_BUS(status, 1)
  if (status=1) then
    Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer OR module_s, process_no + 159)
    Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or module_s, 1)
    Poke_Fast_Bus(Addr_TiCo_Write_Burst       or module_s, -1)
  endif
  SUB_END_CRITICAL_SECTION
  
  
  
  If (tdrv_datatable[64+process_no] AND 1=0) then
    Poke_Fast_Bus(Addr_TiCo_Master_Event OR module_s, 1)' necessary, if Eventsource is "Timer" or "Extern"
  endif
ENDSUB



'******************************************************************************
' stop a process
' module :   module-address
' tico_no: TiCo number (1..n)
' process_no: number of process
'******************************************************************************
SUB P2_Stop_Process(module, tico_no, process_no) ''<HIDE>
  Check_Card(module)
  dim status as long
 
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Read_pointer OR shift_left(module,16), process_no + 159)
  Poke_Fast_Bus(Addr_TiCo_Read_Burst_Count OR shift_left(module,16), 0)
  READ_FAST_BUS(status, 1)
  if (status=1) then
    Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer OR shift_left(module,16), process_no + 159)
    Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or shift_left(module,16), 1)
    Poke_Fast_Bus(Addr_TiCo_Write_Burst       or shift_left(module,16), -1)
  endif
  SUB_END_CRITICAL_SECTION
   
  Poke_Fast_Bus(Addr_TiCo_Master_Event OR shift_left(module,16), 1)' necessary, if Eventsource is "Timer" or "Extern"

ENDSUB

'******************************************************************************
''' P2_Process_Status returns the status of a TiCo process
''' module:   module-address (1..15)
''' tico_no: TiCo number (1..n)
''' process_no: number of process
'''****************************************************************************
FUNCTION P2_Process_Status(module, tico_no, process_no) as Long
  DIM status as Long
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus(Addr_TiCo_Set_Read_pointer OR shift_left(module,16), process_no + 159)
  Poke_Fast_Bus(Addr_TiCo_Read_Burst_Count OR shift_left(module,16), 0)
  READ_FAST_BUS(status, 1)
  SUB_END_CRITICAL_SECTION
  P2_Process_Status=status
ENDFUNCTION

'******************************************************************************
''' P2 WORKLOAD returns the processor workload.
'''+ before use, please first call P2_TDRV_INIT
''' tdrv_datatable[]: array with 150 elements of type Long  
'''****************************************************************************
FUNCTION P2_WorkLoad(tdrv_datatable[]) as Float
  DIM time,counter,help_time,help_counter as Long
  dim module as Long
  dim proc_no as Long
  dim kor,i,d,s as long
  
  Check_Type_Long(tdrv_datatable[1])
  module=tdrv_datatable[85]
  proc_no=tdrv_datatable[86]
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION
  time    = p2_get_uCore_Register(module, 3380E220h)
  counter = p2_get_uCore_Register(module, 3380E240h)
  SUB_END_CRITICAL_SECTION
  
  help_time    = time    - tdrv_datatable[87]
  help_counter = counter - tdrv_datatable[88]
  
  kor=0
  if (tdrv_datatable[91]=1) then
    for i=1 to 4
      s=P2_Process_Status(module, proc_no, i)
      if (s=1) then 'luft process i?
      
        'Bit 2-4:
        '000 Timer
        '001 Extern
        '010 None
        if (tdrv_datatable[64+i] AND 11100B=0) then 'nur bei timer process kor 
          d=help_time/P2_Get_Processdelay(module, proc_no, i) 'as Long 
          kor=kor+d
        endif
      endif
    next
    help_counter=help_counter-kor
  endif
  
  
  if (help_time = 0) then
    P2_WorkLoad = -1
  else
    P2_WorkLoad = 100 * ( 1 - help_counter / help_time)
  endif
  if (p2_Workload>100) then p2_workload=100
  
  tdrv_datatable[87] = time
  tdrv_datatable[88] = counter
ENDFUNCTION

'******************************************************************************
'''reads values from a global array of a TiCo processor and writes the values into a specified array.
'''+ before use, please first call P2_TDRV_INIT
''' tdrv_datatable[]: array with 150 elements of type Long  
''' datano: source(TiCo) array number (1..16)
''' startindex: number of first array element to be transferred
''' count: number of data elements to be transferred
''' array[]: destination array
''' arrayindex: startindex in the destination array
''' flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''******************************************************************************
SUB P2_GetData_Long(tdrv_datatable[], datano, startindex, count, array[], arrayindex, flowrate)
  dim datapointer as Long ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  dim datalocation as Long ' RAM  2 = intern 3 = extern
  dim datatype_reg as Long
  dim module as Long
  dim proc_no as Long
  DIM maxburst as Long
  DIM icount as Long
  DIM anzcount as Long
  DIM iindex as Long
  DIM istart as Long
  'dim ready_to_read as Long
  
  ' dim fi_clear_adr as long
  dim Set_Read_pointer_Ext2 as long
  dim TiCo_Read_Burst_Count_Ext2 as long
  Check_Type_Long(tdrv_datatable[1])
#IF PRIORITAET = LOW
  maxburst=128
  if (flowrate=1) then maxburst=16
  if (flowrate=3) then maxburst=1024
#ELSE
  maxburst=32768
#ENDIF
  if (count>0) then
    icount=count
    iindex=arrayindex
    istart=startindex
    module =tdrv_datatable[85]
    proc_no =tdrv_datatable[86]
    ' PAR_92 is automatically incremented, when a TiCobasic process is loaded.
    ' If PAR_92 is changed, then the tdrv_datatable is invalid.
    ' => P2_TDRV_INIT has to be called again
    if (par_92<>tdrv_datatable[89]) then
      P2_TDRV_INIT(module,proc_no,tdrv_datatable)
    else
      Check_Card(module)
    endif
    datapointer= tdrv_datatable[1 + 4 * (datano - 1)] ' (absolute) pointer on the start of the DATA
    datalocation=tdrv_datatable[2 + 4 * (datano - 1)]
    datatype_reg=tdrv_datatable[3 + 4 * (datano - 1)]
#IF DEBUG_MODE=ON THEN
    if (datatype_reg=-1) then
      PROZESS_FEHLER=210000  '  "TiCo DATA does not exist"
      end_exit
    else
      if ((datatype_reg AND 0FFFFH)>4) then 
        PROZESS_FEHLER=210001   ' "TiCo DATA has wrong datatype"
        end_exit
      endif
      
        
      if (Startindex<1) then 
        prozess_fehler=210003              ' "TiCo DATA-index < 1"
        end_exit
      ENDIF
        
        
        
      if ((Startindex+count)>tdrv_datatable[4 + 4 * (datano-1)]) then 
        PROZESS_FEHLER=210002 ' "TiCo DATA-index too large"
        end_exit
      endif
      
      
    endif
#ENDIF
    if (datatype_reg <> -1) then ' check, if TiCo DATA exists
      
      
      P2_Get_DATA_INT(module,datalocation,Set_Read_pointer_Ext2,TiCo_Read_Burst_Count_Ext2) '<HIDE>
   
      do
        if (icount>maxburst) then
          anzcount=maxburst
        else
          anzcount=icount
        endif
        
        System_Array_Debug_Check(array,iindex,anzcount)
        SUB_BEGIN_CRITICAL_SECTION
        Poke_Fast_Bus(Set_Read_pointer_Ext2, datapointer+istart)
        Poke_Fast_Bus(TiCo_Read_Burst_Count_Ext2, anzcount - 1)
        READ_FAST_BUS(array[iindex], anzcount)
        SUB_END_CRITICAL_SECTION
 
        icount=icount-anzcount
        iindex=iindex+anzcount
        istart=istart+anzcount
      until (icount=0)
    endif
  endif
ENDSUB

''******************************************************************************
'''' reads values from an array and writes them into a global array of a TiCo processor on the specified module.
''''+  before use, please first call P2_TDRV_INIT
''''  tdrv_datatable[]: array with 150 elements of type Long                                                               
''''  dest_array_no: destination (TiCo) array number
''''  dest_array_idx: number of first array element to be written
''''  count: number of data elements to be transferred
''''  src_array[]: source array
''''  src_array_idx: start index in the source array
''''  flowrate: 
''''+          1=low
''''+          2=medium
''''+          3=fast
''''****************************************************************************
'SUB P2_SetData_Long(tdrv_datatable[], dest_array_no, dest_array_idx, count, src_array[], src_array_idx, flowrate)
'  dim datapointer as Long ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
'  dim datalocation as Long 'RAM 2 = intern 3 = extern 4=extern sram
'  dim datatype_reg as Long
'  dim module as Long
'  dim proc_no as Long
'  DIM maxburst as Long
'  DIM icount, i as Long
'  DIM anzcount as Long
'  DIM iindex as Long
'  DIM istart as Long
'  dim busy as long
'  dim busyADR as long
'  dim Addr_TiCo_Set_Write_pointer_EXT2 as long
'  dim Addr_TiCo_Write_Burst_Count_EXT2 as long
'  Check_Type_Long(tdrv_datatable[1]) 
'#IF PRIORITAET = LOW
'  maxburst=128
'  if (flowrate=1) then maxburst=16
'  if (flowrate=3) then maxburst=1024
'#ELSE
'  maxburst=32768
'#ENDIF
'  if (count>0) then
'    icount=count
'    iindex=src_array_idx
'    istart=dest_array_idx
'    module = tdrv_datatable[85]
'    proc_no = tdrv_datatable[86]
'    ' PAR_92 is automatically incremented, when a TiCobasic process is loaded.
'    ' If PAR_92 is changed, then the tdrv_datatable is invalid.
'    ' => P2_TDRV_INIT has to be called again
'    if (par_92<>tdrv_datatable[89]) then
'      P2_TDRV_INIT(module,proc_no,tdrv_datatable)
'    else
'      Check_Card(module)
'    endif
'    datapointer= tdrv_datatable[1 + 4 * (dest_array_no - 1)] ' (absolute) pointer on the start of the DATA
'    datalocation=tdrv_datatable[2 + 4 * (dest_array_no - 1)]
'    datatype_reg=tdrv_datatable[3 + 4 * (dest_array_no - 1)]
'#IF DEBUG_MODE=ON THEN
'    if (datatype_reg = -1) then
'      PROZESS_FEHLER=210020   '  "TiCo DATA does not exist"
'    else
'      if ((datatype_reg AND 0FFFFH) >4) then PROZESS_FEHLER=210021 ' "TiCo DATA has wrong datatype"
'      if (dest_array_idx<1) then prozess_fehler=210023             ' "TiCo DATA-index < 1"
'      if ((dest_array_idx+count)>tdrv_datatable[4 + 4 * (dest_array_no-1)]) then PROZESS_FEHLER=210022 ' "TiCo DATA-index too large"
'    endif
'#ENDIF
'    if (datatype_reg <> -1) then ' check, if TiCo DATA exists
'      do
'        if (icount>maxburst) then
'          anzcount=maxburst
'        else
'          anzcount=icount
'        endif
'        if (datalocation=2) then ' RAM  2 = intern
'          SUB_BEGIN_CRITICAL_SECTION
'          Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer or shift_left(module,16), datapointer  + istart)
'          Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count or shift_left(module,16), anzcount)
'          write_fast_bus(src_array[iindex],anzcount,((Addr_TiCo_Write_Burst) or shift_left(module,16) ))
'          SUB_END_CRITICAL_SECTION
'        else                      ' RAM  3 = extern
'          
'          if (datalocation=4) then 'sram ext
'            busyADR=33807082h or shift_left(module,16)
'            Addr_TiCo_Set_Write_pointer_EXT2=32007082H or shift_left(module,16)
'            Addr_TiCo_Write_Burst_Count_EXT2=32407092H or shift_left(module,16)
'          else
'            busyADR=33807080h or shift_left(module,16)
'            Addr_TiCo_Set_Write_pointer_EXT2 =Addr_TiCo_Set_Write_pointer_EXT or shift_left(module,16)
'            Addr_TiCo_Write_Burst_Count_EXT2=Addr_TiCo_Write_Burst_Count_EXT or shift_left(module,16)
'          endif
'          
'         
'          SUB_BEGIN_CRITICAL_SECTION
'          do
'            Poke_Fast_Bus(busyADR ,0)
'            read_fast_bus(busy,1)
'          until ((busy=1) or (busy=12345678H))
'          
'          Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer_EXT2 , datapointer  + istart)
'          Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count_EXT2 , anzcount)
'         
'          write_fast_bus(src_array[iindex],anzcount,((Addr_TiCo_Write_Burst) or shift_left(module,16) ))
'          SUB_END_CRITICAL_SECTION
'        endif
'        icount=icount-anzcount
'        iindex=iindex+anzcount
'        istart=istart+anzcount
'      until (icount=0)
'    endif
'  endif
'ENDSUB


'******************************************************************************
''' reads values from an array and writes them into a global array of a TiCo processor on the specified module.
'''+  before use, please first call P2_TDRV_INIT
'''  tdrv_datatable[]: array with 150 elements of type Long                                                               
'''  dest_array_no: destination (TiCo) array number
'''  dest_array_idx: number of first array element to be written
'''  count: number of data elements to be transferred
'''  src_array[]: source array
'''  src_array_idx: start index in the source array
'''  flowrate: 
'''+          1=low
'''+          2=medium
'''+          3=fast
'''****************************************************************************
SUB P2_SetData_Long(tdrv_datatable[], dest_array_no, dest_array_idx, count, src_array[], src_array_idx, flowrate)
  dim datapointer as Long ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  dim datalocation as Long 'RAM 2 = intern 3 = extern 4=extern sram
  dim datatype_reg as Long
  dim module as Long
  dim proc_no as Long
  DIM maxburst as Long
  DIM icount, i as Long
  DIM anzcount as Long
  DIM iindex as Long
  DIM istart as Long
  dim busy as long
  dim busyADR as long
  dim Addr_TiCo_Set_Write_pointer_EXT2 as long
  dim Addr_TiCo_Write_Burst_Count_EXT2 as long
  Check_Type_Long(tdrv_datatable[1]) 
#IF PRIORITAET = LOW
  maxburst=128
  if (flowrate=1) then maxburst=16
  if (flowrate=3) then maxburst=1024
#ELSE
  maxburst=32768
#ENDIF
  if (count>0) then
    icount=count
    iindex=src_array_idx
    istart=dest_array_idx
    module = tdrv_datatable[85]
    proc_no = tdrv_datatable[86]
    ' PAR_92 is automatically incremented, when a TiCobasic process is loaded.
    ' If PAR_92 is changed, then the tdrv_datatable is invalid.
    ' => P2_TDRV_INIT has to be called again
    if (par_92<>tdrv_datatable[89]) then
      P2_TDRV_INIT(module,proc_no,tdrv_datatable)
    else
      Check_Card(module)
    endif
    datapointer= tdrv_datatable[1 + 4 * (dest_array_no - 1)] ' (absolute) pointer on the start of the DATA
    datalocation=tdrv_datatable[2 + 4 * (dest_array_no - 1)]
    datatype_reg=tdrv_datatable[3 + 4 * (dest_array_no - 1)]
#IF DEBUG_MODE=ON THEN
    if (datatype_reg = -1) then
      PROZESS_FEHLER=210020   '  "TiCo DATA does not exist"
      end_exit
    else
      if ((datatype_reg AND 0FFFFH) >4) then
        PROZESS_FEHLER=210021 ' "TiCo DATA has wrong datatype"
        end_exit
      endif
      
        
      if (dest_array_idx<1) then 
        prozess_fehler=210023             ' "TiCo DATA-index < 1"
        end_exit
      endif
      
        
      if ((dest_array_idx+count)>tdrv_datatable[4 + 4 * (dest_array_no-1)]) then 
        PROZESS_FEHLER=210022 ' "TiCo DATA-index too large"
        end_exit
      endif
      
    endif
#ENDIF
    if (datatype_reg <> -1) then ' check, if TiCo DATA exists
      
      P2_SET_DATA_INT(module,datalocation,Addr_TiCo_Set_Write_pointer_EXT2,Addr_TiCo_Write_Burst_Count_EXT2,busyADR) ''<HIDE>
  
      
      do
        if (icount>maxburst) then
          anzcount=maxburst
        else
          anzcount=icount
        endif
         
        System_Array_Debug_Check(src_array,iindex,anzcount)
        
        SUB_BEGIN_CRITICAL_SECTION
        
        if (busyadr<>0) then
          do
            Poke_Fast_Bus(busyADR ,0)
            read_fast_bus(busy,1)
          until ((busy=1) or (busy=12345678H))
        endif 
          
        Poke_Fast_Bus(Addr_TiCo_Set_Write_pointer_EXT2 , datapointer  + istart)
        Poke_Fast_Bus(Addr_TiCo_Write_Burst_Count_EXT2 , anzcount)
         
        write_fast_bus(src_array[iindex],anzcount,((Addr_TiCo_Write_Burst) or shift_left(module,16) ))
        SUB_END_CRITICAL_SECTION
    
        icount=icount-anzcount
        iindex=iindex+anzcount
        istart=istart+anzcount
      until (icount=0)
    endif
  endif
ENDSUB


'******************************************************************************
''' read TiCo Status
'''+ return 
'''+        -3 = no TiCo on this module
'''+        -2 = no Pro 2 modul exists (Timeout)
'''+        >0 = each bit corresponds to a TiCo (1= TiCo 1 run)
''' module:   module-address (1..15)
'''****************************************************************************
FUNCTION P2_Get_TiCo_Status(module) as Long
  dim count, a1_1, a1_2 as Long
  Check_Card(module)
  SUB_BEGIN_CRITICAL_SECTION
  Poke_Fast_Bus((33800E00h) or shift_left(module,16), 0)
  READ_FAST_BUS(count, 1)
  SUB_END_CRITICAL_SECTION
  if (count = 12345678H) then
    P2_GET_TiCo_Status=-2
  else
    if (count=0) then
      P2_GET_TiCo_Status=-3
    else
      SUB_BEGIN_CRITICAL_SECTION
      Poke_Fast_Bus((3380E220h) or shift_left(module,16), 0)
      READ_FAST_BUS(a1_1, 1)
      Poke_Fast_Bus((3380E220h) or shift_left(module,16), 0)
      READ_FAST_BUS(a1_2, 1)
      SUB_END_CRITICAL_SECTION
      if (a1_1=a1_2) then
        P2_GET_TiCo_Status=0
      else
        P2_GET_TiCo_Status=1
      endif
    endif
  endif
ENDFUNCTION

'******************************************************************************
'''  initializes the data transfer between ADwin CPU and a TiCo processor
'''  module:  module-address  (1..15)
'''  tico_no: TiCo number (1..n)
'''  tdrv_datatable[]: array with 150 elements of type Long  
'''****************************************************************************
Sub P2_TDRV_Init(module, tico_no, tdrv_datatable[])
  Check_Type_Long(tdrv_datatable[1])
  Check_Card(module)
  System_Array_Debug_Check(tdrv_datatable,1,150)
  P2_TDRV_INIT_int(module, tico_no, tdrv_datatable)
  
#IF DEBUG_MODE=ON THEN
  if (tdrv_datatable[90]<>16) then
    PROZESS_FEHLER=210500  '  "TiCo Datatable does not exist"
    end_exit
  endif
#ENDIF

  
  
endsub

'******************************************************************************
'''reads values from a ringbuffer of a TiCo processor and writes the values into an array of ADwin CPU.
'''+ before use, please first call P2_TDRV_INIT
'''+ return value 1: Error: The TiCo write ringbuffer is dimensioned wrongly.
''' tdrv_datatable[]: Array holding settings for data transfer, e. g. module address and TiCo number.                                                         
''' datano: source(TiCo) array number
''' array[]: destination array
''' arraystartindex: startindex in the destination array
''' maxcount: Max. number (1.n) of transferred values.
'''  flowrate: 
'''+          1=low
'''+          2=medium
'''+          3=fast
''' tico_par: Code number to transfer the read pointer to the TiCo processor.
'''+       1.80: Number (1.80) of global variable Par_n of the TiCo processor, into which the current read pointer value is written.
'''+       0: Read pointer value is not transferred
''' stuct: Code for measurement records:
'''+        0: Read arbitrary number of values.
'''+       >0: The number of transferred values must be a multiple of struct.
'''******************************************************************************
FUNCTION P2_Get_TiCo_RingBuffer(tdrv_datatable[], datano, array[], arraystartindex, maxcount, flowrate, tico_par, struct) as Long
  dim datapointer as Long ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  dim datalocation as Long ' RAM  2 = intern 3 = extern
  dim datatype_reg as Long
  dim size as Long         ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
  dim module as Long
  dim ticonr as Long
  dim tindex as Long ' writepointer ( at first :  = absolute address in TiCo memory)
  '                                 ( later :  = rel. addr. in TiCo mem. ; range : 1 ... size )
  dim count as Long
  dim count1 as Long
  dim count2 as Long
  dim write_registernr as Long
  dim regnr2 as Long         ' position of rel_read_pointer in tdrv_datatable
  dim rel_read_pointer as Long ' pointer relative to the start of the array :  1 ... n
  dim buffer_full as Long
  dim max as Long
#IF DEBUG_MODE=ON THEN
  dim read_registernr as Long
#ENDIF
  Check_Type_Long(tdrv_datatable[1])
 
  datapointer = tdrv_datatable[1 + 4 * (datano - 1)] ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  datalocation= tdrv_datatable[2 + 4 * (datano - 1)] ' RAM     2 = intern 3 = extern 4=sram_extern
  datatype_reg= tdrv_datatable[3 + 4 * (datano - 1)]
  size =        tdrv_datatable[4 + 4 * (datano - 1)]-1 ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
  module =        tdrv_datatable[85]
  ticonr =      tdrv_datatable[86]
  ' which TiCo Indexreg is used as a write pointer ?  Actually possible values : 1, 2
  write_registernr=shift_right(datatype_reg,16) AND 0FFH
  if (write_registernr<>0) then  ' Check : is this ringbuffer declared in TiCo for writing ? If not : do nothing
#IF DEBUG_MODE=ON THEN
    read_registernr = shift_right(datatype_reg,24)
    if (read_registernr<>0) then  ' Check : is this ringbuffer declared in TiCo also for reading ?
      ' Yes ! This means, that the TiCo AS WELL AS this function wants to read
      ' from the ringbuffer. This will cause trouble  =>
      PROZESS_FEHLER=210100  '  "TiCo Ringbuffer is declared as READ and WRITE"
      end_exit
    endif
#ENDIF
    if (datalocation=3) then ' RAM  2 = intern or sram
      regnr2=78+write_registernr
    else                      ' RAM  3 = extern dram
      regnr2=74+write_registernr
    endif
    rel_read_pointer=tdrv_datatable[regnr2] ' pointer relative to the start of the array :  1 ... n
    count1=0
    count=0
    count2=0
    if (datalocation=3) then ' RAM  2 = intern 3 = extern
      ' tindex = writepointer ( = absolute address in TiCo memory)
      tindex = p2_get_uCore_Register(module,(3380E500h+32*(write_registernr-1))) ' get TiCos Index1 or Index2 Register
    else
      tindex = p2_get_uCore_Register(module,(3380E400h+32*(write_registernr-1))) ' get TiCos Indexe1 or Indexe2 Register
    endif
    tindex = tindex - datapointer ' writepointer ( = relative address in TiCo memory ; range : 1 ... size )
    buffer_full = tindex - rel_read_pointer ' number of elements, which the ringbuffer contains
    if (buffer_full<0) then buffer_full=buffer_full+size ' turnaround - check
    max=buffer_full
    if (max>maxcount) then max=maxcount
    IF (struct>0) then max=(max/struct)*struct
    'if (tindex = rel_read_pointer) not necessary to handle this case, bec. then the ringbuffer is empty
    if (tindex < rel_read_pointer) then
      count = size - rel_read_pointer + 1
      if (count>max) then count=max
      count1=count
      if (count > 0) then
        P2_GETData_Long(tdrv_datatable,datano,rel_read_pointer,count,array,arraystartindex,flowrate)
        rel_read_pointer = rel_read_pointer+count
        if (rel_read_pointer >  size) then rel_read_pointer=1   '
      endif
    endif
    if (tindex > rel_read_pointer) then
      count = tindex - rel_read_pointer +1
      if (count+count1>max) then count=max-count1
      count2=count
      if (count > 0) then
        P2_GetData_Long(tdrv_datatable,datano,rel_read_pointer,count,array,arraystartindex+count1,flowrate)
        rel_read_pointer = rel_read_pointer + count
      endif
    endif
    P2_GET_TICO_RingBuffer=count2+count1
    tdrv_datatable[regnr2]=rel_read_pointer
    if ((tico_par>0) AND (tico_par<81)) then
      ' copy the (absolute) read_pointer into a TiCo parameter
      p2_SET_PAR(module,ticonr,tico_par,rel_read_pointer+datapointer)
    endif
  else
    P2_GET_TICO_RingBuffer=-1 ' error: ringbuffer was in TiCo not declared for writing
  endif
ENDFUNCTION

'******************************************************************************
'''writes values from an ADwin CPU array into a ringbuffer on the TiCo processor.
'''+ before use, please first call P2_TDRV_INIT
'''+ Success status of instruction:
'''+       -1: Error: The TiCo read ringbuffer is dimensioned wrongly.
'''+       0: Successful. The return value equals the number of transferred values.
''' tdrv_datatable[]: array with 150 elements of type Long  
''' datano: source(TiCo) array number
''' array[]: destination array
''' arraystartindex: startindex in the destination array
''' maxcount:Max. number (1.n) of transferred values.
'''  flowrate: 
'''+          1=low
'''+          2=medium
'''+          3=fast
''' tico_par:  Code number to transfer the write pointer to the TiCo processor.
'''+          1.80: Number (1.80) of global variable Par_n of the TiCo processor, into which the current write pointer value is written.
'''+          0: Write pointer value is not transferred.
''' struct: Code for measurement records:
'''+          0: Read arbitrary number of values.
'''+         >0: The number of transferred values must be a multiple of struct.
'''******************************************************************************
FUNCTION P2_Set_TiCo_RingBuffer(tdrv_datatable[], datano, array[], arraystartindex, maxcount, flowrate, tico_par, struct) as Long
  dim datapointer as Long ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  dim datalocation as Long ' RAM  2 = intern 3 = extern
  dim datatype_reg as Long
  dim size as Long         ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
  dim module as Long
  dim ticonr as Long
  dim tindex as Long ' readpointer ( at first :  = absolute address in TiCo memory)
  '                                 ( later :  = rel. addr. in TiCo mem. ; range : 1 ... size )
  dim count as Long
  dim count1 as Long
  dim count2 as Long
  dim read_registernr as Long
  dim regnr2 as Long        ' position of rel_write_pointer in tdrv_datatable
  dim rel_write_pointer as Long  ' pointer relative to the start of the array :  1 ... n
  dim buffer_full as Long
  dim max as Long
#IF DEBUG_MODE=ON THEN
  dim write_registernr as Long
#ENDIF
  Check_Type_Long(tdrv_datatable[1])
  datapointer = tdrv_datatable[1 + 4 * (datano - 1)] ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  datalocation= tdrv_datatable[2 + 4 * (datano - 1)] ' RAM     2 = intern 3 = extern
  datatype_reg= tdrv_datatable[3 + 4 * (datano - 1)]
  size =        tdrv_datatable[4 + 4 * (datano - 1)]-1       ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
  module =      tdrv_datatable[85]
  ticonr =      tdrv_datatable[86]
  ' which TiCo Indexreg is used as a read pointer ?  Actually possible values : 1, 2
  read_registernr=shift_right(datatype_reg,24)
  if (read_registernr<>0) then  ' Check : is this ringbuffer declared in TiCo for reading ? If not : do nothing
#IF DEBUG_MODE=ON THEN
    write_registernr = shift_right(datatype_reg,16) AND 0FFH
    if (write_registernr<>0) then  ' Check : is this ringbuffer declared in TiCo also for writing ?
      ' Yes ! This means, that the TiCo AS WELL AS this function wants to write
      ' to the ringbuffer. This will cause trouble  =>
      PROZESS_FEHLER=210120  '  "TiCo Ringbuffer is declared as READ and WRITE"
      end_exit
    endif
#ENDIF
    if (datalocation=3) then ' RAM  2 = intern 3 = extern
      regnr2=78+read_registernr
    else
      regnr2=74+read_registernr
    endif
    rel_write_pointer=tdrv_datatable[regnr2] ' pointer relative to the start of the array :  1 ... n
    count=0
    count1=0
    count2=0
    if (datalocation=3) then  ' RAM  2 = intern 3 = extern
      ' tindex = readpointer ( = absolute address in TiCo memory)
      tindex = p2_get_uCore_Register(module,(3380E500h+32*(read_registernr-1))) ' get TiCos Index1 or Index2 Register
    else
      tindex = p2_get_uCore_Register(module,(3380E400h+32*(read_registernr-1))) ' get TiCos Indexe1 or Indexe2 Register
    endif
    
    tindex = tindex - datapointer '  readpointer ( = relative address in TiCo memory ; range : 1 ... size )
    buffer_full = rel_write_pointer - tindex+1 ' number of elements, which the ringbuffer contains
    ' if (buffer_full<0) then buffer_full=buffer_full+size ' turnaround - check
    if (buffer_full<1) then buffer_full=buffer_full+size ' turnaround - check
   
    max=size-buffer_full ' max. count of the free elements in the ringbuffer
    if (max>maxcount) then max=maxcount
    IF (struct>0) then max=(max/struct)*struct
    if (tindex <= rel_write_pointer) then
      count = size - rel_write_pointer + 1
      if (count>max) then count=max
      count1=count
      if (count > 0) then
        P2_SetData_Long(tdrv_datatable,datano,rel_write_pointer,count,array,arraystartindex,flowrate)
        rel_write_pointer = rel_write_pointer+count
        if (rel_write_pointer>size) then rel_write_pointer=1
      endif
    endif
    if (tindex >= rel_write_pointer) then
      count = tindex - rel_write_pointer +1
      if (count+count1>max) then count=max-count1
      count2=count
      if (count > 0) then
        P2_SetData_Long(tdrv_datatable,datano,rel_write_pointer,count,array,arraystartindex+count1,flowrate)
        rel_write_pointer = rel_write_pointer + count
      endif
    endif
    P2_SET_TICO_RingBuffer=count2+count1
    tdrv_datatable[regnr2]=rel_write_pointer
    if ((tico_par>0) AND (tico_par<81)) then
      ' copy the (absolute) write_pointer into a TiCo parameter
      P2_SET_PAR(module,ticonr,tico_par,rel_write_pointer+datapointer)
    endif
  else
    P2_SET_TICO_RingBuffer=-1 ' error : ringbuffer was in TiCo not declared for reading
  endif
ENDFUNCTION

'''returns the number of used elements in a read ringbuffer on a TiCo processor
'''tdrv_datatable[]: Array holding settings for data transfer, e. g. module address and TiCo number.
'''datano: Number (1.16) of read ringbuffer Data_n on the TiCo processor.
FUNCTION P2_RingBuffer_Full(tdrv_datatable[], datano) as Long
  dim datapointer as Long ' (absolute) pointer on the start of the DATA (on the element no. 0, which does not exist)
  dim datalocation as Long ' RAM  2 = intern 3 = extern
  dim datatype_reg as Long
  dim size as Long
  dim module as Long
  dim mode as Long
  dim read_registernr as Long
  dim write_registernr as Long
  dim regnr3 as Long
  dim write_pointer as Long
  dim read_pointer as Long
  Check_Type_Long(tdrv_datatable[1])
  datapointer = tdrv_datatable[1 + 4 * (datano - 1)] ' (absolute) pointer on the start of the DATA
  datalocation= tdrv_datatable[2 + 4 * (datano - 1)] ' RAM  2 = intern 3 = extern
  datatype_reg= tdrv_datatable[3 + 4 * (datano - 1)]
  size =        tdrv_datatable[4 + 4 * (datano - 1)]-1
  module =        tdrv_datatable[85]
  ' which TiCo Indexreg is used as read / write pointer ?  Actually possible values : 1, 2
  read_registernr=shift_right(datatype_reg,24) 'read
  write_registernr=shift_right(datatype_reg,16) AND 0FFH 'write
  mode=0
  if (datalocation=3) then
    if (read_registernr>0) then '
      mode=1        ' TiCo reads this ringbuffer
      read_pointer  = p2_get_uCore_Register(module,(3380E500h+32*(read_registernr-1)))  ' get TiCos Index1 or Index2 Register
    endif
    if (write_registernr>0) then '
      mode=mode+2  ' TiCo writes to this ringbuffer
      write_pointer = p2_get_uCore_Register(module,(3380E500h+32*(write_registernr-1))) ' get TiCos Index1 or Index2 Register
    endif
    regnr3 = 78 ' read_ or write_registernr will be added later
  else ' datalocation = 2,4
    if (read_registernr>0) then '
      mode=1        ' TiCo reads this ringbuffer
      read_pointer  = p2_get_uCore_Register(module,(3380E400h+32*(read_registernr-1)))  ' get TiCos Indexe1 or Indexe2 Register
    endif
    if (write_registernr>0) then '
      mode=mode+2  ' TiCo writes to this ringbuffer
      write_pointer = p2_get_uCore_Register(module,(3380E400h+32*(write_registernr-1))) ' get TiCos Indexe1 or Indexe2 Register
    endif
    regnr3 = 74 ' read_ or write_registernr will be added later
  endif
  if (mode=0) then    ' type : no buffer at all
    P2_RingBuffer_FULL=-1  ' error
  else
    if (mode=1) then ' TiCo does ONLY read this ringbuffer
      read_pointer = read_pointer - datapointer ' make the absolute pointer to a relative pointer
      write_pointer=tdrv_datatable[regnr3 + read_registernr] ' get (relative) pointer
    else
      if (mode=2) then ' TiCo does ONLY write to this ringbuffer
        write_pointer = write_pointer - datapointer ' make the absolute pointer to a relative pointer
        read_pointer=tdrv_datatable[regnr3 + write_registernr] ' get (relative) pointer
        ' else
        '   (mode=3) nothing more to do for mode 3
      endif
    endif
    ' in mode 3 (read AND write) : substract absolute pointers
    ' in mode 1 and 2            : substract relative pointers
    P2_RingBuffer_FULL = write_pointer - read_pointer
    if (P2_RingBuffer_FULL < 0) then
      P2_RingBuffer_FULL=P2_RingBuffer_FULL + size
    endif
  endif
ENDFUNCTION


''' returns the number of free elements in a write ringbuffer on a TiCo processor
''' tdrv_datatable[]: Array holding settings for data transfer, e. g. module address and TiCo number.
''' datano: Number (1.16) of write ringbuffer Data_n on the TiCo processor.
FUNCTION P2_RingBuffer_Empty(tdrv_datatable[], datano) as Long
  dim size as Long
  dim full as Long
  Check_Type_Long(tdrv_datatable[1])
  size = tdrv_datatable[4 + 4 * (datano - 1)]-1
  full=P2_RingBuffer_FULL(tdrv_datatable,datano)
  if (full=-1) then
    P2_RingBuffer_Empty=-1
  else
    P2_RingBuffer_Empty= size - full-1
  endif
ENDFUNCTION


''' returns the length of TiCo Data
'''+ -2 no data exists
''' tdrv_datatable[]: Array holding settings for data transfer, e. g. module address and TiCo number.
''' datano: Number (1.16) of Data on the TiCo processor.
FUNCTION P2_TiCo_Get_Array_Length(tdrv_datatable[], datano) as long
  dim module as long
  module = tdrv_datatable[85]
  if (par_92<>tdrv_datatable[89]) then P2_TDRV_INIT(module,1,tdrv_datatable)
  P2_TiCo_Get_Array_Length=tdrv_datatable[4 + 4 * ((datano) - 1)]-1  ' ringbuffer size (eventually unequal to declared size bec. 8- aligned)
ENDFUNCTION












