'<ADbasic Header, Headerversion 001.001>
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        ADwpAD.inc                           #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Definition of Functions and procedures            #
'#           to access A/D-modules.                            #
'#                                                             #
'#  25.10.1996  OL   creation                                  #
'#  10.06.1999  OL   redesign & comments in english            #
'#  22.11.2000  OL   mux Wait time bug (on Transputers)        #
'#                         fixed (ADC + ADC16)                 #
'#                         new Subroutine  : ADC_Wait_MUX()    #
'#  03.12.2001  JK   1st line : ADBASIC-SYSTEM_FILE...         #
'#  19.12.2001  MF   ADC auto. 14 s MUX on 16 bit RB modules  #
'#  08.04.2002  MF   AIN FX/14                                 #
'#  02.09.2002  MG   T10                                       #
'#  05.10.2002  MF   T10                                       #
'#  10.01.2003  MF   AIN FX/14 :  new :                        #
'#                   Burst_CSTART(), Burst_Read(), SYNC_MODE() #
'#  03.06.2003  MF   AIN 8/14 , AIN 32/14: new:                #
'#  21.04.2004  MF   bugfix Burst_CRead                        #
'#  01.02.2005  MF   NOT T11                                   #
'#  14.04.2005  MF   ERROR WRONG PROCESSOR                     #
'#  13.12.2005  MF   Read_ADCF4, Read_ADCF8, Read_ADCF?_PACKED #
'#  12.12.2006  MF   Poke_NOP_ADRDF                            #
'#  08.05.2007  MF   designed for ADbasic 5                    #
'#  23.03.2009  MF   '''+                                      #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.0 or higher!        #
'#                                                             #
'###############################################################

#IF PROZESSOR=T11 THEN
#error("This include file can only be used with the processor T2, T4, T5, T8, T9 or T10.")
#ELSE
	
'---------------------------------------------------------------
' Base-address for the different types of Pro-modules.
'---------------------------------------------------------------
#DEFINE DIO 000h	'DIO - MASK ''<HIDE>
#DEFINE AD  040h	'A/D - MASK ''<HIDE>
#DEFINE DA  080h	'D/A - MASK ''<HIDE>
#DEFINE CPU 0A0h	'CPU - MASK ''<HIDE>
#DEFINE EXT 0C0h	'EXT - MASK ''<HIDE>

'---------------------------------------------------------------
' Address-table to access the hardware of the Pro-system,
' depEnding on the CPU in use (ADSP OR Transputer).
'---------------------------------------------------------------
#IF PROZESSOR = T9 THEN
#define DL         20400000h ''<HIDE>
#define DH         20400010h ''<HIDE>
#define DLX        20400020h ''<HIDE>
#define DHX        20400030h ''<HIDE>
#define ADWR       20400060h ''<HIDE>
#define ADRD       20400070h ''<HIDE>
#define adrdf      20400078h ''<HIDE>
#define CPU_EVENT  204000F0h ''<HIDE>
#define WATCHDOG   204001D0h ''<HIDE>
#define WD_TIMER   204001E0h ''<HIDE>
#define CPU_LED    204001F0h ''<HIDE>
#define d32        20400180h ''<HIDE>
#define D32I       20400198H ''<HIDE>
#ELSE
#IF PROZESSOR = T10 THEN
#define DL         20800000h ''<HIDE>
#define DH         20800010h ''<HIDE>
#define DLX        20800020h ''<HIDE>
#define DHX        20800030h ''<HIDE>
#define ADWR       20800060h ''<HIDE>
#define ADRD       20800070h ''<HIDE>
#define adrdf      20800078h ''<HIDE>
#define CPU_EVENT  208000F0h ''<HIDE>
#define WATCHDOG   208001D0h ''<HIDE>
#define WD_TIMER   208001E0h ''<HIDE>
#define CPU_LED    208001F0h ''<HIDE>
#define d32        20800180h ''<HIDE>
#define D32I       20800198H ''<HIDE>
#ELSE
#define DL               00h ''<HIDE>
#define DH               10h ''<HIDE>
#define DLX              20h ''<HIDE>
#define DHX              30h ''<HIDE>
#define ADWR             60h ''<HIDE>
#define ADRD             70h ''<HIDE>
#define CPU_EVENT       0F0h ''<HIDE>
#define WATCHDOG        1D0h ''<HIDE>
#define WD_TIMER        1E0h ''<HIDE>
#define CPU_LED         1F0h ''<HIDE>
#Endif
#EndIF


'---------------------------------------------------------------
' Procedure which adds five NOP-instructions after a REG.-WRITE
' to compensate delaytimes.
'---------------------------------------------------------------
Sub Poke_NOP(adress,value) ''<HIDE>
#IF PROZESSOR = T9 THEN
  Poke(adress,value)
  NOPs(5)
#ELSE
#IF PROZESSOR = T10 THEN
  Poke(adress,value)
  NOPs(10)
#ELSE
  Poke(adress,value)
#EndIF
#EndIF
EndSub

'---------------------------------------------------------------
' Procedure which adds five NOP-instructions after a REG.-WRITE
' to compensate delaytimes.
'---------------------------------------------------------------
Sub Poke_NOP_ADRDF(adress,value) ''<HIDE>
#IF PROZESSOR = T9 THEN
  Poke(adress,value)
  NOPs(6)
#ELSE
#IF PROZESSOR = T10 THEN
  Poke(adress,value)
  NOP 'required !!!
  NOP
  NOPs(9)
#ELSE
  Poke(adress,value)
#EndIF
#EndIF
EndSub




'---------------------------------------------------------------
' Procedure which adds one additional NOP-instruction only for
' the ADSP processor, because only neccessary there.
'---------------------------------------------------------------
Sub NOP_T9()''<HIDE>
#IF PROZESSOR = T9 THEN
  NOP
#EndIF
#IF PROZESSOR = T10 THEN
  NOP
  NOP
#EndIF
EndSub

'---------------------------------------------------------------
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'---------------------------------------------------------------
Sub Sub_Begin_Critical_Section() ''<HIDE>
#IF PROZESSOR = ADSP THEN
#IF PRIORITAET = LOW
  Begin_Critical_Section
#EndIF
#EndIF
EndSub

Sub Sub_End_Critical_Section()''<HIDE>
#IF PROZESSOR = ADSP THEN
#IF PRIORITAET = LOW
  End_Critical_Section
#EndIF
#EndIF
EndSub


'**************************************************************
' Waits for the settling time of the multiplexer.
' Waits 14 s for AIN-8/16-RB , AIN-32/16-RB 
' Waits 3 s  for all other modules
' This Sub is only for T9 or T10 (= ADSP) processors.
'**************************************************************
Sub ADC_Wait_MUX_T9(module)''<HIDE>
  DIM addr3 AS Long
  DIM modulcode AS Long
  dim time1,time2,time3 as Long
  
#if prozessor=T9 then
  time1=peek(204003F0H)
#else
  time1=peek(208003F0H)
#Endif
	
  addr3=069H OR (SHIFT_LEFT(module,8)) 
		
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr3)
  modulcode=PEEK(DLX) AND 255
  Sub_End_Critical_Section
  		
						
  IF ((Modulcode=9) OR (Modulcode=11)) then 'AIN 8/16 RB or AIN 32/16RB
    time3=560 '14 s
  ELSE
    IF ((Modulcode=21) or (modulcode=23)) then 'AIN 8/14 or 'AIN 32/14
      time3=100 '2,5 s
    ELSE
      IF ((Modulcode=22) or (Modulcode=24)) then 'AIN 8/16 RC or 'AIN 32/16 RC
        time3=220 '5,5 s
      ELSE
        time3=120 '3 s 
      EndIF
    EndIF			 	 
  EndIF	

#if prozessor=T9 then
  do
    time2=peek(204003F0H)-time1+10
  until (time2>time3)
	
#else
  do
    time2=peek(208003F0H)-time1+5
  until (time2>time3)
#Endif
 
EndSub


'***************************************************************
' Waits for the settling time of the multiplexer.
' This procedure is suitable for the ADC and the ADC16 Function. 
' (Rechecked by JK 22.11.2000 :  The Waiting time caused by this
'  procedure is 2.7 microseconds (for T8 processor with 25MHz), 
'  which is also sufficient for Pro-AIn-8/16) 
' For AIN-8/16-RB or AIN-32/16-RB please use ADC_Wait_MUX_T9 .
'***************************************************************
Sub ADC_Wait_MUX() ''<HIDE>
  ' Inline assembly code has to be written in lowercase letters !
#IF PROZESSOR = T5 THEN
  ASM{
    ldc 5
    ldc 3
    div
    stl 0
    ldc 5
    ldc 3
    div
    stl 0
    ldc 5
    ldc 3
    div
    stl 0
    ldc 5
    ldc 3
    div
    stl 0
  }END_ASM
#ELSE
#IF PROZESSOR = T9 THEN
  SLEEP(30)
#ELSE
#IF PROZESSOR = T10 THEN
  SLEEP(30)
#ELSE

  ASM{
    ldc 2
    ldc 1
    div
    stl 0
    ldc 4
    ldc 12
    shl
    stl 0
  }END_ASM
			
#EndIF
#EndIF
#EndIF
EndSub


'***************************************************************
''' Samples, converts and Reads out the digital ADC-value of an
'''+ analog input.
'''+ This Function is suitable for all 12 bit modules and for the
'''+ following 16 bit modules :  AIN-8/16-RB , AIN-32/16-RB 
'''+  Attention:                                                 
'''+  This instruction is not prepared to handle an access from  
'''+  a low AND high priority process to the same module.        
'''+ result: 16 bit Long
'''module:   module-address (0..255)
''' input_no: channel number of analog input
'''*************************************************************
Function ADC(module,input_no) AS Long
  DIM addr, addr1, adc_n, reminder AS Long
	
  '............ set MUX ............
  PRECALC
  addr = 050h OR (SHIFT_LEFT(module,8))
  PRECALC
  adc_n = input_no-1
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,adc_n)
  Sub_End_Critical_Section
  '............ Wait multiplexer settling time ........
#IF PROZESSOR=ADSP THEN 
  ADC_Wait_MUX_T9(module) ' Wait 3 s or more, depEnding on hardware
#ELSE
  ADC_Wait_MUX          ' Wait 3 s 
#EndIF
  '............ start conversion ............
  PRECALC
  addr = 054h OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,0)
  Sub_End_Critical_Section
  '............ Wait EOC ............
  PRECALC
  addr = 056h OR (SHIFT_LEFT(module,8))
  PRECALC
  addr1 = AD OR (SHIFT_LEFT(module,8))
  DO
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD,addr)
    reminder = (PEEK(DLX) AND 1)
    Sub_End_Critical_Section
  UNTIL(reminder = 0)
  '............ Read out result ............
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr1)
  ADC = PEEK(DLX)
  Sub_End_Critical_Section
EndFunction


'***************************************************************
''' Samples, converts and Reads out the digital 16 bit ADC-value
'''+ of an analog input.
'''+ For AIN-8/16-RB or AIN-32/16-RB please use the Function "ADC"
'''+ Attention:                                                 
'''+ This instruction is not prepared to handle an access from  
'''+ a low AND high priority process to the same module.        
'''+ result: 16 bit Long
''' module:   module-address (0..255)
''' input_no: channel number of analog input
'''*************************************************************
Function ADC16(module,input_no) AS Long
  DIM addr, addr1, adc_n, reminder AS Long
  '************ set MUX ************
  PRECALC
  addr = 050h OR (SHIFT_LEFT(module,8))
  PRECALC
  adc_n = input_no - 1
  Sub_Begin_Critical_Section
  Poke (ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,adc_n)
  Sub_End_Critical_Section
  '............ Wait multiplexer settling time ........
  ADC_Wait_MUX
  '............ start conversion ............
  PRECALC
  addr = 054h OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section
  '............ Wait EOC ............
  PRECALC
  addr = 056h OR (SHIFT_LEFT(module,8))
  PRECALC
  addr1 = AD OR (SHIFT_LEFT(module,8))
  DO
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD,addr)
    reminder = (PEEK(DLX) AND 1)
    Sub_End_Critical_Section
  UNTIL(reminder = 0)
  '............ start conversion again (serial ADC) ............
  PRECALC
  addr = 054h OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,0)
  Sub_End_Critical_Section
  '............ Wait EOC ............
  PRECALC
  addr = 056h OR (SHIFT_LEFT(module,8))
  PRECALC
  addr1 = AD OR (SHIFT_LEFT(module,8))
  DO
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD,addr)
    reminder = (PEEK(DLX) AND 1)
    Sub_End_Critical_Section
  UNTIL(reminder = 0)
  '............ Read out result ............
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr1)
  ADC16 = PEEK(DLX)
  Sub_End_Critical_Section
EndFunction


'***************************************************************
''' Set MUX to desired input channel.
'''+ (Gain is only on 12 bit modules available!)
''' module:   module-address (0..255)
''' pattern:  
'''+ bit 4...0 -> channel 1...32
'''+ bit 6 & 5 -> gain, 
'''*************************************************************
Sub Set_Mux(module,pattern)
  DIM addr, adc_n AS Long
  PRECALC
  addr = 050h OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,pattern)
  Sub_End_Critical_Section
EndSub


'***************************************************************
''' Start conversion of ADC.
''' module: module-address (0.255)
'''*************************************************************
Sub Start_Conv(module)
  DIM addr, adc_n AS Long
  PRECALC
  addr = 054h OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,0)
  Sub_End_Critical_Section
EndSub


'***************************************************************
''' Wait until EOC-signal goes active (End Of Conversion).
''' module: module-address (0.255)
'''*************************************************************
Sub Wait_EOC(module)
  DIM addr, reminder AS Long
  PRECALC
  addr = 056h OR (SHIFT_LEFT(module,8))
  DO
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD,addr)
    reminder = PEEK(DLX) AND 1
    Sub_End_Critical_Section
  UNTIL(reminder = 0)
EndSub


'***************************************************************
''' Returns conversion result of ADC.
'''+ result: 16 bit Long
''' module:   module-address (0..255)
'''*************************************************************
Function ReadADC(module) AS Long
  DIM addr AS Long
  PRECALC
  addr = AD OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr)
  ReadADC = PEEK(DLX)
  Sub_End_Critical_Section
EndFunction


'***************************************************************
''' Returns conversion result of ADC and starts immediately
'''+ a new conversion.
'''+ result: 16 bit Long
''' module:   module-address (0..255)
'''*************************************************************
Function ReadADC_SConv(module) AS Long
  DIM addr AS Long
  PRECALC
  addr = 058h OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr)
  ReadADC_SConv = PEEK(DLX)
  Sub_End_Critical_Section
EndFunction


'***************************************************************
''' patterns single-Ended (s.e.) or differential (diff.) inputs
'''+ for the AIN-32/x-module only.
''' module: module-address (0..255)
''' choice: 
'''+ s.e. -> 0  
'''+ diff. -> 1 (default after power-up)
'''*************************************************************
Sub SE_Diff(module,choice)
  DIM addr AS Long
  PRECALC
  addr = 061h OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,choice)
  Sub_End_Critical_Section
EndSub


'***************************************************************
''' Samples, converts and Reads out the digital 16 bit ADC-value
'''+ of an analog input of an AIN-Fx/yy-module ("fast"-ADC-module).
'''+ Attention:                                                 
'''+ This instruction is not prepared to handle an access from  
'''+ a low AND high priority process to the same module.        
'''+ result: 16 bit Long
''' module:  module-address (0..255)
''' input_no: channel number of analog input
'''*************************************************************
Function ADCF(module,input_no) AS Long
  DIM addr, addr1, dip, adc_n1, adc_n, reminder AS Long
  PRECALC
  dip = SHIFT_LEFT(module,8)
  PRECALC
  adc_n = input_no-1
  PRECALC
  adc_n1 = SHIFT_LEFT(1,adc_n)
  '............ start conversion ............
  PRECALC
  addr = 054h OR dip
  Sub_Begin_Critical_Section
  Poke (ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,adc_n1)
  Sub_End_Critical_Section
  '............ Wait EOC ............
  PRECALC
  addr = 056h OR dip
  PRECALC
  addr1 = (AD+adc_n) OR dip
  DO
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD,addr)
    reminder = PEEK(DLX) AND adc_n1
    Sub_End_Critical_Section
  UNTIL(reminder = 0)
  '............ Read out result ............
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr1)
  ADCF = PEEK(DLX) 
  Sub_End_Critical_Section
EndFunction


'***************************************************************
''' Starts a conversion on patterned ADC on AIN-Fx/yy-modules.
''' module:   module-address
''' ADC_pattern: Bit pattern that determines the ADCs whose conversion is to be started
'''*************************************************************
Sub Start_ConvF(module,ADC_pattern)
  DIM addr,adc_n AS Long
  PRECALC
  addr = 054h OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,ADC_pattern)
  Sub_End_Critical_Section
EndSub


'***************************************************************
''' Wait until EOC-signals of all patterned ADCs are active.
'''+ (for AIN-Fx/yy-modules only)
''' module:   module-address (0..255)
''' ADC_pattern: ADC-#1 -> bit 0,  ...,  ADC-#8 -> bit 7
'''*************************************************************
Sub Wait_EOCF(module,ADC_pattern)
  DIM addr, reminder AS Long
  PRECALC
  addr = 056h OR (SHIFT_LEFT(module,8))
  DO
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD,addr)
    reminder = (PEEK(DLX) AND ADC_pattern)
    Sub_End_Critical_Section
  UNTIL(reminder = 0)
EndSub


'***************************************************************
''' Returns conversion result of ADC of AIN-Fx/yy-module.
'''+ result: 16 bit Long
''' module:   module-address (0..255(
''' adc_no: channel number of analog input
'''*************************************************************
Function ReadADCF(module,adc_no) AS Long
  DIM addr AS Long
  PRECALC
  addr = (03Fh+adc_no) OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr)
  ReadADCF = PEEK(DLX)
  Sub_End_Critical_Section
EndFunction


'***************************************************************
''' Returns conversion result of two ADC's simultaneously from
'''+ an AIN-Fx/yy-module.
'''+ result: 32 bit Long
'''+ low-word -> input_no,  high-word -> input_no + 1
''' module:   module-address
''' adc_no: Number of the first F-ADC to be read (1, 3 or 1, 3, 5, 7).
'''*************************************************************
Function ReadADCF_32(module,adc_no) AS Long
  DIM addr AS Long
  PRECALC
  addr = (03Fh+adc_no) OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr)
  ReadADCF_32 = SHIFT_LEFT(PEEK(DH),16)
  ReadADCF_32 = ReadADCF_32 OR PEEK(DLX)
  Sub_End_Critical_Section
EndFunction


'***************************************************************
''' Returns conversion result of two ADC's simultaneously and
'''+ immediately starts the conversion of both ADC again.
'''+ result: 32 bit Long
'''+         low-word -> input_no,  high-word -> input_no + 
''' module:   module-address(0..255)
''' adc_no:	
'''+        1 = channel no. 1 + 2
'''+        2 = channel no. 3 + 4
'''+        3 = channel no. 5 + 6
'''+        4 = channel no. 7 + 8
'''*************************************************************
Function ReadADCF_SConv_32(module,adc_no) AS Long
  DIM addr AS Long
  PRECALC
  addr = (049h+adc_no) OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr)
  ReadADCF_SConv_32 = SHIFT_LEFT(PEEK(DH),16)
  ReadADCF_SConv_32 = (ReadADCF_SConv_32 OR PEEK(DLX))
  Sub_End_Critical_Section
EndFunction


'***************************************************************
''' Returns conversion result of ADC and starts immediately
'''+ a new conversion (for AIN-Fx/yy-modules only).
'''+ result: 16 bit Long
''' module:   module-address (0..255)
''' adc_no: channel number of analog input
'''*************************************************************
Function ReadADCF_SConv(module,adc_no) AS Long
  DIM addr AS Long
  PRECALC
  addr = (057h+adc_no) OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr)
  ReadADCF_SConv = PEEK(DLX)
  Sub_End_Critical_Section
EndFunction


'***************************************************************
''' Sets, if equipped with a S&H add-on PCB,
'''+ the mode of the S&H stage.
''' module: module-address
''' mode: 
'''+     0  sample  
'''+     1  hold 
'''*************************************************************
Sub SH_SetMode(module,mode)
  DIM addr AS Long
  PRECALC
  addr = 05Ah OR (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,mode)
  Sub_End_Critical_Section
EndSub



'**************************************************************
'''Sub is setting the parameters of the burst mode
'''module : dip switch address (0..255)
'''mode: 
'''+     1 Sample Channel 1 only
'''+     2 Sample Channel 1-2
'''+     3 Sample Channel 1-4
'''+     4 Sample Channel 1-8 
'''pulses (n*25 ns)
'''samples max 2^19 values in Mode 1
'''************************************************************
Sub Burst_Init(module,mode,pulses,samples)
  DIM addr AS Long
  DIM mode2 AS Long

  ADDR=(SHIFT_LEFT(module,8)) OR 51H
	
  Sub_Begin_Critical_Section  
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(d32,pulses)
  Sub_End_Critical_Section

  inc ADDR       'samples
  Sub_Begin_Critical_Section  
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(d32,samples)
  Sub_End_Critical_Section

  ADDR=ADDR + 2       'set mode
  MODE2=SHIFT_LEFT(((mode-1) AND 3),8)

  Sub_Begin_Critical_Section  
  Poke(ADWR,ADDR)
  NOP_T9
  Poke_NOP(DLX,MODE2)
  Sub_End_Critical_Section
EndSub

'**************************************************************
'''Sub start the burst measurement
'''module : dip switch address (0.255)
'''************************************************************
Sub Burst_Start(module)
  DIM ADR AS Long
  DIM MODE AS Long
  
  ADR=054h OR (SHIFT_LEFT(module,8))

  Sub_Begin_Critical_Section  
  Poke_NOP(ADRD,ADR)
  MODE=PEEK(D32)OR 10000000000B
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section  
  Poke(ADWR,ADR)
  NOP_T9
  Poke_NOP(D32,MODE)
  Sub_End_Critical_Section

EndSub


'**************************************************************
'''Sub start the burst measurement in continous mode
'''+This Sub is only for ADSP processors and Fx/14 Rev B2 
'''module: dip switch address (0..255)
'''************************************************************
Sub Burst_CStart(module) 
  DIM ADR AS Long
  DIM MODE AS Long
  
  ADR=054h OR (SHIFT_LEFT(module,8))

  Sub_Begin_Critical_Section  
  Poke_NOP(ADRD,ADR)
  MODE=PEEK(D32)OR 110000000000B
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section  
  Poke(ADWR,ADR)
  NOP_T9
  Poke_NOP(D32,MODE)
  Sub_End_Critical_Section
EndSub





'**************************************************************
'''Function Reads the progress of the burst measure
'''+return value: number of convertions to do
'''+This Function is only for ADSP processors and Fx/14
'''module: dip switch address (0..255)
'''************************************************************
Function Burst_Status(module) AS Long
  DIM ADDR AS Long
  DIM COUNT AS Long
   
  ADDR = 052h OR (SHIFT_LEFT(module,8))
	 
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr)
  COUNT = peek(d32)      
  Sub_End_Critical_Section
   
  INC ADDR
   
  Sub_Begin_Critical_Section 'wert
  Poke_NOP(ADRD,addr)
  Burst_Status=count-peek(d32)
  Sub_End_Critical_Section	

EndFunction

'**************************************************************
'''transfer the input data to an array
'''+This Sub is only for ADSP processors and Fx/14
'''module: dip switch address
'''channel: pattern channel
'''startadr: first value of channel which should be transferred
'''length: number of values
'''array: destination array 
'''array_startindex: startindex in the destination array
'''************************************************************
Sub Burst_Read(module,channel,startadr,count,array,array_startindex)

  DIM ADR AS Long
  DIM ADDR AS Long
  DIM value AS Long
  DIM i AS Long
  dim mode as Long
  dim ramstartadr as Long
  dim lenint as Long
  dim pointer as Long

  ADR=SHIFT_LEFT(module,8) 
 
  addr=054H or adr
  Sub_Begin_Critical_Section 
  Poke_NOP(ADRD,addr)
  MODE=peek(DLX) AND 1100000000B
  Sub_End_Critical_Section	
  
  RAMSTARTADR=(SHIFT_LEFT((channel-1),(20-shift_right(mode,8))))+startadr-1
 		
  addr=061H or adr
  Sub_Begin_Critical_Section 
  Poke(ADWR,addr)
  NOP_t9
  Poke_NOP(d32,RAMSTARTADR)
  Sub_End_Critical_Section	

  addr=60H or adr
 
  lenint=count AND 0FFFFFFFEH
 
  if (LENINT>1) then
    for i=1 to LENINT step 2   
      Sub_Begin_Critical_Section 'wert
      Poke_NOP(ADRD,addr)
      value=peek(d32)
      Sub_End_Critical_Section
      pointer=array_startindex+i-1	
      array[pointer]=value AND 0FFFFH
      array[pointer+1]=SHIFT_RIGHT(VALUE,16)	
    NEXT
  Endif
 
  if (count AND 1=1) THEN
    Sub_Begin_Critical_Section 'wert
    Poke_NOP(ADRD,addr)
    array[count+array_startindex-1]=peek(d32) AND 0FFFFH
    Sub_End_Critical_Section	
  Endif

EndSub


'**************************************************************
'''transfer the input data to an array
'''+This Sub is only for ADSP processors and Fx/14
'''module: dip switch address
'''channel: pattern channel
'''count: number of values
'''array: destination array 
'''array_startindex: startindex in the destination array
'''************************************************************
Sub Burst_CRead(module,channel,count,array[],array_startindex)

  DIM adr as Long
  dim diff as Long
  dim pos as Long 
  dim le as Long 
  dim addr as Long
  dim anz as Long
  dim i as Long
  dim str[2] as Long
  dim len[2] as Long
  dim sindex[2] as Long

  ADR=SHIFT_LEFT(module,8) 

 
  addr=052H or adr
  Sub_Begin_Critical_Section 
  Poke_NOP(ADRD,addr)
  le=peek(D32) 
  Sub_End_Critical_Section	

  inc addr

  Sub_Begin_Critical_Section 
  Poke_NOP(ADRD,addr)
  pos=peek(D32) 
  Sub_End_Critical_Section	

  diff=pos-count


  if (diff>=0) then 'overflow ?
    anz=1
    str[1]= diff
    len[1]=count
    sindex[1]=array_startindex
  else
    anz=2
    str[1]=le+diff
    str[2]=1
    len[1]=-diff
    len[2]=pos
    sindex[1]=array_startindex
    sindex[2]=array_startindex-diff
  Endif


  for i=1 to anz
    Burst_Read(module,channel,str[i],len[i],array,sindex[i])
  next

EndSub


'**************************************************************
'''transfer the input data to an array
'''module: dip switch address (0..255)
'''channel: pattern channel
'''startadr: first value of channel which should be transferred
'''count: number of values / 2
'''array: destination array 
'''array_startindex: startindex in the destination array
'''This Sub is only for ADSP processors and Fx/14
'''**************************************************************
Sub Burst_Read_Packed(module,channel,startadr,count,array,array_startindex)

  DIM ADR AS Long
  DIM ADDR AS Long
  DIM VALUE AS Long
  DIM I AS Long
  DIM MODE AS Long
  DIM RAMSTARTADR as Long
  DIM LENINT AS Long
  DIM POINTER AS Long
  DIM INTERNAINDEX AS Long

  ADR=SHIFT_LEFT(module,8) 
  INTERNAINDEX=ARRAY_STARTINDEX-1
 
  addr=054H or adr
  Sub_Begin_Critical_Section 
  Poke_NOP(ADRD,addr)
  MODE=peek(DLX) AND 1100000000B
  Sub_End_Critical_Section	
  
  RAMSTARTADR=(SHIFT_LEFT((channel-1),(20-shift_right(mode,8))))+startadr-1
 	 
  ADDR=061H OR ADR
  Sub_Begin_Critical_Section 
  Poke(ADWR,ADDR)
  NOP_t9
  Poke_NOP(d32,RAMSTARTADR)
  Sub_End_Critical_Section	
 
  ADDR=060H or ADR
  
  IF (count>0) THEN                             
    FOR i=1 to count    
      Sub_Begin_Critical_Section 
      Poke_NOP(ADRD,addr)
      array[i+INTERNAINDEX]=peek(d32)
      Sub_End_Critical_Section	
    NEXT
  EndIF
 	 
EndSub



'**************************************************************
'''Function stop the burst measure and returns the samples  
'''+This Sub is only for ADSP processors and Fx/14
'''module: dip switch address(0..255)
'''************************************************************
Function Burst_Abort(module) AS Long

  DIM ADDR AS Long
  DIM value AS Long

  addr=054H OR (SHIFT_LEFT(module,8)) 
	  
  Sub_Begin_Critical_Section 
  Poke_NOP(ADRD,addr)
  Value=peek(d32) AND 0FFFFFBFFH
  Sub_End_Critical_Section	

  Sub_Begin_Critical_Section 
  Poke(ADWR,addr)
  NOP_t9
  Poke_NOP(d32,value)
  Sub_End_Critical_Section	

  dec addr
  
  Sub_Begin_Critical_Section 'wert
  Poke_NOP(ADRD,addr)
  Burst_ABORT=peek(d32)
  Sub_End_Critical_Section	
  NOP_t9
EndFunction


'***************************************************************
'''Sub set the input range 
'''+for AIN Fx/14 only 
'''module: dip switch address (0..255)
'''channel 1-8
'''mode:
'''+     0 range -10 V -> +10 V
'''+     1 range -5V   -> + 5 V
'''+     2 range -2.5V -> + 2.5 V
'''+     3 range -1.25 -> + 1.25 V
'''*************************************************************
Sub Set_Gain(module,channel,mode)
  DIM addr, AS Long
  DIM mode3 AS Long
  DIM shift AS Long
		
  addr = 055h OR (SHIFT_LEFT(module,8))
  shift=shift_left((channel-1),1)
	
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr)
  mode3 = PEEK(DLX) 
  Sub_End_Critical_Section
  
  mode3=(mode3 AND NOT (shift_left(3,shift))) OR (shift_left((mode),shift))  
		 
  Sub_Begin_Critical_Section
  Poke(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,mode3)
  Sub_End_Critical_Section

EndSub

'**************************************************************
'''initialising the syncronisation mode of the f14 board
'''module: dip switch address (0..255)
'''mode: 
'''+      0 normal Mode (no syncronasation)
'''+      1 Master Mode
'''+      2 Slave Mode
'''+      3 Event Mode
'''************************************************************
Sub Sync_Mode(module,mode)

  dim addr as Long

  addr = 04Fh OR (SHIFT_LEFT(module,8))
  
  Sub_Begin_Critical_Section  
  Poke(ADWR,ADDR)
  NOP_T9
  Poke_NOP(D32,mode)
  Sub_End_Critical_Section

EndSub

'**************************************************************
''' determines the waiting time (between 2 measurements) of the sequential control on the specified module. 
''' module: dip switch address (0..255)
''' time: 
'''+  0=default time
'''+  1-2048 time (unit25 ns)
'''************************************************************
Sub Seq_Set_Delay(module,time)

  dim addr as Long

  addr = 63H OR (SHIFT_LEFT(module,8))
  
  Sub_Begin_Critical_Section  
  Poke(ADWR,ADDR)
  NOP_T9
  Poke_NOP(D32,time)
  Sub_End_Critical_Section

EndSub

'**************************************************************
'''initialising the ain mode 
'''module: dip switch address (0..255)
'''mode: 
'''+      0 normal Mode 
'''+      1 single shot mode
'''+      3 continuous mode
'''gain:
'''+      0 range -10 V -> +10 V
'''+      1 range -5V   -> + 5 V
'''+      2 range -2.5V -> + 2.5 V
'''+      3 range -1.25 -> + 1.25 V
'''************************************************************
Sub Seq_Mode(module,mode,gain)

  dim addr as Long
  addr=52h or (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section  
  Poke(ADWR,ADDR)
  NOP_T9
  Poke_NOP(DLX,0)
  Sub_End_Critical_Section
  
  Sub_Begin_Critical_Section
  Poke(ADWR,addr-2)
  NOP_T9
  Poke_NOP(DLX,shift_left(GAIN,5))
  Sub_End_Critical_Section
	 
  Sub_Begin_Critical_Section
  Poke(ADWR,ADDR)
  NOP_T9
  Poke_NOP(DLX,mode)
  Sub_End_Critical_Section
	 
EndSub


'**************************************************************
'''determines the channels belonging to the measurement group, which will be converted by the sequential control on the specified module. 
'''module: dip switch address (0..255)
'''pattern: the channel in single shot or continuous mode 
'''************************************************************
Sub Seq_Select(module,pattern)
  dim addr as Long
  addr=53h or (SHIFT_LEFT(module,8))
  Sub_Begin_Critical_Section  
  Poke(ADWR,ADDR)
  NOP_T9
  Poke_NOP(D32,pattern)
  Sub_End_Critical_Section
  NOP_t9
EndSub

'**************************************************************
'''this Function returns the number of channel that is in progress
'''+Amount of the channels being already converted and stored (1 ... 32).
'''+It makes only sense to use this instruction in the mode 1 (single shot).
'''+The return value must not be interpreted as the number of a channel, but always refers to the measurement group, defined by Seq_Select.
'''+For instance, return value 4 in a measurement group with the channels (1, 3, 7, 11, 12, 15) means 
'''+that channel 11 has already been converted and that channel 12 is waiting to be measured at next. 
'''+In other words: There are already 4 values in the temporary register of the module waiting to be fetched. 
'''+You can now either read out the values and process them or wait for the end of the measurement sequence.
'''module : dip switch address(0...255)
'''**************************************************************
Function Seq_Status(module) AS Long
  DIM ADDR AS Long
     
  ADDR = 051h OR (SHIFT_LEFT(module,8))
	 
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,addr)
  Seq_Status = peek(d32)      
  Sub_End_Critical_Section
  NOP_t9
EndFunction

'**************************************************************
'''reads out a specified measurement value (16 bit) of a measurement group on the specified module.
'''+This Sub is only for (ADSP) processors
'''module: dip switch address (0..255)
'''channel_index: Index no., that indicates the position of a channel in the measurement group (1 ... 32).
'''************************************************************
Function Seq_Read_One(module,channel_index) as Long 
	 
  dim value as Long
  dim i as Long
  dim baseadr as Long
	 
  i=shift_right(channel_index-1,1)
	 
  baseadr=(040h+i) OR (SHIFT_LEFT(module,8))
    
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,baseadr)
  if (channel_index and 1=1) then 
    Seq_Read_One=PEEK(d32) AND 0FFFFH    
  else
    Seq_Read_One=shift_right(PEEK(d32),16) 
  Endif
  Sub_End_Critical_Section
  NOP_t9

EndFunction

'**************************************************************
'''reads out at the same time 2 consecutive measurement values (16-bit each) of a measurement group, on the specified module and returns them in a 32-bit value. 
'''+This Sub is only for (ADSP) processors 
'''module: dip switch address (0..255)
'''channel_index: Index number that indicates the position of 2 channels in the measurement group (0 ... 15).
'''************************************************************
Function Seq_Read_TWO(module,channel_index) as Long 
	 
  dim value as Long
  dim baseadr as Long
	 
  baseadr=(040h+channel_index) OR (SHIFT_LEFT(module,8))
    
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,baseadr)
  SEQ_Read_TWO=PEEK(D32)
  Sub_End_Critical_Section
  NOP_t9
				   
EndFunction

'**************************************************************
'''transfer the input data to an array 
'''module: dip switch address
'''lenght: number of values
'''array[]: destination array 
'''array_startindex: startindex in the destination array
'''************************************************************
Sub Seq_Read(module,length,array[],array_startindex)  
	 
  dim value as Long
  dim i as Long
  dim baseadr as Long
	
  baseadr=(040h) OR (SHIFT_LEFT(module,8))
    
  if (length>2) then 
    for i=1 to length-2 step 2
      Sub_Begin_Critical_Section
      Poke_NOP(ADRD,baseadr)
      Value=PEEK(D32)
      Sub_End_Critical_Section
      inc baseadr
      array[i+array_startindex-1]=value AND 0FFFFH   'Kanal 1
      array[i+array_startindex]=shift_right(value,16) 'Kanal 2	
    next  	
  Endif
   
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,baseadr)
  Value=PEEK(D32)
  Sub_End_Critical_Section
   
  if (length and 1=1) then 
    array[length+array_startindex-1]=value AND 0FFFFH   
  else 
    array[length+array_startindex-2]=value AND 0FFFFH   
    array[length+array_startindex-1]=shift_right(value,16) 
  Endif
	 
EndSub	



'**************************************************************
'''transfer the input data to an array
'''module: dip switch address (0..255)
'''length: number of values / 2
'''array[]: destination array 
'''array_startindex: startindex in the destination array 
'''************************************************************
Sub Seq_Read_Packed(module,length,array[],array_startindex)  
	 
  dim i as Long
   
  for i=1 to length
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD,(03Fh+i) OR (SHIFT_LEFT(module,8)))
    array[i+array_startindex-1]=Peek(D32)      
    Sub_End_Critical_Section  
  next  	  
   
EndSub	

'**************************************************************
'''transfer the input data of all 32 channels to an array
'''+This Sub is only for (ADSP) processors 
'''module: dip switch address
'''array[]: destination array 
'''array_startindex: startindex in the destination array
'''**************************************************************
Sub Seq_Read32(module,array[],array_startindex)  
  dim value as Long
	 
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,(040h)OR (SHIFT_LEFT(module,8)))
   
#if prozessor=t9 then
  NOPs(7)
#else	 
  NOPs(14)
#Endif
	 
	 
  Value=PEEK(D32i)	 
  array[array_startindex]=value AND 0FFFFH   
  array[1+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[4+array_startindex]=value AND 0FFFFH   
  array[5+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[8+array_startindex]=value AND 0FFFFH   
  array[9+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[12+array_startindex]=value AND 0FFFFH   
  array[13+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[16+array_startindex]=value AND 0FFFFH   
  array[17+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[20+array_startindex]=value AND 0FFFFH   
  array[21+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[24+array_startindex]=value AND 0FFFFH   
  array[25+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[28+array_startindex]=value AND 0FFFFH   
  array[29+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[2+array_startindex]=value AND 0FFFFH   
  array[3+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[6+array_startindex]=value AND 0FFFFH   
  array[7+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[10+array_startindex]=value AND 0FFFFH   
  array[11+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[14+array_startindex]=value AND 0FFFFH   
  array[15+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[18+array_startindex]=value AND 0FFFFH   
  array[19+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[22+array_startindex]=value AND 0FFFFH   
  array[23+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32i)
  array[26+array_startindex]=value AND 0FFFFH   
  array[27+array_startindex]=shift_left(value,-16) 
  Value=PEEK(D32)
  array[30+array_startindex]=value AND 0FFFFH   
  array[31+array_startindex]=shift_left(value,-16) 
  Sub_End_Critical_Section
EndSub	  


'**************************************************************
'''transfer the input data of all 32 channels to an array
'''module: dip switch address (0..255)
'''array[]: destination array 
'''array_startindex: startindex in the destination array
'''This Sub is only for (ADSP) processors 
'''************************************************************
Sub Seq_Read32_Packed(module,array[],array_startindex)  
  dim value as Long
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD,(040h) OR (SHIFT_LEFT(module,8)))
  NOP_t9
  NOP_t9
  array[array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[2+array_startindex]=PEEK(D32i)
  NOP_t9 
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[4+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[6+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[8+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[10+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[12+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[14+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[1+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[3+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[5+array_startindex]=PEEK(D32i) 
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[7+array_startindex]=PEEK(D32i) 
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[9+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[11+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[13+array_startindex]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[15+array_startindex]=PEEK(D32)
  NOP_t9
  Sub_End_Critical_Section
EndSub	

'**************************************************************
'''transfer the input data from channel 1-4 to an array
'''module: dip switch address (0..255)
'''array[]: destination array 
'''index: startindex in the destination array
'''************************************************************
Sub Read_ADCF4_Packed(module,array[],index)    
  Sub_Begin_Critical_Section
  Poke_NOP_adrdf(ADRDF,(040h) OR (SHIFT_LEFT(module,8)))
  NOP_t9
  array[index]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[index+1]=PEEK(D32)
  NOP_t9
  Sub_End_Critical_Section
EndSub

'**************************************************************
'''transfer the input data from channel 1-8 to an array
'''module: dip switch address (0..255)
'''array[]: destination array 
'''index: startindex in the destination array
'''************************************************************
Sub Read_ADCF8_Packed(module,array[],index)    
  Sub_Begin_Critical_Section
  Poke_NOP_adrdf(ADRDF,(040h) OR (SHIFT_LEFT(module,8)))
	
  NOP_t9
	
  array[index]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[index+1]=PEEK(D32i)	
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[index+2]=PEEK(D32i)
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  NOP_t9
  array[index+3]=PEEK(D32)
  Sub_End_Critical_Section
  NOP_t9
EndSub

'**************************************************************
'''transfer the input data from channel 1-8 to an array
'''module: dip switch address
'''array[]: destination array 
'''index: startindex in the destination array
'''************************************************************
Sub Read_ADCF8(module,array[],index)    
  dim value as Long

  Sub_Begin_Critical_Section
  Poke_NOP_adrdf(ADRDF,(040h) OR (SHIFT_LEFT(module,8)))
  NOP_t9
	
  value=PEEK(D32i)'channel 1 + 2
  array[index]=value AND 0FFFFH
  array[index+1]=shift_right(value,16)
	
  value=PEEK(D32i)'channel 3 + 4
	
  array[index+2]=value AND 0FFFFH
  array[index+3]=shift_right(value,16)
  

  value=PEEK(D32i)'channel 5 + 6
  array[index+4]=value AND 0FFFFH
  array[index+5]=shift_right(value,16)
  
  value=PEEK(D32)'channel 7 + 8
  Sub_End_Critical_Section
	
  array[index+6]=value AND 0FFFFH
  array[index+7]=shift_right(value,16)

EndSub


'**************************************************************
'''transfer the input data from channel 1-4 to an array
'''module: dip switch address (0..255)
'''array: destination array 
'''index: startindex in the destination array
'''************************************************************
Sub Read_ADCF4(module,array[],index)    
  dim value as Long

  Sub_Begin_Critical_Section
  Poke_NOP_adrdf(ADRDF,(040h) OR (SHIFT_LEFT(module,8)))
  NOP_t9
  value=PEEK(D32i)'channel 1 + 2
  array[index]=value AND 0FFFFH
  array[index+1]=shift_right(value,16)
  value=PEEK(D32)'channel 3 + 4
  Sub_End_Critical_Section
  array[index+2]=value AND 0FFFFH
  array[index+3]=shift_right(value,16)
EndSub



#Endif

