****************************************
*	 Prozenummer = 1
*	 Delay = 100000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--L16-PC
'
'###############################################################
'#                        CAN.inc                              #
'#   INCLUDE-file for ADwin PC expansion board (ADwin-CAN)     #
'#                and ADwin-light-16                           #
'#          ( NOT for ADwin-Pro !)                             #
'###############################################################
'#                                                             #
'# Contents: functions and procedures for comfortable          #
'#            operation with CAN interface                     #
'#                                                             #
'#  20.08.1997  OL   creation                                  #
'#  16.11.2001  JK   1st line : ADBASIC-SYSTEM_FILE...         #
'#  14.05.2007  MF   designed for ADbasic 5                    #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#                                                             #
'###############################################################


REM Die Compilerdirektiven drfen nicht gelscht werden,
REM da sie die Wartezeit sicherstellen, die vergehen mu,
REM bis der CAN-Controller die Daten sicher bereitgestellt
REM hat.

#IF PROZESSOR = T9 THEN
  #define  enadrwr  204000dch      'wr 13           Initialisierung der ASIC-Adressen ''<HIDE> 
  #define  enadrrd  204001dch      'wr 29 ''<HIDE> 
  #define  rdcan    204000fch      'rd 15 ''<HIDE> 
  #define  wrcan    204000fch      'wr 15 ''<HIDE> 
  #define  rescan   204001fch      'rd 14 ''<HIDE> 
#ELSE
  #define  enadrwr  0dch           'wr 13           Initialisierung der ASIC-Adressen ''<HIDE> 
  #define  enadrrd  1dch           'wr 29 ''<HIDE> 
  #define  rdcan    0fch           'rd 15 ''<HIDE> 
  #define  wrcan    0fch           'wr 15 ''<HIDE> 
  #define  rescan   1fch           'rd 14 ''<HIDE> 
#ENDIF

dim test as integer              ''<HIDE>         ' fr Zeitschleife
dim CAN_Msg[9] as integer   			' Datensatz, der 8 Datenbytes und die Anzahl der Datenbytes  enthlt
                                          ' Element 1 bis 8 enthlt Datenbyte 1 bis 8
                                          ' Element 9 enthlt die Anzahl der Datenbytes  


REM Diese Prozedur gibt einen Datensatz zum Lesen frei
REM bergabeparameter: Nummer des MSG Objekts
REM                    Identifier (11 Bit)
REM Interrups werden gespert. (im Objekt)

sub EN_Receive(objektnummer,identifier)
  REM Message Objekt freigeben
    set_can_reg(objektnummer * 16, 153)
  REM Richtung lesen; DLC = 8 ; 11 Bit ID
    set_can_reg(objektnummer * 16 + 6, 128)    ' 8 Databytes ; 11 Bit ID

  REM Identifier bertragen; 11 Bit ID
    set_can_reg(objektnummer * 16 + 2, (shift_right(identifier,3)and 255))
    set_can_reg(objektnummer * 16 + 3, (shift_left(identifier,5)and 255))
endsub


REM Diese Prozedur gibt einen Datensatz zum Lesen frei
REM bergabeparameter: Nummer des MSG Objekts
REM                    Identifier (29 Bit)
REM Interrups werden gespert. (im Objekt)

sub en_receive_29(objektnummer,identifier)  ''<HIDE> 
  REM Message Objekt freigeben
    set_can_reg(objektnummer * 16, 149)
  REM Richtung lesen; DLC = 8 ; 11 Bit ID
    set_can_reg(objektnummer * 16 + 6, 132)    ' 8 Databytes ; 29 Bit ID

  REM Identifier bertragen; 29 Bit ID
    set_can_reg(objektnummer * 16 + 2, (shift_right(identifier,21)and 255))
    set_can_reg(objektnummer * 16 + 3, (shift_right(identifier,13)and 255))
    set_can_reg(objektnummer * 16 + 4, (shift_right(identifier,5)and 255))
    set_can_reg(objektnummer * 16 + 5, (shift_left(identifier,3)and 255))
endsub


REM Diese Prozedur gibt einen Datensatz zum Schreiben frei
REM bergabeparameter: Nummer des MSG Objekts
REM                    Identifier (11 Bit)
REM Interrups werden gespert. (im Objekt)

sub EN_Transmit(objektnummer,identifier)
  REM Message Objekt freigeben
    set_can_reg(objektnummer * 16, 149)

  REM Richtung schreiben ; DLC=8 ; 11 Bit ID
    set_can_reg(objektnummer * 16 + 6, 136)

  REM Identifier bertragen; 11 Bit ID
    set_can_reg(objektnummer * 16 + 2, (shift_right(identifier,3)and 255))
    set_can_reg(objektnummer * 16 + 3, (shift_left(identifier,5)and 255))
endsub


REM Diese Prozedur gibt einen Datensatz zum Schreiben frei
REM bergabeparameter: Nummer des MSG Objekts
REM                    Identifier (29 Bit)
REM Interrups werden gespert. (im Objekt)

sub en_transmit_29(objektnummer,identifier)  ''<HIDE> 
  REM Message Objekt freigeben
    set_can_reg(objektnummer * 16, 149)

  REM Richtung schreiben ; DLC=8 ; 11 Bit ID
    set_can_reg(objektnummer * 16 + 6, 140)

  REM Identifier bertragen; 11 Bit ID
    set_can_reg(objektnummer * 16 + 2, (shift_right(identifier,21)and 255))
    set_can_reg(objektnummer * 16 + 3, (shift_right(identifier,13)and 255))
    set_can_reg(objektnummer * 16 + 4, (shift_right(identifier,5)and 255))
    set_can_reg(objektnummer * 16 + 5, (shift_left(identifier,3)and 255))
endsub



REM Diese Prozedur initialisiert den CAN-Controller
REM Busbertragungsrate: 125 KBit/s

sub Init_CAN()
dim lauf as integer

  rem Reset des CAN-Controllers (Hardwarereset)
  poke(rescan,1)
#IF PROZESSOR = T9 THEN						'Resetpin mu mindestens 1 ms low sein
  sleep(10000)
#ELSE
  nwtime=read_timer()
  wait(1000)
#ENDIF
  poke(rescan,0)


  REM Bus abschalten, d.h. nur Schreibrecht fr CPU
    set_can_reg(0,65)

  REM CPU Interface Register
    set_can_reg(2,65)

  REM Masken alle auf "must match"
    set_can_reg(06h,0ffh)
    set_can_reg(07h,0ffh)
    set_can_reg(08h,0ffh)
    set_can_reg(09h,0ffh)
    set_can_reg(0ah,0ffh)
    set_can_reg(0bh,0ffh)
    set_can_reg(0ch,0ffh)
    set_can_reg(0dh,0ffh)
    set_can_reg(0eh,0ffh)
    set_can_reg(0fh,0ffh)

  REM Clock Out Register auf 0 setzen
    set_can_reg(01fh,0)
 
  REM  Bus Configuration Register auf 0 setzen
    set_can_reg(02fh,0)

  REM Bit Timing Register 0 auf 3 setzen = 125KBit/s in 
  REM Verbindung mit Register Nummer 04fh
    set_can_reg(03fh,3)

  REM Bit Timing Register 1 auf 28 setzen
    set_can_reg(04fh,28)

  REM Alle Message Objekte sperren

  for lauf = 1 to 15
    set_can_reg(lauf * 16,85)
    set_can_reg(lauf * 16 + 1,85)
  next lauf 

  REM Zugriffsrecht an CAN-Busseite zurckgeben
    set_can_reg(0,0)
endsub




REM Diese Funktion berprft, ob eine neue Nachricht im angegebenen Objekt
REM empfangen wurde. Falls dies der Fall ist werden die Daten
REM augelesen und in das Feld can_msg geschrieben.
REM Die Anzahl der Datenbytes ist im Element 9 gespeichert.
REM Die Funktion gibt den Identifier zurck. Falls keine 
REM Nachricht angekommen ist wird der Wert 0 zurckgegeben.
REM Das MSG Objekt mu zuvor entsprechend konfiguriert werden.
REM bergabeparameter: Nummer des MSG Objekts
REM Rckgabeparameter: 0 = keine neue Nachricht im MSG Objekt vorhanden
REM                    sonst Identifier


function Read_Msg(msg_nummer) as integer
  dim new as integer                                           ' Neue MSG angekommen
  dim id0,id1,id2,id3 as integer                               ' Identifier Byte 0 und 1
  dim lauf as integer                                          ' Laufvariable
  dim buffer as integer							   ' Zwischenspeicher
  dim id_lenght as integer						   ' zur Unterscheidung zwischen 11 und 29 Bit

  rem prfen, ob eine neue Nachricht angekommen ist
  new = get_can_reg(msg_nummer * 16 + 1) and 3                 'New Data Bit

if (new =2) then                                               ' Neue Daten vorhanden

  rem Anzahl der Datenbytes ermitteln
    buffer = get_can_reg(msg_nummer * 16 + 6)
    can_msg[9] = shift_right((buffer and 0f0h),4)                'Anzahl der Datenbytes 
    id_lenght = buffer and 4

    id0 = get_can_reg(msg_nummer * 16 + 2)				'Identifierbyte 0
    id1 = get_can_reg(msg_nummer * 16 + 3)				'Identifierbyte 1
    if (id_lenght = 4) then
      id2 = get_can_reg(msg_nummer * 16 + 4)				'Identifierbyte 2
      id3 = get_can_reg(msg_nummer * 16 + 5)				'Identifierbyte 3
    endif

  rem Daten lesen ; nur so viele wie notwendig
    for lauf = 1 to can_msg[9]
      can_msg[lauf] = get_can_reg((msg_nummer * 16) +lauf+6)
    next lauf

  REM New_Data_Bit rcksetzen,da wieder Daten empfangen werden knnen
    set_can_reg(msg_nummer * 16,0fdh) 
    set_can_reg(msg_nummer * 16 +1,85) 
    if (id_lenght = 4) then
      read_msg = (shift_right(id3,3)) or (shift_left(id2,5)) or (shift_left(id1,13))  or (shift_left(id0,21))       ' Rckgabewert Daten vorhanden = ID(29 Bit)
    else
      read_msg = (shift_right(id1,5)) or (shift_left(id0,3))        ' Rckgabewert Daten vorhanden = ID(11 Bit)
    endif
else
  read_msg = 0                                                  ' Rckgabewert Keine neuen Daten = 0
endif

endfunction



REM Sendet ein Datenpaket
REM Das zugehrige Message Objekt mu zuvor entsprechend
REM konfiguriert werden.
REM bergabeparameter: Nummer der MSG Objekts
REM Datenbytes und Anzahl der Datenbytes sind im Array can_msg abgelegt.
REM Nach dem Ende der Routine werden die Daten versendet, sobald
REM dies vom Bus her mglich ist.

sub Transmit(msg_num)
dim merker as integer
dim lauf as integer

  REM Daten bergeben 
  for lauf = 1 to can_msg[9]
    set_can_reg((msg_num * 10h)+lauf+6,can_msg[lauf]) 
  next lauf



  REM Anzahl der Datenbytes bergeben
  merker = get_can_reg((msg_num * 10h)+6)         'Wert des Registers auslesen
  merker = merker and 0fh                         ' DLC Bits manipulieren
  merker = merker or shift_left(can_msg[9],4)
  set_can_reg(msg_num *16 +6,merker)           ' Neuen Wert bergeben
  
  REM Control 1 Register (Zeigt an, da neue Daten versendet werden knnen) 
    set_can_reg(msg_num * 16 +1, 102)
ENDSUB


sub EN_Interrupt(msg_num)
  set_can_reg(msg_num * 16, 0ebh)
endsub



REM Diese Prozedur setzt ein Register
REM bergabeparameter : Registernummer (relativ zum Control Register)
REM                     Wert, der in das Register geschrieben werden soll


sub Set_CAN_reg(registernummer, wert)   
	  #IF PROZESSOR = T9 THEN						'Prozesse mit niedriger Prioritt und T9 Prozessor drfen nicht unterbrochen werden, wenn ein Zugriff auf ein ADwinPro-Module erfolgt
	    #IF PRIORITAET = LOW
	      BEGIN_CRITICAL_SECTION
	    #ENDIF
	  #ENDIF
  poke(enadrwr,registernummer) 
  poke(rdcan,wert) 
	  #IF PROZESSOR = T9 THEN
	    #IF PRIORITAET = LOW
	      END_CRITICAL_SECTION
	    #ENDIF
	  #ENDIF
endsub



REM Diese Funktion liest ein Register aus
REM bergabeparameter : Nummer des Registers (relativ zum Control Register)
REM Rckgabeparameter : Inhalt des Registers

Function Get_CAN_Reg(registernummer) as integer
	  #IF PROZESSOR = T9 THEN						'Prozesse mit niedriger Prioritt und T9 Prozessor drfen nicht unterbrochen werden, wenn ein Zugriff auf ein ADwinPro-Module erfolgt
	    #IF PRIORITAET = LOW
	      BEGIN_CRITICAL_SECTION
	    #ENDIF
	  #ENDIF
  poke(enadrrd, registernummer) 
#IF PROZESSOR = T5 THEN
  test =1*1*1*1
  wait(10)
#ELSE
  #IF PROZESSOR = T9 THEN
    sleep(6)
  #ELSE 
    test = SHIFT_LEFT(1,8)
  #ENDIF
#ENDIF
 get_can_reg = peek(rdcan)
	  #IF PROZESSOR = T9 THEN
	    #IF PRIORITAET = LOW
	      END_CRITICAL_SECTION
	    #ENDIF
	  #ENDIF
endfunction