'<TiCoBasic Header, Headerversion 001.001>
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'##############################################################################
'#                        DIO32Tico.inc                                       #
'#              INCLUDE-file for DIO 32 with Tico                             #
'##############################################################################
'#                                                                            #
'#                                                                            #
'#  08.06.2006  mf   creation                                                 #
'#  11.05.2007  mf   digin_fifo                                               #
'#  15.06.2007  JK   Digin_Edge()                                             #
'#  27.06.2007  MF   Digin_Edge()                                             #
'#  14.08.2007  AP   Digin_FIFO_Read_Timer()                                  #
'#  19.09.2007  TN   Event_Enable, Event_Config                               #
'#  06.12.2007  MF   Trigger Event                                            #
'#  31.01.2008  MF   Digprog neue ADR                                         #
'#  01.02.2008  MF   #if adwin_system=ADwin_ProII                             #
'#  07.02.2008  MF   Digout_set, Digout_Reset,Digout_Bits                     #
'#  12.08.2008  MF   Dgout_FiFo                                              #
'#  15.01.2009  MF   Digout                                                   #
'#  17.03.2009  MF   '''+                                                     #
'#  04.11.2009  MF   removed Digin_FIFO_Filter                                #
'#  22.12.2009  MF   DigProg_Set/GET_IO_Level Beta                            #
'#  08.01.2010  MF   Digin_FiFo_Full compatible Dio.TiCo-2                    #
'#                                                                            #
'#                                                                            #
'# Attention:                                                                 #
'#   - Do not copy the first source line (containing                          #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                             #
'#     Otherwise the Syntax color may be not correct.                         #
'#   - This includefile requires ADbasic 5 or higher!                         #
'#                                                                            #
'##############################################################################

#if adwin_system=ADwin_ProII
#else
#error("This include file can only be used with the ADwin ProII")  
#endif


'---------------------------------------------------------------
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'---------------------------------------------------------------
Sub Sub_Begin_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  Begin_Critical_Section
#EndIf
EndSub

Sub Sub_End_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  End_Critical_Section
#EndIf
EndSub


'******************************************************************************
''' switches a LED on or off
''' value: 
'''+  0 off
'''+  1 on
'''****************************************************************************
SUB Set_LED(value)
  out 80804000H, value
ENDSUB

'******************************************************************************
'''  checks the LED
'''****************************************************************************
FUNCTION Check_LED() AS Long
  Check_LED=in(80804000h)
ENDFUNCTION

'******************************************************************************
''' Initialisation of a digital I/O module (channel 0-31)
'''  value: each bit corresponds to 8 channel
'''+     0 = input
'''+     1 = output
'''****************************************************************************
SUB DigProg(value)
  out 4100H, value
ENDSUB

'******************************************************************************
''' Sets the digital outputs (channel 0 - 31)
''' value: each bit corresponds to a channel
'''****************************************************************************
SUB Digout_Long(value)
  out 0, value
ENDSUB

'******************************************************************************
''' read back of the output value of the digital
''' outputs (channel 0 - 31))
'''****************************************************************************
FUNCTION Get_Digout_Long() AS Long
  Get_Digout_Long=in(0)
ENDFUNCTION

'******************************************************************************
''' Reads the digital inputs (channel 0 - 31)
'''****************************************************************************
FUNCTION Digin_Long() AS Long
  Digin_Long=in(100H)
ENDFUNCTION


'******************************************************************************
''' Sets and resets selected digital outputs
''' set: Bitstring indicating the outputs which should be set
''' clear: Bitstring indicating the outputs which should be reset
'''****************************************************************************
SUB Digout_Bits(set,clear)
  out(20H,set)
  out(21H,clear)
ENDSUB

******************************************************************************
''' Sets selected digital outputs
''' set: Bitstring indicating the outputs which should be set
'''***************************************************************************
SUB Digout_Set(set)
  out(20H,set)
ENDSUB

******************************************************************************
''' Resets selected digital outputs
''' clear: Bitstring indicating the outputs which should be reset
'''***************************************************************************
SUB Digout_Reset(clear)
  out(21H,clear)
ENDSUB


'******************************************************************************
''' Sets or resets one channel of a digital output
''' channel: Number of the output to be set  (0..31)
''' value:
'''+     0 = reset channel
'''+     1 = set channel
'''****************************************************************************
SUB Digout(channel,value)
  out((0021h-(value)),(shift_left(1,(channel))))
ENDSUB



'******************************************************************************
''' Clear Digin Fifo
'''****************************************************************************
SUB Digin_FIFO_Clear()
  out(80804880h, 0) 'FIFO clear
ENDSUB

'******************************************************************************
''' Clear Digout Fifo
'''****************************************************************************
SUB Digout_FIFO_Clear()
  out(80804880h, 0) 'FIFO clear
ENDSUB




'******************************************************************************
''' Enable Digin Fifo
''' pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digin_FIFO_Enable(pattern)
  out(80804890h, pattern) 'FIFO clear
ENDSUB


'******************************************************************************
''' determines, which input channels the edge detection unit will monitor
''' pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digout_FIFO_Enable(pattern)
  out(80804890h, pattern) 'FIFO clear
ENDSUB

'******************************************************************************
'''returns the number of saved value pairs in the FIFO of the edge detection unit.
'''****************************************************************************
FUNCTION Digin_FIFO_Full() as Long
  Digin_FIFO_Full=in(80804880h) AND 0FFFFH
ENDFUNCTION

'******************************************************************************
'''returns the number of free value pairs in the edge output FIFO.
'''****************************************************************************
FUNCTION Digout_FIFO_Empty() as Long
  Digout_FIFO_Empty=in(80804882h)
ENDFUNCTION

'******************************************************************************
'''sets the FIFO operation mode: input with edge detection or edge output
'''value:
'''+    0 Use FiFo as Input (default)
'''+    1 Use FiFo as Output absolute
'''+    2 reserved 
'''+    3 Use FiFo as Output relativ
'''+     Mode 1 available from Version 
'''+     DIO TiCo >=E0.3 or DIO TiCo-100 >=E0.1
'''****************************************************************************
SUB Dig_FIFO_Mode(value)
  out(80804870h, value) 
ENDSUB


'******************************************************************************
''' start output pattern
'''****************************************************************************
SUB Digout_FIFO_Start()
  out(4860h, 1)
ENDSUB


'******************************************************************************
'''reads one value pair from the FIFO of the edge detection unit and writes them into 2 variables.
'''value_by_ref: Variable where the level status bit pattern is written
'''+Each level status bit corresponds to a digital input (see table below).
'''timestamp_by_ref: Variable where the time stamp is written.
'''****************************************************************************
SUB Digin_FIFO_Read(value_by_ref,timestamp_by_ref)
  SUB_BEGIN_CRITICAL_SECTION
  value_by_ref=in(310H)
  timestamp_by_ref=in(310H)
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
''' writes value pairs into the output edge FIFO.
''' value:Variable where the level status bit pattern is written
''' timestamp:Variable where the time stamp is written
'''****************************************************************************
SUB Digout_FIFO_Write(value,timestamp)
  SUB_BEGIN_CRITICAL_SECTION
  out(310H,value)
  out(310H,timestamp)
  
  SUB_END_CRITICAL_SECTION
ENDSUB


'''******************************************************************************
'''Reads 100 MHz FIFO Timer
'''+ This timer runs synchronous to the 50 MHz TiCo Timer.
'''+ In difference to the TiCo timer, this timer will not be set to 0 while core reset.
'''******************************************************************************
FUNCTION Digin_FIFO_Read_Timer() AS LONG
  Digin_FIFO_Read_Timer = IN(0311H)
ENDFUNCTION

'******************************************************************************
'''Reads 100 MHz FIFO Timer
'''+
'''+ This timer runs synchronous to the 50 MHz TiCo Timer.
'''+ In difference to the TiCo timer, this timer will not be set to 0 while core reset.
'''*****************************************************************************
FUNCTION Digout_FIFO_Read_Timer() AS LONG
  Digout_FIFO_Read_Timer = IN(0311H)
ENDFUNCTION


'
''******************************************************************************
'''' Input Filter ON/OFF
'''' value: 
''''+      0 off (default) 
''''+      1 on
''''****************************************************************************
'SUB Digin_FIFO_Filter(value)
'  out (80804875h,value)
'ENDSUB



'******************************************************************************
''' Reads one of the Latch Registers, which detect, if rising / falling edges
'''+ occured on the digital inputs (channel 0 - 31)
'''+ (These registers are cleared on reading)
'''edge:
'''+     0 latch register for the falling edges
'''+     1 latch register for the rising edges
'''****************************************************************************
FUNCTION Digin_Edge(edge) AS Long
  if (edge = 1) then
    Digin_Edge=in(300H) ' read lath register for rising edges
  else
    Digin_Edge=in(301H) '  ...  for falling edges
  endif
ENDFUNCTION



'*******************************************************************************
'''  activates or deactivates the external Event input
'''  value:
'''+     0 deactivate
'''+     1 activate
'''*****************************************************************************
SUB Event_Enable(value)
  DIM old AS Long

  old=in(80804800h)
  old =(old AND 0FFFFFFFEH) or value
  out (80804800h, old)
ENDSUB

'*******************************************************************************
'''  config the external Event input
'''  min_hold:
'''+     0=15 ns (default) 
'''+     1 =50 ns
'''  edge:
'''+      1 rising edge (default)
'''+      2 falling edge
'''+      3 rising & falling edge
'''       prescale : 1 to 255
'''****************************************************************************
SUB Event_Config(min_hold,edge,prescale)
  DIM old AS Long
  DIM neu AS Long
  DIM value AS Long

  old=in(80804800h)

  neu=shift_left((min_hold AND 1),4) or shift_left((edge AND 3),2)
  old =(old AND 0FFFFFFE3H) or neu
  out (80804800h, old)
  value=prescale AND 0FFH
  out (80804810h,value)
ENDSUB

'*******************************************************************************
''' creat an event for the master cpu
'''*****************************************************************************
SUB Trigger_Event()
  out (108041E0h, 1)
ENDSUB

'******************************************************************************
''' Get Initialisation of a digital I/O module
'''+return: 0...255 
''' group:
'''+     0=channel (1...8)
'''+     1=channel (9....16)
'''+     2=channel (17...24)
'''+     3=channel (25...32)
'''****************************************************************************
FUNCTION DigProg_Get_IO_Level(group) as long
  
  '#if prozessor=tico2
  
  dim bit,poti,i as long
  poti=0
  sub_begin_critical_section
             
  out (10801500h,77359400h) 'Poti ID
  nops(4)            
  for i=0 to 31
    if ((i=0) or (i=16)) then
      bit=in(10801502h) 'stack bit
      nops(20)
    endif
    bit=in(10801502h) '
    nops(20)
    poti=poti or (shift_left(bit and 1,31-i))
  next
    
  out (10801500h,0) 'Poti ID disable
  nops(8)
  sub_end_critical_section
  
  DIGPROG_GET_IO_LEVEL=255-(shift_right(poti,(group)*8) AND 0FFH)

ENDFUNCTION 


'******************************************************************************
''' Initialisation of a digital I/O module 
''' group:
'''+     0=channel (1...8)
'''+     1=channel (9....16)
'''+     2=channel (17...24)
'''+     3=channel (25...32)
''' level: 0...255
'''****************************************************************************
SUB DigProg_Set_IO_Level(group, level)
  dim bit,poti,i as long
  
  '#if prozessor=tico2
  poti=0
  sub_begin_critical_section
  out (10801500h,77359400h) 'Poti ID
  nops(4)                   
 
  for i=0 to 31
    if ((i=0) or (i=16)) then 'stack
      bit=in(10801502h) 'stackbit
      nops(20)
    endif
        
    bit=in(10801502h)
    nops(20)
    poti=poti or (shift_left(bit and 1,31-i))
  next
  
  poti= (poti AND not(shift_left(0FFH,(group)*8))) or shift_left(255-(level AND 0FFH),(group)*8)  
  for i=0 to 31
    if ((i=0) or (i=16)) then 'stack bit                   
      out (10801502h,0) ' 'Poti 2 Stack Bit
      nops(10)
    endif
    
    out (10801502h,shift_right(poti, 31-i) and 1) ' 'Poti out
    nops(10)
  next i
  
  out (10801500h,0) 'Poti ID disable            'Poti ID => Disable
  nops(8)
  sub_end_critical_section
  '#else
  
  '#endif
ENDSUB























