'<TiCoBasic Header, Headerversion 001.001>
' Foldings                       = 487,723,902
'<Header End>
'##############################################################################
'#                        FIELDBUS_TiCo.inc                                   #
'#              INCLUDE-file for PRO II PROFIBUS with Tico                    #
'##############################################################################
'#                                                                            #
'#                                                                            #
'#  26.02.2008  mf   creation                                                 #
'#  20.03.2008  ur   PROFIBUS                                                 #
'#  13.05.2008  mf   ABCC_Reset()                                             #
'#  26.03.2009  ur   DeviceNet                                                #
'#  10.08.2009  UR   Profibus/DeviceNet processarrayelement value             #
'#                   limit to 8bit                                            #
'#                                                                            #
'# Attention:                                                                 #
'#   - Do not copy the first source line (containing                          #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                             #
'#     Otherwise the Syntax color may be not correct.                         #
'#                                                                            #
'##############################################################################


#if adwin_system=ADwin_ProII
#else
#error("This include file can only be used with the ADwin ProII")
#endif

#define AB_TRUE 1
#define AB_FALSE 0
#define AB_UNDEF -1
#define AB_ADR_CR 3FFEh
#define AB_ADR_SR 3FFFh
#define AB_ADR_MOPDW 3800h    'Prozessdaten write area
#define AB_ADR_MOPDR 3900h    'Prozessdaten read area
#define AB_ADR_MOMDW 3B00h    'Message write area
#define AB_ADR_MOMDR 3D00h    'Message read area

#define AB_ADR_MSG_COMM_TYPE 1
#define AB_ADR_MSG_RESP_TYPE 2

'Control register bitmasks.
#define AB_CTRL_T_BIT    80h
#define AB_CTRL_M_BIT    40h
#define AB_CTRL_R_BIT    20h
#define AB_CTRL_AUX_BIT  10h

'Status register bitmasks.
#define AB_STAT_T_BIT    80h
#define AB_STAT_M_BIT    40h
#define AB_STAT_R_BIT    20h
#define AB_STAT_AUX_BIT  10h
#define AB_STAT_SUP_BIT  08h
#define AB_STAT_S_BITS   07h

'Anybus state
#define AB_STAT_SETUP    0
#define AB_STAT_NW_INIT  1
#define AB_STAT_WAIT_PROCESS  2
#define AB_STAT_IDLE     3
#define AB_STAT_PROCESS_ACTIVE 4
#define AB_STAT_ERROR    5
#define AB_STAT_reserved 6
#define AB_STAT_EXCEPTION 7

'Message header bitmasks.
#define AB_MSG_HEAD_C_BIT     40h
#define AB_MSG_HEAD_E_BIT     80h
#define AB_MSG_HEAD_CMD_BITS  3Fh

'HEAD_CMDTYPE
'E bit: 0->Message is a command or successful response
'       1->Message is an Error response
'C bit: 0->Message is a response
'       1->Message is a command

'Message commands.
#define AB_CMD_GET_ATTR          01h    '/* Get attribute                    */
#define AB_CMD_SET_ATTR          02h    '/* Set attribute                    */
#define AB_CMD_CREATE            03h    '/* Create                           */
#define AB_CMD_DELETE            04h    '/* Delete                           */
#define AB_CMD_RESET             05h    '/* Reset                            */
#define AB_CMD_GET_ENUM_STR      06h    '/* Get enumeration string           */
#define AB_CMD_GET_INDEXED_ATTR  07h    '/* Get indexed attribute            */
#define AB_CMD_SET_INDEXED_ATTR  08h    '/* Set indexed attribute            */
#define AB_CMD_MAP_ADI_WRITE_AREA 10h   '/* Map ADI write area               */
#define AB_CMD_MAP_ADI_READ_AREA 11h    '/* Map ADI read area                */

#define AB_BEF_ARR_LEN 200    'Die rx-daten liegen ab idx 1 bis max. 80
#define AB_B_START_IDX 100    'Befehle ab hier
#define AB_R_START_IDX 151    'Response ab hier

'Arbeitsvariablen
#define AB_L_R_BIT 81     'dim l_r_bit as long
#define AB_RX_HEAD_C 82   'dim RX_HEAD_C, RX_HEAD_E as long
#define AB_RX_HEAD_E 83
#define AB_P_TX 84        'dim p_tx as long
#define AB_KOMM_OK 85     'dim komm_ok as long
#define AB_ERROR 86       'dim ERROR as long
#define AB_F_SEND_RESP 87 'dim f_send_resp, f_send_comm as long
#define AB_F_SEND_COMM 88
#define AB_LASTSENDMSGTYPE 89 'dim LastSendMsgType as long
#define AB_STATE_RESPONSE 90  'dim STATE_RESPONSE as long
#define AB_KOMM_STATE 91      'dim KOMM_STATE as long
#define AB_L_SR_T 92       'dim l_sr_t, l_sr_t_alt as long
#define AB_L_SR_T_ALT 93


'******************************************************************************
' switches a LED on or off
' WERT : 0/1 off/on
'******************************************************************************
SUB Set_LED(value)
  out (80804000H, value)
ENDSUB


'******************************************************************************
'  checks the LED
'  Achtung geht noch nicht! Warum ?
'****************************************************************************
FUNCTION Check_LED() AS LONG
  Check_LED=in(80804000h)
ENDFUNCTION



'*******************************************************************************
'  activates or deactivates the external Event input
'  value: 0/1 deactivate/activate
'*******************************************************************************
SUB Event_Enable(value) ''<HIDE>
  DIM old AS Long

  old=in(80804800h)
  old =(old AND 0FFFFFFFEH) or value
  out (80804800h, old)
ENDSUB

'*******************************************************************************
'  config the external Event input
'  min_hold 0/1  0=15 ns (default) 1 =50 ns
'  edge: 1 rising edge (default)
'                        2 falling edge
'        3 rising & falling edge
'  prescale : 1 to 255
'*******************************************************************************
SUB Event_Config(min_hold, edge, prescale) ''<HIDE>
  DIM old AS Long
  DIM neu AS Long
  DIM value AS Long

  old=in(80804800h)

  neu=shift_left((min_hold AND 1), 4) or shift_left((edge AND 3), 2)
  old =(old AND 0FFFFFFE3H) or neu
  out (80804800h, old)
  value=prescale AND 0FFH
  out (80804810h, value)
ENDSUB

'*******************************************************************************
' creat an event for the ADwin-cpu
'*******************************************************************************
SUB Trigger_Event()
  out (108041E0h, 1)
ENDSUB


'---------------------------------------------------------------
' If a low-priority process accesses must not be
' interrupted by any other process !!!
'------------------------------------------------------------5700---
Sub Sub_Begin_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  Begin_Critical_Section
#EndIf
EndSub

Sub Sub_End_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  End_Critical_Section
#EndIf
EndSub



'#################################################################################

'-------------------Anybus
'---------------------------------------------------------------
' Getting a byte from the DPRAM of a profibus-DP master or slave
' byteno: number of the byte on the DPRAM
'---------------------------------------------------------------
Function Get_Pro_Byte(byteno) As Long
  dim in_data as long
  in_data=in (80000000h or byteno)
  Get_Pro_Byte=(in_data and 0FFh)
EndFunction

'---------------------------------------------------------------
' Setting a byte in the DPRAM of a profibus-DP master or slave
' byteno: number of the byte on the DPRAM
' value:  value for the selected byte
'---------------------------------------------------------------
Sub Set_Pro_Byte(byteno, value)
  out((80000000h or byteno), value and 0FFh)
EndSub

'---------------------------------------------------------------
' Hardware reset on the HMS Module
' module:  module address
'---------------------------------------------------------------
Sub ABCC_Reset() ''<HIDE>
  
  dim abretry as long
  dim state as long

  abretry=3

  do
    out(80004000h, 1)'reset active
    sleep(10000) ' =1ms
    out(80004000h, 0)'reset inactive
    sleep(15000000)  '1.5sec (in 10 nsec)
    set_pro_byte(3801H, 15)
    set_pro_byte(3802H, 0)
    
    state=get_pro_byte(3801h)
    dec abretry
  until ((state=15) or (abretry=0))
    
  set_pro_byte(3801H, 0)

EndSub

sub write_dat_to_abcc(arr[], arr_idx) ''<HIDE>
  dim i as long
  for i = 0 to arr[arr_idx]-1
    set_pro_byte(AB_ADR_MOMDW + i, arr[i + arr_idx + 1])   'skip 1. element
  next i
endsub

sub read_msg_header(msg_dat[], start_idx) ''<HIDE>
  dim i as long
  for i = 0 to 7
    msg_dat[i+start_idx] = get_pro_byte(AB_ADR_MOMDR + i)
  next i
endsub

sub read_msg_dat(msg_dat[], md_len, start_idx) ''<HIDE>
  dim i as long
  for i = 0 to md_len-1
    msg_dat[i+start_idx] = get_pro_byte(AB_ADR_MOMDR + i + 8)
  next i
endsub

sub write_proc_dat(proc_dat[], pd_len) ''<HIDE>
  dim i as long
  for i = 0 to pd_len-1
    set_pro_byte(AB_ADR_MOPDW + i, proc_dat[i+1])
  next i
endsub

sub read_proc_dat(proc_dat[], pd_len) ''<HIDE>
  dim i as long
  for i = 0 to pd_len-1
    proc_dat[i+1] = get_pro_byte(AB_ADR_MOPDR + i)
  next i
endsub

function get_CTRL() as long ''<HIDE>
  get_CTRL = get_pro_byte(AB_ADR_CR)
endfunction

sub set_CTRL(value) ''<HIDE>
  set_pro_byte(AB_ADR_CR, value)
endsub

function get_STAT() as long ''<HIDE>
  dim t1, t2 as long
  do
    t1 = get_pro_byte(AB_ADR_SR)
    t2 = get_pro_byte(AB_ADR_SR)
  until (t1 = t2)
  get_STAT = t1
endfunction

function get_STAT_T() as long ''<HIDE>
  get_STAT_T = (get_STAT() and AB_STAT_T_BIT)
endfunction

function get_STAT_M() as long ''<HIDE>
  get_STAT_M = (get_STAT() and AB_STAT_M_BIT)
endfunction

function get_STAT_R() as long ''<HIDE>
  get_STAT_R = (get_STAT() and AB_STAT_R_BIT)
endfunction

'***************************************************************
'''Reads and writes processdata from/to Profibus module
'''+return value: 
'''+         0-> Setup
'''+         2-> Wait
'''+         4-> Active
'''+     other-> Error (configuration correct?)
'''out_pd_arr[]: array with output data
'''out_pd_arr_len: number of output elements
'''in_pd_arr[]: array for input data
'''in_pd_arr_len: number of input elements
'''work_arr[]: array for kommunikation T11 <-> DeviceNet-Module 
'''+ the same as at Init function
'''***************************************************************
function Run_Profibus(out_pd_arr[], out_pd_arr_len, in_pd_arr[], in_pd_arr_len, work_arr[]) as long
  dim i, tmp, l_cr as long

  selectcase work_arr[AB_STATE_RESPONSE]
    case 0
      if (work_arr[AB_KOMM_OK] = AB_TRUE) then
        work_arr[AB_STATE_RESPONSE] = 1
      endif
    
    case 1
      if (work_arr[AB_RX_HEAD_C] = AB_TRUE) then
        work_arr[AB_RX_HEAD_C] = AB_UNDEF
        work_arr[AB_L_R_BIT] = AB_FALSE    'R-bit
        work_arr[AB_STATE_RESPONSE] = 2
        work_arr[AB_R_START_IDX] = 8       'len
        work_arr[AB_R_START_IDX+1] = 19    'Source ID
        work_arr[AB_R_START_IDX+2] = 1     'objekt
        work_arr[AB_R_START_IDX+3] = 1     'inst lsb
        work_arr[AB_R_START_IDX+4] = 0     'inst msb
        work_arr[AB_R_START_IDX+5] = AB_CMD_GET_ATTR or 80h    'err resp
        work_arr[AB_R_START_IDX+6] = 0     'Message data size
        work_arr[AB_R_START_IDX+7] = 1     'Cmd_ext lsb
        work_arr[AB_R_START_IDX+8] = 0     'Cmd_ext msb
      endif

    case 2
      'Auswerten der Anfrage
      if (work_arr[AB_F_SEND_RESP] = AB_FALSE) then
        work_arr[AB_R_START_IDX] = 8 + work_arr[6]     'resp-len
        for i = 1 to work_arr[AB_R_START_IDX]
          work_arr[AB_R_START_IDX + i] = work_arr[i]
        next i
        work_arr[AB_R_START_IDX + 5] = work_arr[AB_R_START_IDX + 5] and 3Fh  'Err resp
        work_arr[AB_R_START_IDX + 5] = work_arr[AB_R_START_IDX + 5] or 80h   'Err resp
        work_arr[AB_F_SEND_RESP] = AB_TRUE
        work_arr[AB_L_R_BIT] = AB_TRUE
        work_arr[AB_STATE_RESPONSE] = 1
      endif
   
  endselect  
      
  selectcase work_arr[AB_KOMM_STATE]
    case 1

    case 2     'send telegramm with message
      l_cr = get_CTRL()
      l_cr = l_cr or AB_CTRL_M_BIT
      if (work_arr[AB_L_R_BIT] = AB_TRUE) then
        l_cr = l_cr or AB_CTRL_R_BIT          'req to ADWIN
      else
        l_cr = l_cr or (not(AB_CTRL_R_BIT))   'no req to ADWIN 
      endif
      l_cr = l_cr xor AB_CTRL_T_BIT
      write_dat_to_abcc(work_arr, work_arr[AB_P_TX])
      set_CTRL(l_cr)
      work_arr[AB_KOMM_STATE] = 4
    
    case 3     'send telegramm without message
      l_cr = get_CTRL()
      l_cr = l_cr and (not(AB_CTRL_M_BIT))
      if (work_arr[AB_L_R_BIT] = AB_TRUE) then
        l_cr = l_cr or AB_CTRL_R_BIT
      else
        l_cr = l_cr or (not(AB_CTRL_R_BIT))
      endif
      l_cr = l_cr xor AB_CTRL_T_BIT
      write_proc_dat(out_pd_arr, out_pd_arr_len)
      set_CTRL(l_cr)
      work_arr[AB_KOMM_STATE] = 4

    case 4     'wait for response
      work_arr[AB_L_SR_T] = get_stat_t()
      if (work_arr[AB_L_SR_T] <> work_arr[AB_L_SR_T_ALT]) then
        work_arr[AB_L_SR_T_ALT] = work_arr[AB_L_SR_T]
        work_arr[AB_KOMM_STATE] = 5
      endif
    
    case 5    'read response
      tmp = get_stat_m()
      if (tmp = AB_STAT_M_BIT) then
        'new Data
        read_msg_header(work_arr, 1)     'header 8 elements
        read_msg_dat(work_arr, work_arr[6], 9)
        if ((work_arr[5] and AB_MSG_HEAD_C_BIT) = AB_MSG_HEAD_C_BIT) then    'command
          work_arr[AB_RX_HEAD_C] = AB_TRUE
        else                          'response
          work_arr[AB_RX_HEAD_C] = AB_FALSE
        endif
        if ((work_arr[5] and AB_MSG_HEAD_E_BIT) = AB_MSG_HEAD_E_BIT) then    'error resp
          work_arr[AB_RX_HEAD_E] = AB_TRUE
        else                          'command or successful resp
          work_arr[AB_RX_HEAD_E] = AB_FALSE
        endif
      endif
      read_proc_dat(in_pd_arr, in_pd_arr_len)               'read processdata
      work_arr[AB_KOMM_STATE] = 6

    case 6   'idle
      work_arr[AB_KOMM_STATE] = 3       'send telegramm without message
      if (get_stat_r() = AB_STAT_R_BIT) then    'ABCC accept more commands
        if (work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_COMM_TYPE) then
          if (work_arr[AB_F_SEND_RESP] = AB_TRUE) then
            'send response
            work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
            work_arr[AB_P_TX] = AB_R_START_IDX     'next response
            work_arr[AB_F_SEND_RESP] = AB_FALSE
            work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_RESP_TYPE
          else
            if (work_arr[AB_F_SEND_COMM] = AB_TRUE) then
              'send command
              work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
              work_arr[AB_P_TX] = AB_B_START_IDX    'next command
              work_arr[AB_F_SEND_COMM] = AB_FALSE
              work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_COMM_TYPE
            endif
          endif
        else
          if (work_arr[AB_F_SEND_COMM] = AB_TRUE) then
            'send command
            work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
            work_arr[AB_P_TX] = AB_B_START_IDX    'next command
            work_arr[AB_F_SEND_COMM] = AB_FALSE
            work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_COMM_TYPE
          else
            if (work_arr[AB_F_SEND_RESP] = AB_TRUE) then
              'send response
              work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
              work_arr[AB_P_TX] = AB_R_START_IDX    'next response
              work_arr[AB_F_SEND_RESP] = AB_FALSE
              work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_RESP_TYPE
            endif          
          endif
        endif
      else                  'ABCC is not ready to accept more commands
        if (work_arr[AB_F_SEND_RESP] = AB_TRUE) then
          'send response
          work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
          work_arr[AB_P_TX] = AB_R_START_IDX    'next response
          work_arr[AB_F_SEND_RESP] = AB_FALSE
          work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_RESP_TYPE
        endif
      endif
      work_arr[AB_KOMM_OK] = AB_TRUE
  endselect
  Run_Profibus = get_stat()

endfunction

'***************************************************************
'''Initialize communication at Profibus module
'''+return value: 
'''+         0-> OK
'''+     other-> Error
'''dev_adr: node ID
'''in_mod_cnt: number of input elements
'''in_mod_type: input datatype
'''+         1-> 1 Byte
'''+         2-> 2 Byte
'''+         3-> 4 Byte
'''+        16-> 8 Byte
'''out_mod_cnt: number of output elements
'''out_mod_type: output datatype
'''+         1-> 1 Byte
'''+         2-> 2 Byte
'''+         3-> 4 Byte
'''+        16-> 8 Byte
'''work_arr[]: array for kommunikation T11 <-> DeviceNet-Module
'''+  min size 200 elements
'''info[]: info array for bustype
'''+  min size 10 elements
'''+ these returnvalues are correct:
'''+         [1]-> 1
'''+         [2]-> 4
'''***************************************************************
function Init_Profibus(dev_adr, in_mod_cnt, in_mod_type, out_mod_cnt, out_mod_type, work_arr[], info[]) as long
  dim init_fertig as long
  dim ret as long
  dim STATE_BEFEHLE as long
  dim i, tmp as long
  
  dim l_in_pd_arr[76] as long
  dim l_out_pd_arr[76] as long
  
  ABCC_Reset()

  for i = 1 to AB_BEF_ARR_LEN
    work_arr[i] = 0
  next i

  ret = AB_FALSE
  init_fertig = AB_FALSE
  work_arr[AB_ERROR] = 0
  'check Profibusmodul
  for i=0 to 0FFh
    set_pro_byte(AB_ADR_MOPDW + i, i + 1)    'Processdata write area
    set_pro_byte(AB_ADR_MOPDR + i, i + 2)    'Processdata read area
    set_pro_byte(AB_ADR_MOMDW + i, i + 3)    'Message write area
    set_pro_byte(AB_ADR_MOMDR + i, i + 4)    'Message read area
  next i
  for i = 0 to 0FFh
    tmp = get_pro_byte(AB_ADR_MOPDW + i)
    if (tmp <> (i+1)and 0FFh) then work_arr[AB_ERROR] = 1
    tmp = get_pro_byte(AB_ADR_MOPDR + i)
    if (tmp <> (i+2)and 0FFh) then work_arr[AB_ERROR] = 2
    tmp = get_pro_byte(AB_ADR_MOMDW + i)
    if (tmp <> (i+3)and 0FFh) then work_arr[AB_ERROR] = 3
    tmp = get_pro_byte(AB_ADR_MOMDR + i)
    if (tmp <> (i+4)and 0FFh) then work_arr[AB_ERROR] = 4
  next i
  work_arr[AB_KOMM_STATE] = 3
  work_arr[AB_L_SR_T] = get_STAT_T()
  work_arr[AB_L_SR_T_ALT] = work_arr[AB_L_SR_T]
  STATE_BEFEHLE = 0
  work_arr[AB_P_TX] = AB_B_START_IDX
  work_arr[AB_STATE_RESPONSE] = 0
  work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_RESP_TYPE
  work_arr[AB_F_SEND_RESP] = AB_FALSE
  work_arr[AB_F_SEND_COMM] = AB_FALSE
  work_arr[AB_RX_HEAD_C] = AB_UNDEF
  work_arr[AB_RX_HEAD_E] = AB_UNDEF
  work_arr[AB_L_R_BIT] = AB_TRUE
  work_arr[AB_KOMM_OK] = AB_FALSE

  do
    selectcase STATE_BEFEHLE
      case 0
        if (work_arr[AB_KOMM_OK] = AB_TRUE) then
          STATE_BEFEHLE = 1
        endif
    
      case 1
        'data_type
        '0: bool 8bit
        '1: sint 8bit
        '2: sint 16bit
        '3: sint 32bit
        '4: uint 8bit
        '5: uint 16bit
        '6: uint 32
        '7: uint char 8bit
        '8: enum 8bit
        '16: sint 64bit
        '17: uint 64nit
        '18 float 32bit
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          'B_IDX_MAP_ADI_READ_AREA
          work_arr[AB_B_START_IDX] = 12        'len
          work_arr[AB_B_START_IDX + 1] = 1     'Source ID
          work_arr[AB_B_START_IDX + 2] = 3     'objekt
          work_arr[AB_B_START_IDX + 3] = 1     'inst lsb
          work_arr[AB_B_START_IDX + 4] = 0     'inst msb
          work_arr[AB_B_START_IDX + 5] = AB_CMD_MAP_ADI_READ_AREA or 40h    'command
          work_arr[AB_B_START_IDX + 6] = 4     'Message data size
          work_arr[AB_B_START_IDX + 7] = 3     'Cmd_ext lsb
          work_arr[AB_B_START_IDX + 8] = 0     'Cmd_ext msb
          work_arr[AB_B_START_IDX + 9] = IN_MOD_TYPE  '1.data  data_type
          work_arr[AB_B_START_IDX + 10] = IN_MOD_CNT  '2.number of elements
          work_arr[AB_B_START_IDX + 11] = 1    '3.      order no low byte
          work_arr[AB_B_START_IDX + 12] = 0    '4.      order no high byte
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 2
        endif
    
      case 2
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            STATE_BEFEHLE = 3
          else
            work_arr[AB_ERROR] = 5
          endif
        endif

      case 3
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          'B_IDX_MAP_ADI_WRITE_AREA
          work_arr[AB_B_START_IDX] = 12
          work_arr[AB_B_START_IDX + 1] = 3
          work_arr[AB_B_START_IDX + 2] = 3
          work_arr[AB_B_START_IDX + 3] = 1
          work_arr[AB_B_START_IDX + 4] = 0
          work_arr[AB_B_START_IDX + 5] = AB_CMD_MAP_ADI_WRITE_AREA or 40h
          work_arr[AB_B_START_IDX + 6] = 4
          work_arr[AB_B_START_IDX + 7] = 3
          work_arr[AB_B_START_IDX + 8] = 0
          work_arr[AB_B_START_IDX + 9] = OUT_MOD_TYPE
          work_arr[AB_B_START_IDX + 10] = OUT_MOD_CNT
          work_arr[AB_B_START_IDX + 11] = 1
          work_arr[AB_B_START_IDX + 12] = 0
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 4
        endif

      case 4
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            STATE_BEFEHLE = 5
          else
            work_arr[AB_ERROR] = 6
          endif
        endif

      case 5
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          'B_SET_DEV_ADR
          work_arr[AB_B_START_IDX] = 9
          work_arr[AB_B_START_IDX + 1] = 5
          work_arr[AB_B_START_IDX + 2] = 4
          work_arr[AB_B_START_IDX + 3] = 1
          work_arr[AB_B_START_IDX + 4] = 0
          work_arr[AB_B_START_IDX + 5] = AB_CMD_SET_ATTR or 40h
          work_arr[AB_B_START_IDX + 6] = 1
          work_arr[AB_B_START_IDX + 7] = 5
          work_arr[AB_B_START_IDX + 8] = 0
          work_arr[AB_B_START_IDX + 9] = DEV_ADR
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 6
        endif

      case 6
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            STATE_BEFEHLE = 7
          else
            work_arr[AB_ERROR] = 7
          endif
        endif

      case 7
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          'REQ_READ_MODULE_TYPE
          work_arr[AB_B_START_IDX] = 8
          work_arr[AB_B_START_IDX + 1] = 11
          work_arr[AB_B_START_IDX + 2] = 1
          work_arr[AB_B_START_IDX + 3] = 1
          work_arr[AB_B_START_IDX + 4] = 0
          work_arr[AB_B_START_IDX + 5] = AB_CMD_GET_ATTR or 40h
          work_arr[AB_B_START_IDX + 6] = 0
          work_arr[AB_B_START_IDX + 7] = 1
          work_arr[AB_B_START_IDX + 8] = 0
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 8
        endif

      case 8
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            for i = 1 to 10
              info[i] = work_arr[i+8]
            next i
            STATE_BEFEHLE = 9
          else
            work_arr[AB_ERROR] = 8
          endif
        endif

      case 9
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          'B_SETUP_COMPLETE
          work_arr[AB_B_START_IDX] = 9
          work_arr[AB_B_START_IDX + 1] = 9
          work_arr[AB_B_START_IDX + 2] = 1
          work_arr[AB_B_START_IDX + 3] = 1
          work_arr[AB_B_START_IDX + 4] = 0
          work_arr[AB_B_START_IDX + 5] = AB_CMD_SET_ATTR or 40h
          work_arr[AB_B_START_IDX + 6] = 1
          work_arr[AB_B_START_IDX + 7] = 5
          work_arr[AB_B_START_IDX + 8] = 0
          work_arr[AB_B_START_IDX + 9] = 1
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 10
        endif

      case 10
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            STATE_BEFEHLE = 11
          else
            work_arr[AB_ERROR] = 9
          endif
        endif

      case 11
    
    endselect
    tmp = Run_Profibus(l_out_pd_arr, 76, l_in_pd_arr, 76, work_arr) and 7h
    if (tmp = 2) then init_fertig = AB_TRUE
    
  until ((init_fertig = AB_TRUE) or (work_arr[AB_ERROR] <> 0))
  Init_Profibus = work_arr[AB_ERROR]
endfunction

'***************************************************************
'''Reads and writes processdata from/to DeviceNet module
'''+return value: 
'''+         0-> Setup
'''+         2-> Wait
'''+         4-> Active
'''+     other-> Error (configuration correct?)
'''in_pd_arr[]: array for input data
'''in_pd_arr_len: number of input elements
'''out_pd_arr[]: array with output data
'''out_pd_arr_len: number of output elements
'''work_arr[]: array for kommunikation T11 <-> DeviceNet-Module 
'''+ the same as at Init function
'''***************************************************************
function Run_DeviceNet(in_pd_arr[], in_pd_arr_len, out_pd_arr[], out_pd_arr_len, work_arr[]) as long
  dim i, tmp, l_cr as long

  selectcase work_arr[AB_STATE_RESPONSE]
    case 0
      if (work_arr[AB_KOMM_OK] = AB_TRUE) then
        work_arr[AB_STATE_RESPONSE] = 1
      endif
    
    case 1
      if (work_arr[AB_RX_HEAD_C] = AB_TRUE) then
        work_arr[AB_RX_HEAD_C] = AB_UNDEF
        work_arr[AB_L_R_BIT] = AB_FALSE    'R-bit
        work_arr[AB_STATE_RESPONSE] = 2
        work_arr[AB_R_START_IDX] = 8       'len
        work_arr[AB_R_START_IDX+1] = 19    'Source ID
        work_arr[AB_R_START_IDX+2] = 1     'objekt
        work_arr[AB_R_START_IDX+3] = 1     'inst lsb
        work_arr[AB_R_START_IDX+4] = 0     'inst msb
        work_arr[AB_R_START_IDX+5] = AB_CMD_GET_ATTR or 80h    'err resp
        work_arr[AB_R_START_IDX+6] = 0     'Message data size
        work_arr[AB_R_START_IDX+7] = 1     'Cmd_ext lsb
        work_arr[AB_R_START_IDX+8] = 0     'Cmd_ext msb
      endif

    case 2
      'Auswerten der Anfrage
      if (work_arr[AB_F_SEND_RESP] = AB_FALSE) then
        work_arr[AB_R_START_IDX] = 8 + work_arr[6]     'resp-len
        for i = 1 to work_arr[AB_R_START_IDX]
          work_arr[AB_R_START_IDX + i] = work_arr[i]
        next i
        work_arr[AB_R_START_IDX + 5] = work_arr[AB_R_START_IDX + 5] and 3Fh  'Err resp
        work_arr[AB_R_START_IDX + 5] = work_arr[AB_R_START_IDX + 5] or 80h   'Err resp
        work_arr[AB_F_SEND_RESP] = AB_TRUE
        work_arr[AB_L_R_BIT] = AB_TRUE
        work_arr[AB_STATE_RESPONSE] = 1
      endif
   
  endselect  
      
  selectcase work_arr[AB_KOMM_STATE]
    case 1

    case 2     'send telegramm with message
      l_cr = get_CTRL()
      l_cr = l_cr or AB_CTRL_M_BIT
      if (work_arr[AB_L_R_BIT] = AB_TRUE) then
        l_cr = l_cr or AB_CTRL_R_BIT          'req to ADWIN
      else
        l_cr = l_cr or (not(AB_CTRL_R_BIT))   'no req to ADWIN 
      endif
      l_cr = l_cr xor AB_CTRL_T_BIT
      write_dat_to_abcc(work_arr, work_arr[AB_P_TX])
      set_CTRL(l_cr)
      work_arr[AB_KOMM_STATE] = 4
    
    case 3     'send telegramm without message
      l_cr = get_CTRL()
      l_cr = l_cr and (not(AB_CTRL_M_BIT))
      if (work_arr[AB_L_R_BIT] = AB_TRUE) then
        l_cr = l_cr or AB_CTRL_R_BIT
      else
        l_cr = l_cr or (not(AB_CTRL_R_BIT))
      endif
      l_cr = l_cr xor AB_CTRL_T_BIT
      write_proc_dat(out_pd_arr, out_pd_arr_len)
      set_CTRL(l_cr)
      work_arr[AB_KOMM_STATE] = 4

    case 4     'wait for response
      work_arr[AB_L_SR_T] = get_stat_t()
      if (work_arr[AB_L_SR_T] <> work_arr[AB_L_SR_T_ALT]) then
        work_arr[AB_L_SR_T_ALT] = work_arr[AB_L_SR_T]
        work_arr[AB_KOMM_STATE] = 5
      endif
    
    case 5    'read response
      tmp = get_stat_m()
      if (tmp = AB_STAT_M_BIT) then
        'new Data
        read_msg_header(work_arr, 1)     'header 8 elements
        read_msg_dat(work_arr, work_arr[6], 9)
        if ((work_arr[5] and AB_MSG_HEAD_C_BIT) = AB_MSG_HEAD_C_BIT) then    'command
          work_arr[AB_RX_HEAD_C] = AB_TRUE
        else                          'response
          work_arr[AB_RX_HEAD_C] = AB_FALSE
        endif
        if ((work_arr[5] and AB_MSG_HEAD_E_BIT) = AB_MSG_HEAD_E_BIT) then    'error resp
          work_arr[AB_RX_HEAD_E] = AB_TRUE
        else                          'command or successful resp
          work_arr[AB_RX_HEAD_E] = AB_FALSE
        endif
      endif
      read_proc_dat(in_pd_arr, in_pd_arr_len)               'read processdata
      work_arr[AB_KOMM_STATE] = 6

    case 6   'idle
      work_arr[AB_KOMM_STATE] = 3       'send telegramm without message
      if (get_stat_r() = AB_STAT_R_BIT) then    'ABCC accept more commands
        if (work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_COMM_TYPE) then
          if (work_arr[AB_F_SEND_RESP] = AB_TRUE) then
            'send response
            work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
            work_arr[AB_P_TX] = AB_R_START_IDX     'next response
            work_arr[AB_F_SEND_RESP] = AB_FALSE
            work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_RESP_TYPE
          else
            if (work_arr[AB_F_SEND_COMM] = AB_TRUE) then
              'send command
              work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
              work_arr[AB_P_TX] = AB_B_START_IDX    'next command
              work_arr[AB_F_SEND_COMM] = AB_FALSE
              work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_COMM_TYPE
            endif
          endif
        else
          if (work_arr[AB_F_SEND_COMM] = AB_TRUE) then
            'send command
            work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
            work_arr[AB_P_TX] = AB_B_START_IDX    'next command
            work_arr[AB_F_SEND_COMM] = AB_FALSE
            work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_COMM_TYPE
          else
            if (work_arr[AB_F_SEND_RESP] = AB_TRUE) then
              'send response
              work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
              work_arr[AB_P_TX] = AB_R_START_IDX    'next response
              work_arr[AB_F_SEND_RESP] = AB_FALSE
              work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_RESP_TYPE
            endif          
          endif
        endif
      else                  'ABCC is not ready to accept more commands
        if (work_arr[AB_F_SEND_RESP] = AB_TRUE) then
          'send response
          work_arr[AB_KOMM_STATE] =  2     'send telegramm with message
          work_arr[AB_P_TX] = AB_R_START_IDX    'next response
          work_arr[AB_F_SEND_RESP] = AB_FALSE
          work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_RESP_TYPE
        endif
      endif
      work_arr[AB_KOMM_OK] = AB_TRUE
  endselect
  Run_DeviceNet = get_stat()

endfunction

'***************************************************************
'''Initialize communication at DeviceNet module
'''+return value: 
'''+         0-> OK
'''+     other-> Error
'''dev_adr: node ID
'''baudrate: 
'''+         0-> 125kbit
'''+         1-> 250kbit
'''+         2-> 250kbit
'''+         3-> Autobaud
'''in_mod_cnt: number of input elements
'''in_mod_type: input datatype
'''+         1-> 1 Byte
'''+         2-> 2 Byte
'''+         3-> 4 Byte
'''+        16-> 8 Byte
'''out_mod_cnt: number of output elements
'''out_mod_type: output datatype
'''+         1-> 1 Byte
'''+         2-> 2 Byte
'''+         3-> 4 Byte
'''+        16-> 8 Byte
'''work_arr[]: array for kommunikation T11 <-> DeviceNet-Module
'''+  min size 200 elements
'''info[]: info array for bustype
'''+  min size 10 elements
'''+ these returnvalues are correct:
'''+         [1]-> 1
'''+         [2]-> 4
'''***************************************************************
function Init_DeviceNet(dev_adr, baudrate, in_mod_cnt, in_mod_type, out_mod_cnt, out_mod_type, work_arr[], info[]) as long
  dim init_fertig as long
  dim ret as long
  dim STATE_BEFEHLE as long
  dim i, tmp as long
  
  dim l_in_pd_arr[256] as long
  dim l_out_pd_arr[256] as long
  
  ABCC_Reset()

  for i = 1 to AB_BEF_ARR_LEN
    work_arr[i] = 0
  next i

  ret = AB_FALSE
  init_fertig = AB_FALSE
  work_arr[AB_ERROR] = 0
  'check DeviceNetmodul
  for i=0 to 0FFh
    set_pro_byte(AB_ADR_MOPDW + i, i + 1)    'Processdata write area
    set_pro_byte(AB_ADR_MOPDR + i, i + 2)    'Processdata read area
    set_pro_byte(AB_ADR_MOMDW + i, i + 3)    'Message write area
    set_pro_byte(AB_ADR_MOMDR + i, i + 4)    'Message read area
  next i
  for i = 0 to 0FFh
    tmp = get_pro_byte(AB_ADR_MOPDW + i)
    if (tmp <> (i+1)and 0FFh) then work_arr[AB_ERROR] = 1
    tmp = get_pro_byte(AB_ADR_MOPDR + i)
    if (tmp <> (i+2)and 0FFh) then work_arr[AB_ERROR] = 2
    tmp = get_pro_byte(AB_ADR_MOMDW + i)
    if (tmp <> (i+3)and 0FFh) then work_arr[AB_ERROR] = 3
    tmp = get_pro_byte(AB_ADR_MOMDR + i)
    if (tmp <> (i+4)and 0FFh) then work_arr[AB_ERROR] = 4
  next i
  work_arr[AB_KOMM_STATE] = 3
  work_arr[AB_L_SR_T] = get_STAT_T()
  work_arr[AB_L_SR_T_ALT] = work_arr[AB_L_SR_T]
  STATE_BEFEHLE = 0
  work_arr[AB_P_TX] = AB_B_START_IDX
  work_arr[AB_STATE_RESPONSE] = 0
  work_arr[AB_LASTSENDMSGTYPE] = AB_ADR_MSG_RESP_TYPE
  work_arr[AB_F_SEND_RESP] = AB_FALSE
  work_arr[AB_F_SEND_COMM] = AB_FALSE
  work_arr[AB_RX_HEAD_C] = AB_UNDEF
  work_arr[AB_RX_HEAD_E] = AB_UNDEF
  work_arr[AB_L_R_BIT] = AB_TRUE
  work_arr[AB_KOMM_OK] = AB_FALSE

  do
    selectcase STATE_BEFEHLE
      case 0
        if (work_arr[AB_KOMM_OK] = AB_TRUE) then
          STATE_BEFEHLE = 1
        endif
    
      case 1
        'data_type
        '0: bool 8bit
        '1: sint 8bit
        '2: sint 16bit
        '3: sint 32bit
        '4: uint 8bit
        '5: uint 16bit
        '6: uint 32
        '7: uint char 8bit
        '8: enum 8bit
        '16: sint 64bit
        '17: uint 64nit
        '18 float 32bit
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          'B_IDX_MAP_ADI_READ_AREA
          work_arr[AB_B_START_IDX] = 12        'len
          work_arr[AB_B_START_IDX + 1] = 1     'Source ID
          work_arr[AB_B_START_IDX + 2] = 3     'objekt
          work_arr[AB_B_START_IDX + 3] = 1     'inst lsb
          work_arr[AB_B_START_IDX + 4] = 0     'inst msb
          work_arr[AB_B_START_IDX + 5] = AB_CMD_MAP_ADI_READ_AREA or 40h    'command
          work_arr[AB_B_START_IDX + 6] = 4     'Message data size
          work_arr[AB_B_START_IDX + 7] = 3     'Cmd_ext lsb
          work_arr[AB_B_START_IDX + 8] = 0     'Cmd_ext msb
          work_arr[AB_B_START_IDX + 9] = IN_MOD_TYPE  '1.data  data_type
          work_arr[AB_B_START_IDX + 10] = IN_MOD_CNT  '2.number of elements
          work_arr[AB_B_START_IDX + 11] = 1    '3.      order no low byte
          work_arr[AB_B_START_IDX + 12] = 0    '4.      order no high byte
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 2
        endif
    
      case 2
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            STATE_BEFEHLE = 3
          else
            work_arr[AB_ERROR] = 5
          endif
        endif

      case 3
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          'B_IDX_MAP_ADI_WRITE_AREA
          work_arr[AB_B_START_IDX] = 12
          work_arr[AB_B_START_IDX + 1] = 3
          work_arr[AB_B_START_IDX + 2] = 3
          work_arr[AB_B_START_IDX + 3] = 1
          work_arr[AB_B_START_IDX + 4] = 0
          work_arr[AB_B_START_IDX + 5] = AB_CMD_MAP_ADI_WRITE_AREA or 40h
          work_arr[AB_B_START_IDX + 6] = 4
          work_arr[AB_B_START_IDX + 7] = 3
          work_arr[AB_B_START_IDX + 8] = 0
          work_arr[AB_B_START_IDX + 9] = OUT_MOD_TYPE
          work_arr[AB_B_START_IDX + 10] = OUT_MOD_CNT
          work_arr[AB_B_START_IDX + 11] = 1
          work_arr[AB_B_START_IDX + 12] = 0
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 4
        endif

      case 4
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            STATE_BEFEHLE = 5
          else
            work_arr[AB_ERROR] = 6
          endif
        endif

      case 5
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          ' Node ID (MacID)
          work_arr[AB_B_START_IDX] = 9
          work_arr[AB_B_START_IDX + 1] = 5
          work_arr[AB_B_START_IDX + 2] = 4
          work_arr[AB_B_START_IDX + 3] = 1
          work_arr[AB_B_START_IDX + 4] = 0
          work_arr[AB_B_START_IDX + 5] = AB_CMD_SET_ATTR or 40h
          work_arr[AB_B_START_IDX + 6] = 1
          work_arr[AB_B_START_IDX + 7] = 5
          work_arr[AB_B_START_IDX + 8] = 0
          work_arr[AB_B_START_IDX + 9] = DEV_ADR
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 6
        endif

      case 6
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            STATE_BEFEHLE = 7
          else
            work_arr[AB_ERROR] = 7
          endif
        endif

      case 7
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          ' Baud_Rate
          ' 0-> 125kbit
          ' 1-> 250kbit
          ' 2-> 500kbit
          ' 3-> Autobaud
          work_arr[AB_B_START_IDX] = 9
          work_arr[AB_B_START_IDX + 1] = 4  'Source ID
          work_arr[AB_B_START_IDX + 2] = 4  'objekt
          work_arr[AB_B_START_IDX + 3] = 2  'inst lsb
          work_arr[AB_B_START_IDX + 4] = 0  'inst msb
          work_arr[AB_B_START_IDX + 5] = AB_CMD_SET_ATTR or 40h  'command
          work_arr[AB_B_START_IDX + 6] = 1  'Message data size
          work_arr[AB_B_START_IDX + 7] = 5  'Cmd_ext lsb
          work_arr[AB_B_START_IDX + 8] = 0  'Cmd_ext msb
          work_arr[AB_B_START_IDX + 9] = baudrate  '1.data
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 8
        endif

      case 8
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            STATE_BEFEHLE = 9
          else
            work_arr[AB_ERROR] = 8
          endif
        endif

      case 9
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          'REQ_READ_MODULE_TYPE
          work_arr[AB_B_START_IDX] = 8
          work_arr[AB_B_START_IDX + 1] = 11
          work_arr[AB_B_START_IDX + 2] = 1
          work_arr[AB_B_START_IDX + 3] = 1
          work_arr[AB_B_START_IDX + 4] = 0
          work_arr[AB_B_START_IDX + 5] = AB_CMD_GET_ATTR or 40h
          work_arr[AB_B_START_IDX + 6] = 0
          work_arr[AB_B_START_IDX + 7] = 1
          work_arr[AB_B_START_IDX + 8] = 0
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 10
        endif

      case 10
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            for i = 1 to 10
              info[i] = work_arr[i + 8]
            next i
            STATE_BEFEHLE = 11
          else
            work_arr[AB_ERROR] = 9
          endif
        endif

      case 11
        if (work_arr[AB_F_SEND_COMM] = AB_FALSE) then
          'B_SETUP_COMPLETE
          work_arr[AB_B_START_IDX] = 9
          work_arr[AB_B_START_IDX + 1] = 9
          work_arr[AB_B_START_IDX + 2] = 1
          work_arr[AB_B_START_IDX + 3] = 1
          work_arr[AB_B_START_IDX + 4] = 0
          work_arr[AB_B_START_IDX + 5] = AB_CMD_SET_ATTR or 40h
          work_arr[AB_B_START_IDX + 6] = 1
          work_arr[AB_B_START_IDX + 7] = 5
          work_arr[AB_B_START_IDX + 8] = 0
          work_arr[AB_B_START_IDX + 9] = 1
          work_arr[AB_F_SEND_COMM] = AB_TRUE
          STATE_BEFEHLE = 12
        endif

      case 12
        if (work_arr[AB_RX_HEAD_C] = AB_FALSE) then
          work_arr[AB_RX_HEAD_C] = AB_UNDEF
          if (work_arr[AB_RX_HEAD_E] = AB_FALSE) then
            STATE_BEFEHLE = 13
          else
            work_arr[AB_ERROR] = 10
          endif
        endif

      case 13
    
    endselect
    tmp = Run_DeviceNet(l_in_pd_arr, 256, l_out_pd_arr, 256, work_arr) and 7h
    if (tmp = 2) then init_fertig = AB_TRUE
    
  until ((init_fertig = AB_TRUE) or (work_arr[AB_ERROR] <> 0))
  Init_DeviceNet = work_arr[AB_ERROR]
endfunction

