'<TiCoBasic Header, Headerversion 001.001>
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--ALL

'###############################################################
'#                           MATH_TiCo.inc                     #
'#   INCLUDE-file for all ADwin-Systems with TiCo processors   #
'###############################################################
'#                                                             #
'# Contents: Mathematical FUNCTIONs for TiCo processors        #
'#                                                             #
'#  02.02.2010  TN creation                                    #
'#  08.04.2010  JK comments added ;  released for ADwin-CD     #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#                                                             #
'###############################################################




'#####################################################################
'#                                                                   #
'#                            r = x Mod y                            #
'#                                                                   #
'#   The modulus determines the signed remainder of x divided by y   #
'#              for nonzero y, and returns x otherwise.              #
'# The function uses the definition of Wirth: the return value of    #
'# the division will be truncated. Therefore mod(-4,3) returns -1.   #
'#                                                                   #
'# The function Mod() expects LONGs as parameters                    #
'#                                                                   #
'# Known issues:     none                                            #
'#                                                                   #
'# updates :                                                         #
'# 08.04.2010 JK comments added ;  released for ADwin-CD             #
'#                                                                   #
'#####################################################################

'******************************************************************************
'''determines the signed remainder of x divided by y for nonzero y, and returns x otherwise. 
''' x_param: x
''' y_param: y
'''******************************************************************************
Function Mod(x_param,y_param) as Long  
  
  Dim y as Long   ' calculate always with y as a variable, not as a 
  y = y_param     '  constant to avoid that the compiler complains   
  '               '  the division by the (constant) null. (Compiler
  '               '  cannot detect division by (variable) null).

  Mod = x_param - ((x_param / y) * y_param)
  
EndFunction 
  
