#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string.h>

#include <libadwin_scilab.h>
#include <libadwin.h>

void sl_Boot(const char *filename)
{
    Boot(filename);
}

void sl_Clear_Process(int32_t *process_no)
{
    Clear_Process(*process_no);
}

void sl_Data_Length(int32_t *data_no, int32_t *value)
{
    *value = Data_Length(*data_no);
}

void sl_Data2File(const char *filename, int32_t *data_no, int32_t *start_index, int32_t *count, int32_t *mode)
{
    Data2File(filename, *data_no, *start_index, *count, *mode);
}

void sl_Fifo_Clear(int32_t *fifo_no)
{
    Fifo_Clear(*fifo_no);
}

void sl_Fifo_Empty(int32_t *fifo_no, int32_t *value)
{
    *value = Fifo_Empty(*fifo_no);
}

void sl_Fifo_Full(int32_t *fifo_no, int32_t* value)
{
    *value = Fifo_Full(*fifo_no);
}

void sl_Free_Mem(int32_t *mem_spec, int32_t *value)
{
    *value = Free_Mem(*mem_spec);
}

void sl_Get_FPar(int32_t *index, float* value)
{
    *value = Get_FPar(*index);
}

void sl_Get_FPar_All(float dest[])
{
    Get_FPar_All(dest);
}

void sl_Get_FPar_Block(float dest[], int32_t *start_index, int32_t *count)
{
    Get_FPar_Block(dest, *start_index, *count);
}

void sl_Get_Last_Error (int32_t *error_number)
{
    *error_number = Get_Last_Error();
}

void sl_Get_Last_Error_Text(int32_t *error_number, char *error_text)
{
    strncpy(error_text, Get_Last_Error_Text(*error_number), 255);
}

void sl_Get_Par(int32_t *index, int32_t *value)
{
    *value = Get_Par(*index);
}

void sl_Get_Par_All(int32_t dest[])
{
    Get_Par_All(dest);
}

void sl_Get_Par_Block(int32_t dest[], int32_t *start_index, int32_t *count)
{
    Get_Par_Block(dest, *start_index, *count);
}

void sl_Get_Processdelay(int32_t *process_no, int32_t *delay)
{
    *delay = Get_Processdelay(*process_no);
}

void sl_GetData_Float(int32_t *data_no, float dest[], int32_t *start_index, int32_t *count)
{
    GetData_Float(*data_no, dest, *start_index, *count);
}

void sl_GetData_Long(int32_t *data_no, int32_t dest[], int32_t *start_index, int32_t *count)
{
    GetData_Long(*data_no, dest, *start_index, *count);
}

void sl_GetData_String(int32_t *data_no, char dest[], int32_t *max_count)
{
    GetData_String(*data_no, dest, *max_count);
}

void sl_GetFifo_Float(int32_t *fifo_no, float dest[], int32_t *count)
{
    GetFifo_Float(*fifo_no, dest, *count);
}

void sl_GetFifo_Long(int32_t *fifo_no, int32_t dest[], int32_t *count)
{
    GetFifo_Long(*fifo_no, dest, *count);
}

void sl_Load_Process(const char *filename)
{
    Load_Process(filename);
}

void sl_Process_Status(int32_t *process_no, int32_t *status)
{
    *status = Process_Status(*process_no);
}

void sl_Processor_Type(int32_t *processor_type)
{
    *processor_type = Processor_Type();
}

void sl_Set_DeviceNo(int32_t *device_no)
{
    Set_DeviceNo(*device_no);
}

void sl_Set_FPar(int32_t *index, float *value)
{
    Set_FPar(*index, *value);
}

void sl_Set_Par(int32_t *index, int32_t *value)
{
    Set_Par(*index, *value);
}

void sl_Set_Processdelay(int32_t *process_no, int32_t *process_delay)
{
    Set_Processdelay(*process_no, *process_delay);
}

void sl_SetData_Float(int32_t *data_no, float src[], int32_t *start_index, int32_t *count)
{
    SetData_Float(*data_no, src, *start_index, *count);
}

void sl_SetData_Long(int32_t *data_no, int32_t src[], int32_t *start_index, int32_t *count)
{
    SetData_Long(*data_no, src, *start_index, *count);
}

void sl_SetData_String(int32_t *data_no, char data[])
{
    SetData_String(*data_no, data);
}

void sl_SetFifo_Float(int32_t *fifo_no, float src[], int32_t *count)
{
    SetFifo_Float(*fifo_no, src, *count);
}

void sl_SetFifo_Long(int32_t *fifo_no, int32_t src[], int32_t *count)
{
    SetFifo_Long(*fifo_no, src, *count);
}

void sl_Start_Process (int32_t *process_no)
{
    Start_Process(*process_no);
}

void sl_Stop_Process (int32_t *process_no)
{
    Stop_Process(*process_no);
}

void sl_String_Length(int32_t *data_no, int32_t *length)
{
    *length = String_Length(*data_no);
}

void sl_Test_Version(int32_t *value)
{
    *value = Test_Version();
}

void sl_Workload(int32_t *priority, int32_t *workload)
{
    *workload = Workload(*priority);
}

