
#ifndef __USB_H__
#define __USB_H__

#include <linux/adwin.h>

#ifdef __cplusplus
extern "C" {
#endif


int USB_Test_Version(adwin_dev_t *dev, int fd);

long USB_Boot(adwin_dev_t *dev, int fd, char *filename, long iboardsize);

int USB_Load_Process(adwin_dev_t *dev, int fd, char *filename);
int USB_Start_Process(adwin_dev_t *dev, int fd, int processID);
int USB_Stop_Process(adwin_dev_t *dev, int fd, int processID);
int USB_Clear_Process(adwin_dev_t *dev, int fd, int processID);
int USB_Process_Status(adwin_dev_t *dev, int fd, int processID);

int USB_Free_Mem(adwin_dev_t *dev, int fd, int Mem_Spec, int *dest);
int USB_Workload (adwin_dev_t *dev, int fd, int Priority, int32_t *dest);

int USB_Set_Globaldelay(adwin_dev_t *dev, int fd, long ProcessNo, long Globaldelay);
int USB_Get_Globaldelay(adwin_dev_t *dev, int fd, long ProcessNo, long *Globaldelay);

int USB_Set_Par(adwin_dev_t *dev, int fd, int Parameternr, int32_t value);
int USB_Set_FPar(adwin_dev_t *dev, int fd, int Parameternr, float value);

int USB_Get_Par(adwin_dev_t *dev, int fd, int Parameternr, int *value);

int USB_Get_FPar(adwin_dev_t *dev, int fd, int Parameternr, float *value);

int USB_Get_Par_All(adwin_dev_t *dev, int fd, int first, int cnt, int32_t *dest);
int USB_Get_FPar_All(adwin_dev_t *dev, int fd, int first, int cnt, float *dest);

int USB_GetData(adwin_dev_t *dev, int fd, int dataNo, long startindex, long count, void *dest);
int USB_SetData(adwin_dev_t *dev, int fd, int dataNo, long startindex, long count, void *src);

int USB_Data_Length(adwin_dev_t *dev, int fd, long DataNo);

int USB_Data2File(adwin_dev_t *dev, int fd, char *filename, int dataNo, long startindex, long count, int mode);


int USB_Fifo_Clear(adwin_dev_t *dev, int fd, int fifono);
int USB_Fifo_Empty(adwin_dev_t *dev, int fd, int fifono, int *dest);
int USB_Fifo_Full(adwin_dev_t *dev, int fd, int fifono, int *dest);

int USB_SetFifo(adwin_dev_t *dev, int fd, int fifono, long count, void *src);
int USB_GetFifo(adwin_dev_t *dev, int fd, int fifono, long count, void *dest);



// ***************************** unsupported *****************************

int USB_Get_Memory_dsp(adwin_dev_t *dev, int fd, long base_addr, long anzahl, long *dest);

int USB_Clear_Data(adwin_dev_t *dev, int fd, int Datanr);
int USB_GetDataType(adwin_dev_t *dev, int fd, int datanr);


#ifdef __cplusplus
}
#endif


#endif /* __USB_H__ */
