'<ADbasic Header, Headerversion 001.001>
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--Inc--PRO
'
'###############################################################
'#                        ADwinpro1.Inc                        #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Definition of functions and procedures            #
'#           to access A/D-modules.                            #
'#                                                             #
'#  01.02.2005  MF   created                                   #
'#  31.05.2005  MF   T11                                       #
'#  16.06.2005  MF   MAKE_LIB = OFF                            #
'#  07.07.2005  MF   Sleep->P1_Sleep                           #
'#  20.09.2005  MF   TC_Read_Voltage                           #
'#  24.01.2006  MF   WriteDAC32                                #
'#  11.04.2006  ur   syntax checked                            #
'#  24.04.2006  MF   TCJ_Dig_To_Temp                           #
'#  24.04.2006  MF   TCK_Dig_To_Temp                           #
'#  27.04.2006  MF   Digin_Long_F optimze                      #
'#  02.05.2006  MF   PT100_Dig_To_Temp                         #
'#  02.05.2006  MF   PT100_Dig_To_R                            #
'#  20.06.2006  MF   TC_Read_B                                 #
'#  17.10.2006  MF   LS-BUS                                    #
'#  11.10.2006  OL   En_Transmit compatible to T9 and T10      #
'#  30.11.2006  MF   bugfix PWM_Enable                         #
'#  16.03.2007  MF   designed for ADbasic 5                    #
'#  27.03.2007  GC   check for ADbasic 5                       #
'#  14.06.2007  OL   New sub: Read_Msg_Con                     #
'#  20.05.2008  MF   Digout                                    #
'#  16.07.2008  MF   removed test                              #
'#  18.02.2009  MF   Read_Msg_Con                              #
'#  19.02.2009  MF   Transmit_Status                           #
'#  17.03.2009  MF   '''+                                      #
'#  29.06.2009  MF   '''+ RS_INIT                              #
'#  06.04.2010  MF   CAN msg , channel ()                      #
'#  01.06.2010  MF   optimize CAN_Init                         #
'#                                                             #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This include file requires ADbasic 5 or higher!         #
'#                                                             #
'###############################################################

'---------------------------------------------------------------
' Base-address for the different types of Pro-modules.
'---------------------------------------------------------------
#If PROZESSOR = T11 Then
#Define DIO 000h      'DIO - MASK ''<HIDE>
#Define AD  040h      'A/D - MASK ''<HIDE>
#Define DA  080h      'D/A - MASK ''<HIDE>
#Define CPU 0A0h      'CPU - MASK ''<HIDE>
#Define EXT 0C0h      'EXT - MASK ''<HIDE>
'Profibus slave addresses (DPRAM)
'Handshake registers
#Define APP_IND       7FEh ''<HIDE>
#Define ANY_IND       7FFh ''<HIDE>
'Mailbox registers
#Define MAIL_IN_0     400h ''<HIDE>
#Define MAIL_IN_1     401h ''<HIDE>
#Define MAIL_IN_2     402h ''<HIDE>
#Define MAIL_IN_3     403h ''<HIDE>
#Define MAIL_IN_4     404h ''<HIDE>
#Define MAIL_IN_5     405h ''<HIDE>
#Define MAIL_IN_6     406h ''<HIDE>
#Define MAIL_IN_7     407h ''<HIDE>
#Define MAIL_IN_8     408h ''<HIDE>
#Define MAIL_IN_9     409h ''<HIDE>
#Define MAIL_IN_A     40Ah ''<HIDE>
#Define MAIL_IN_B     40Bh ''<HIDE>
#Define MAIL_IN_C     40Ch ''<HIDE>
#Define MAIL_IN_D     40Dh ''<HIDE>
#Define MAIL_IN_E     40Eh ''<HIDE>
#Define MAIL_IN_F     40Fh ''<HIDE>

#Define MAIL_OUT_0    520h ''<HIDE>
#Define MAIL_OUT_1    521h ''<HIDE>
#Define MAIL_OUT_2    522h ''<HIDE>
#Define MAIL_OUT_3    523h ''<HIDE>
#Define MAIL_OUT_4    524h ''<HIDE>
#Define MAIL_OUT_5    525h ''<HIDE>
#Define MAIL_OUT_6    526h ''<HIDE>
#Define MAIL_OUT_7    527h ''<HIDE>
#Define MAIL_OUT_8    528h ''<HIDE>
#Define MAIL_OUT_9    529h ''<HIDE>
#Define MAIL_OUT_A    52ah ''<HIDE>
#Define MAIL_OUT_B    52bh ''<HIDE>
#Define MAIL_OUT_C    52ch ''<HIDE>
#Define MAIL_OUT_D    52dh ''<HIDE>
#Define MAIL_OUT_E    52eh ''<HIDE>
#Define MAIL_OUT_F    52fh ''<HIDE>

#If MAKE_LIB = OFF Then
'Dim test As Long          ' variable for delay ''<HIDE>
'''The first 8 elements of the array contain the data bytes 1...8 and the 9th array element the amount of valid data bytes of the message. 
'''Here a value from 0 to 8 must be entered.
'''The data bytes use only the bits 7...0 in the array elements, bits 31...8 are ignored
Dim CAN_msg[9] As Long    ' array with 9 elements
Dim toggle_flag[5] As Long' Anybus togglebit ''<HIDE>
#EndIf

'---------------------------------------------------------------
' Address-table to access the hardware of the Pro-system, 
' depending on the CPU in use (ADSP or Transputer).
'---------------------------------------------------------------
#Define DL           20400000h ''<HIDE>
#Define DH           20400010h ''<HIDE>
#Define DLX          20400020h ''<HIDE>
#Define DHX          20400030h ''<HIDE>
#Define ADWR         20400060h ''<HIDE>
#Define ADRD         20400070h ''<HIDE>
#Define ADRDF        20400078h ''<HIDE>
#Define CPU_EVENT    204000F0h ''<HIDE>
#Define WATCHDOG     10000400h ''<HIDE>
#Define WD_TIMER     10000400h ''<HIDE>
#Define CPU_LED      10000100h ''<HIDE>
#Define D32          20400180h ''<HIDE>
#Define D32I         20400198h ''<HIDE>
#Define CPU_DIG_ADR  10000210h ''<HIDE>
#Define CPU_DIG_ADR1 10000220h ''<HIDE>
#Define SYNC_REG     10000100h ''<HIDE>


'---------------------------------------------------------------
' Procedure which adds NOP-instructions after a REG.-WRITE
' to compensate delaytimes.
'---------------------------------------------------------------
Sub Poke_NOP(address, value) ''<HIDE>
#If PROZESSOR = T11 Then
  Poke(address, value)
  Bus_Sleep(25)
#EndIf
EndSub

Sub Poke_NOP_RD(address, value) ''<HIDE>
#If PROZESSOR = T11 Then
  Poke(address, value)
#EndIf
EndSub


'---------------------------------------------------------------
' Procedure which adds one additional NOP-instruction only for
' the ADSP processor, because only neccessary there.
'---------------------------------------------------------------
Sub NOP_T9() ''<HIDE>

EndSub


'---------------------------------------------------------------
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'---------------------------------------------------------------
Sub Sub_Begin_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  Begin_Critical_Section
#EndIf
EndSub

Sub Sub_End_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  End_Critical_Section
#EndIf
EndSub


'---------------------------------------------------------------
' Waits for the settling time of the multiplexer.
' waits 14 s for AIN-8/16-RB, AIN-32/16-RB
' waits 3 s  for all other modules
' This Sub is only for T9 or T10 (= ADSP) processors.
'---------------------------------------------------------------
Sub ADC_Wait_MUX_T9(module) ''<HIDE>
  Dim addr As Long
  Dim modulecode As Long
  Dim time1, time2, time3 As Long

  addr = Peek(SYNC_REG)
  time1 = Read_Timer()
  addr = 069h Or (Shift_Left(module, 8))

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  modulecode = Peek(DLX) And 255
  Sub_End_Critical_Section

  If ((modulecode = 9) Or (modulecode = 11)) Then        'AIN 8/16 RB or AIN 32/16RB
    time3 = 4200                                         '14 s
  Else
    If ((modulecode = 21) Or (modulecode = 23)) Then     'AIN 8/14 or AIN 32/14
      time3 = 750                                        '2, 5 s
    Else
      If ((modulecode = 22) Or (modulecode = 24)) Then   'AIN 8/16 RC or AIN 32/16 RC
        time3 = 1650                                     '5, 5 s
      Else                                               'any other module
        time3 = 900                                      '3 s
      EndIf
    EndIf
  EndIf
  Do
    time2 = Read_Timer() - time1
  Until (time2>time3)
EndSub


'---------------------------------------------------------------
' Waits for the settling time of the multiplexer.
' This procedure is suitable for the ADC and the ADC16 function.
' (Rechecked by JK 22.11.2000 :  The waiting time caused by this
'  procedure is 2.7 microseconds (for T8 processor with 25MHz), 
'  which is also sufficient for Pro-AIn-8/16)
' For AIN-8/16-RB Or AIN-32/16-RB please use ADC_Wait_MUX_T9 .
'---------------------------------------------------------------
Sub ADC_Wait_MUX() ''<HIDE>
  P1_Sleep(300)
EndSub


'---------------------------------------------------------------
''' Samples, converts and reads out the digital ADC-value of an
'''+ analog input.
'''+ This function is suitable for all 12 bit modules and for the
'''+ following 16 bit modules :  AIN-8/16-RB, AIN-32/16-RB
'''+ result:   16 bit Long
'''+  Attention:                                                 
'''+  This instruction is not prepared to handle an access from  
'''+  a low and high priority process to the same module.        
''' module:   module address (0..255)
''' input_no: channel number of analog input
'''---------------------------------------------------------------
Function ADC(module, input_no) As Long
  Dim addr, addr1, adc_n, reminder As Long

  '............ set MUX ............
  addr = 050h Or (Shift_Left(module, 8))
  adc_n = input_no - 1
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, adc_n)
  Sub_End_Critical_Section

  '............ wait multiplexer settling time ........
  ADC_Wait_MUX_T9(module) ' wait 3 s or more, depending on hardware

  '............ start conversion ............
  addr = 054h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section
  Bus_Sleep(6)

  '............ wait EOC ............
  addr = 056h Or (Shift_Left(module, 8))
  addr1 = AD Or (Shift_Left(module, 8))
  Do
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr)
    reminder = (Peek(DLX) And 1)
    Sub_End_Critical_Section
  Until(reminder = 0)
  '............ read out result ............
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr1)
  ADC = Peek(DLX)
  Sub_End_Critical_Section
  Bus_Sleep(30)
EndFunction


'---------------------------------------------------------------
''' Samples, converts and reads out the digital 16 bit ADC-value
'''+ of an analog input.
'''+ For AIN-8/16-RB Or AIN-32/16-RB please use the function "ADC"
'''+result:   16 bit Long
'''+  Attention:                                                 
'''+  This instruction is not prepared to handle an access from  
'''+  a low and high priority process to the same module.        
'''  module:   module address (0..255)
'''  input_no: channel number of analog input 
'''-------------------------------------------------------------
Function ADC16(module, input_no) As Long
  Dim addr, addr1, adc_n, reminder As Long

  '------------- set MUX -------------
  addr = 050h Or (Shift_Left(module, 8))
  adc_n = input_no - 1
  Sub_Begin_Critical_Section
  Poke (ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, adc_n)
  Sub_End_Critical_Section

  '............ wait multiplexer settling time ........
  ADC_Wait_MUX

  '............ start conversion ............
  addr = 054h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section
  Bus_Sleep(6)

  '............ wait EOC ............
  addr = 056h Or (Shift_Left(module, 8))
  addr1 = AD Or (Shift_Left(module, 8))
  Do
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr)
    reminder = (Peek(DLX) And 1)
    Sub_End_Critical_Section
  Until(reminder = 0)
  Bus_Sleep(27)
  Bus_Sleep(27)
  Bus_Sleep(27)

  '............ start conversion again (serial ADC) ............
  addr = 054h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section

  Bus_Sleep(6)

  '............ wait EOC ............
  addr = 056h Or (Shift_Left(module, 8))
  addr1 = AD Or (Shift_Left(module, 8))
  Do
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr)
    reminder = (Peek(DLX) And 1)
    Sub_End_Critical_Section
  Until(reminder = 0)

  '............ read out result ............
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr1)
  ADC16 = Peek(DLX)
  Sub_End_Critical_Section
  Bus_Sleep(30)
EndFunction


'---------------------------------------------------------------
''' Set MUX to desired input channel.
'''+ (Gain is not on all modules available!)
''' module:  module address  (0..255)
''' pattern: bit 6 & 5 -> gain, bit 4...0 -> channel 1...32
'''-------------------------------------------------------------
Sub Set_Mux(module, pattern)
  Dim addr As Long

  addr = 050h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Start conversion of ADC.
''' module: module address  (0..255)
'''-------------------------------------------------------------
Sub Start_Conv(module)
  Dim addr As Long

  addr = 054h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Wait Until EOC-signal goes active (End Of Conversion).
''' module: module address  (0..255)
'''-------------------------------------------------------------
Sub Wait_EOC(module)
  Dim addr, reminder As Long

  addr = 056h Or (Shift_Left(module, 8))
  Bus_Sleep(6)
  Do
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr)
    reminder = Peek(DLX) And 1
    Sub_End_Critical_Section
  Until(reminder = 0)
  Bus_Sleep(35)
EndSub


'---------------------------------------------------------------
''' Returns conversion result of ADC.
'''+ result: 16 bit Long
''' module: module address  (0..255)
'''-------------------------------------------------------------
Function ReadADC(module) As Long
  Dim addr As Long

  addr = AD Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  ReadADC = Peek(DLX)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Returns conversion result of ADC and starts immediately
'''+ a new conversion.
'''+ result: 16 bit Long
''' module: module address  (0..255)
'''-------------------------------------------------------------
Function ReadADC_Sconv(module) As Long
  Dim addr As Long

  addr = 058h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  ReadADC_Sconv = Peek(DLX)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Selects single ended (s.e.) or differential (diff.) inputs
'''+ for the AIN-32/x-module only.
''' module: module address  (0..255)
''' choice: s.e. -> 0, diff. -> 1 (default after power-up)
'''-------------------------------------------------------------
Sub SE_Diff(module, choice)
  Dim addr As Long

  addr = 061h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, choice)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Samples, converts and reads out the digital 16 bit ADC-value
'''+ of an analog input of an AIN-Fx/yy-module ("fast"-ADC-module).
'''+ result:   16 bit Long
'''+  Attention:                                                 
'''+  This instruction is not prepared to handle an access from  
'''+  a low and high priority process to the same module.        
''' module:  module address (0..255)
''' input_no: channel number of analog input
'''-------------------------------------------------------------
Function ADCF(module, input_no) As Long
  Dim addr, dip, adc_n, reminder As Long

  adc_n = Shift_Left(1, (input_no - 1))

  '............ start conversion ............
  addr = 054h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke (ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, adc_n)
  Sub_End_Critical_Section

  '............ wait EOC ............
  Bus_Sleep(6)
  addr = addr + 2
  Do
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr)
    reminder = Peek(DLX) And adc_n
    Sub_End_Critical_Section
  Until(reminder = 0)

  '............ read out result ............
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, (addr - 17h + (input_no)))
  ADCF = Peek(DLX)
  Sub_End_Critical_Section
  Bus_Sleep(32)
EndFunction


'---------------------------------------------------------------
''' Starts a conversion on selected ADC on AIN-Fx/yy-modules.
''' module:      module address (0..255)
''' ADC_pattern: Datenbit z. B.: 0101 = ADC1 + 3
'''-------------------------------------------------------------
Sub Start_ConvF(module, ADC_pattern)
  Dim addr As Long

  addr = 054h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, ADC_pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Wait Until EOC-signals of all selected ADCs are active.
'''+ (for AIN-Fx/yy-modules only)
''' module:      module address (0..255)
''' ADC_pattern: ADC-#1 -> bit 0, ..., ADC-#8 -> bit 7
'''-------------------------------------------------------------
Sub Wait_EOCF(module, ADC_pattern)
  Dim addr, reminder As Long

  Bus_Sleep(6)
  addr = 056h Or (Shift_Left(module, 8))
  Do
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr)
    reminder = (Peek(DLX) And ADC_pattern)
    Sub_End_Critical_Section
  Until(reminder = 0)
  Bus_Sleep(32)
EndSub


'---------------------------------------------------------------
''' Returns conversion result of ADC of AIN-Fx/yy-module.
'''+ result: 16 bit Long
''' module: module address (0..255)
''' adc_no: channel number of analog input
'''-------------------------------------------------------------
Function ReadADCF(module, adc_no) As Long
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, (03Fh + adc_no) Or (Shift_Left(module, 8)))
  ReadADCF = Peek(DLX)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Returns conversion result of two ADC's simultaneously from
'''+ an AIN-Fx/yy-module.
'''+ result: 32 bit Long
'''+         low-word -> adc_no, high-word -> adc_no + 1
''' module: module address (0..255)
''' adc_no: channel number of analog input
'''-------------------------------------------------------------
Function ReadADCF_32(module, adc_no) As Long
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, (03Fh + adc_no) Or (Shift_Left(module, 8)))
  ReadADCF_32 = Peek(D32)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Returns conversion result of two ADC's simultaneously and
'''+ immediately starts the conversion of both ADC again.
'''+ result: 32 bit Long
'''+         low-word -> adc_no, high-word -> adc_no + 1
''' module: module address (0..255)
''' adc_no:
'''+         1 = channel no. 1 + 2
'''+         2 = channel no. 3 + 4
'''+         3 = channel no. 5 + 6
'''+         4 = channel no. 7 + 8
'''-------------------------------------------------------------
Function ReadADCF_SConv_32(module, adc_no) As Long
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, (049h + adc_no) Or (Shift_Left(module, 8)))
  ReadADCF_SConv_32 = Peek(D32)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Returns conversion result of ADC and starts immediately
'''+ a new conversion (for AIN-Fx/yy-modules only).
'''+ result: 16 bit Long
''' module: module address (0..255)
''' adc_no: channel number of analog input
'''-------------------------------------------------------------
Function ReadADCF_SConv(module, adc_no) As Long
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, (057h + adc_no) Or (Shift_Left(module, 8)))
  ReadADCF_SConv = Peek(DLX)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Sets, if equipped with a S&H add-on PCB, 
'''+ the mode of the S&H stage.
''' module: module address (0..255)
''' mode:   
'''+   sample -> 0 
'''+   hold -> 1
'''-------------------------------------------------------------
Sub SH_SetMode(module, mode)
  Dim addr As Long

  addr = 05Ah Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, mode)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Sub is setting the parameters of the burst mode
''' module: module address (0..255)
''' mode:   
'''+         1 Sample Channel 1 only
'''+         2 Sample Channel 1..2
'''+         3 Sample Channel 1..4
'''+         4 Sample Channel 1..8
''' pulses:  sampleperiod (n * 25 ns)
''' samples: count of samples
'''+samples max 2^19 values in mode 1
'''--------------------------------------------------------------
Sub Burst_Init(module, mode, pulses, samples)
  Dim addr As Long
  Dim mode2 As Long

  addr = (Shift_Left(module, 8)) Or 51h

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, pulses)
  Sub_End_Critical_Section
  Inc addr       'samples

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, samples)
  Sub_End_Critical_Section
  addr = addr + 2       'set mode
  mode2 = Shift_Left(((mode - 1) And 3), 8)

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, mode2)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Sub start the burst measurement
''' module: module address (0..255)
''' This Sub is only for ADSP processors and Fx/14
'''-------------------------------------------------------------
Sub Burst_Start(module)
  Dim addr As Long
  Dim mode As Long

  addr = 054h Or (Shift_Left(module, 8))

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  mode = Peek(D32) Or 10000000000b
  NOP_T9
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, mode)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Sub start the burst measurement in continous mode
''' module: module address (0..255)
''' This Sub is only for ADSP processors and Fx/14 Rev B2
'''-------------------------------------------------------------
Sub Burst_CStart(module)
  Dim addr As Long
  Dim mode As Long

  addr = 054h Or (Shift_Left(module, 8))

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  mode = Peek(D32) Or 110000000000b
  NOP_T9
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, mode)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Function reads the progress of the burst measure
'''+ return value: number of convertions to do
''' module: module address (0..255)
'''---------------------------------------------------------------
Function Burst_Status(module) As Long
  Dim addr As Long
  Dim count As Long

  addr = 052h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  count = Peek(D32)
  Sub_End_Critical_Section
  Inc addr

  Sub_Begin_Critical_Section 'wert
  Poke_NOP_RD(ADRD, addr)
  Burst_Status = count - Peek(D32)
  Sub_End_Critical_Section
  NOP_T9
EndFunction


'---------------------------------------------------------------
''' transfer the input data to an array
''' module:   module address (0..255)
''' channel:  select channel
''' startadr: first value of channel which should be transferred
''' count:    number of values
''' array[]:    destination array
''' array_startindex: startindex at the destination array
''' This sub is only for Fx/14
'''--------------------------------------------------------------
Sub Burst_Read(module, channel, startadr, count, array[], array_startindex)
  Dim addr As Long
  Dim addr1 As Long
  Dim value As Long
  Dim i As Long
  Dim mode As Long
  Dim ramstartadr As Long
  Dim lenint As Long
  Dim pointer As Long

  addr = Shift_Left(module, 8)
  addr1 = 054h Or addr
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr1)
  mode = Peek(DLX) And 1100000000b
  Sub_End_Critical_Section

  ramstartadr = (Shift_Left((channel - 1), (20 - Shift_Right(mode, 8)))) + startadr - 1
  addr1 = 061h Or addr
  Sub_Begin_Critical_Section
  Poke(ADWR, addr1)
  NOP_T9
  Poke_NOP(D32, ramstartadr)
  Sub_End_Critical_Section

  addr1 = 60h Or addr
  lenint = count And 0FFFFFFFEh
  If (lenint>1) Then
    For i = 1 To lenint Step 2
      Sub_Begin_Critical_Section 'wert
      Poke_NOP_RD(adrD, addr1)
      value = Peek(D32)
      Sub_End_Critical_Section
      pointer = array_startindex + i - 1
      array[pointer] = value And 0FFFFh
      array[pointer + 1] = Shift_Right(value, 16)
    Next
  EndIf
  If (count And 1 = 1) Then
    Sub_Begin_Critical_Section 'wert
    Poke_NOP_RD(adrD, addr1)
    array[count + array_startindex - 1] = Peek(D32) And 0FFFFh
    Sub_End_Critical_Section
  EndIf
EndSub


'---------------------------------------------------------------
''' transfer the input data to an array
''' module:  module address (0..255)
''' channel: select channel
''' count:   number of values
''' array[]: destination array
''' array_startindex: startindex in the destination array
''' This Sub is only Fx/14
'''---------------------------------------------------------------
Sub Burst_CRead(module, channel, count, array[], array_startindex)
  Dim addr As Long
  Dim diff As Long
  Dim pos As Long
  Dim le As Long
  Dim addr1 As Long
  Dim anz As Long
  Dim i As Long
  Dim str[2] As Long
  Dim len[2] As Long
  Dim sindex[2] As Long

  addr = Shift_Left(module, 8)
  addr1 = 052h Or addr
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr1)
  le = Peek(D32)
  Sub_End_Critical_Section
  Inc addr1

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr1)
  pos = Peek(D32)
  Sub_End_Critical_Section
  diff = pos - count
  If (diff>= 0) Then 'overflow ?
    anz = 1
    str[1] = diff
    len[1] = count
    sindex[1] = array_startindex
  Else
    anz = 2
    str[1] = le + diff
    str[2] = 1
    len[1] = -diff
    len[2] = pos
    sindex[1] = array_startindex
    sindex[2] = array_startindex - diff
  EndIf

  For i = 1 To anz
    Burst_Read(module, channel, str[i], len[i], array, sindex[i])
  Next
EndSub


'---------------------------------------------------------------
''' transfer the input data to an array
''' module:   module address (0..255)
''' channel:  select channel
''' startadr: first value of channel which should be transferred
''' count:    number of values / 2
''' array[]:  destination array
''' array_startindex: startindex in the destination array
'''This Sub is only for Fx/14
'''-------------------------------------------------------------
Sub Burst_Read_Packed(module, channel, startadr, count, array[], array_startindex)
  Dim addr As Long
  Dim addr1 As Long
  Dim value As Long
  Dim i As Long
  Dim mode As Long
  Dim ramstartadr As Long
  Dim lenint As Long
  Dim pointer As Long
  Dim internalindex As Long

  addr = Shift_Left(module, 8)
  internalindex = array_startindex - 1
  addr1 = 054h Or addr
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr1)
  mode = Peek(DLX) And 1100000000b
  Sub_End_Critical_Section

  ramstartadr = (Shift_Left((channel - 1), (20 - Shift_Right(mode, 8)))) + startadr - 1
  addr1 = 061h Or addr
  Sub_Begin_Critical_Section
  Poke(ADWR, addr1)
  NOP_T9
  Poke_NOP(D32, ramstartadr)
  Sub_End_Critical_Section

  addr1 = 060h Or addr
  If (count>0) Then
    For i = 1 To count
      Sub_Begin_Critical_Section
      Poke_NOP_RD(ADRD, addr1)
      array[i + internalindex] = Peek(D32)
      Sub_End_Critical_Section
    Next
  EndIf
EndSub


'---------------------------------------------------------------
''' Function stops the burst measure and returns the samples
''' module: module address (0..255)
''' This Sub is only for ADSP processors and Fx/14
'''-------------------------------------------------------------
Function Burst_Abort(module) As Long
  Dim addr As Long
  Dim value As Long

  addr = 054h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  value = Peek(D32) And 0FFFFFBFFh
  NOP_T9
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, value)
  Sub_End_Critical_Section
  Dec addr

  Sub_Begin_Critical_Section 'wert
  Poke_NOP_RD(ADRD, addr)
  Burst_Abort = Peek(D32)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Sub set the input range
''' module:  module address (0..255)
''' channel: channel 1..8
''' mode:    
'''+      0 range -10 V ..  + 10 V
'''+      1 range -5V   .. + 5 V
'''+      2 range -2.5V .. + 2.5 V
'''+      3 range -1.25 .. + 1.25 V
'''For AIN Fx/14 only
'''---------------------------------------------------------------
Sub Set_Gain(module, channel, mode)
  Dim addr As Long
  Dim mode1 As Long
  Dim Shift As Long

  addr = 055h Or (Shift_Left(module, 8))
  Shift = Shift_Left((channel - 1), 1)

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  mode1 = Peek(DLX)
  NOP_T9
  Sub_End_Critical_Section
  mode1 = (mode1 And NOT (Shift_Left(3, Shift))) Or (Shift_Left((mode), Shift))

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, mode1)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' initialising the syncronisation mode of the f14 board
''' module: module address (0..255)
''' mode: 
'''+             0 normal mode (no synchronisation)
'''+             1 Master mode
'''+             2 Slave mode
'''+             3 Event mode
'''-------------------------------------------------------------
Sub Sync_Mode(module, mode)
  Dim addr As Long

  addr = 04Fh Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, mode)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' sets the waiting time (between 2 measurements) of the sequential control for one ADC
''' module: module address (0..255)
''' time:   
'''+      0 = default time
'''+      1..2048 time in 25 ns
'''-------------------------------------------------------------
Sub SEQ_Set_Delay(module, time)
  Dim addr As Long

  addr = 63h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, time)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' initialising the ain mode
''' module: module address (0..255)
''' mode:
'''+      0 normal mode
'''+      1 single shot mode
'''+      3 continuous mode
'''gain:   
'''+           0 range -10 V ..  + 10 V
'''+           1 range -5V   .. + 5 V
'''+           2 range -2.5V .. + 2.5 V
'''+           3 range -1.25 .. + 1.25 V
'''--------------------------------------------------------------
Sub SEQ_Mode(module, mode, gain)
  Dim addr As Long

  addr = 52h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section
  Poke(ADWR, addr - 2)
  NOP_T9
  Poke_NOP(DLX, Shift_Left(GAIN, 5))
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, mode)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' select the channel in single shot or continuous mode
''' module:  module address (0..255)
''' pattern: selected channels in binary
'''-------------------------------------------------------------
Sub SEQ_Select(module, pattern)
  Dim addr As Long

  addr = 53h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, pattern)
  NOP_T9
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' this function returns the number of channel that is in progress
''' module: module address (0..255)
''' This Sub is only for (ADSP) processors
'''-------------------------------------------------------------
Function SEQ_Status(module) As Long
  Dim addr As Long

  addr = 051h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Seq_Status = Peek(D32)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' transfer the input data to an array
''' module: module address (0..255)
''' channel_index: channel to read
'''-------------------------------------------------------------
Function SEQ_Read_One(module, channel_index) As Long
  Dim value As Long
  Dim i As Long
  Dim baseadr As Long

  i = Shift_Right(channel_index - 1, 1)
  baseadr = (040h + i) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, baseadr)
  If (channel_index And 1 = 1) Then
    Seq_Read_One = Peek(D32) And 0FFFFh
  Else
    Seq_Read_One = Shift_Right(Peek(D32), 16)
  EndIf
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' transfer the input data to an array
''' module:  module address (0..255)
''' channel_index: channel to read
''' This Sub is only for (ADSP) processors
'''-------------------------------------------------------------
Function SEQ_Read_Two(module, channel_index) As Long
  Dim value As Long
  Dim baseadr As Long

  baseadr = (040h + channel_index) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, baseadr)
  Seq_Read_Two = Peek(D32)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' transfer the input data to an array
''' module: module address (0..255)
''' length: number of values
''' array[]:  destination array
''' array_startindex: startindex in the destination array
''' This Sub is only for (ADSP) processors
'''-------------------------------------------------------------
Sub SEQ_Read(module, length, array[], array_startindex)
  Dim value As Long
  Dim i As Long
  Dim baseaddr As Long

  baseaddr = (040h) Or (Shift_Left(module, 8))
  If (length>2) Then
    For i = 1 To length-2 Step 2
      Sub_Begin_Critical_Section
      Poke_NOP_RD(ADRD, baseaddr)
      value = Peek(D32)
      Sub_End_Critical_Section
      Inc baseaddr
      array[i + array_startindex - 1] = value And 0FFFFh   'Kanal 1
      array[i + array_startindex] = Shift_Right(value, 16) 'Kanal 2
    Next
  EndIf

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, baseaddr)
  value = Peek(D32)
  Sub_End_Critical_Section

  If (length And 1 = 1) Then
    array[length + array_startindex - 1] = value And 0FFFFh
  Else
    array[length + array_startindex - 2] = value And 0FFFFh
    array[length + array_startindex - 1] = Shift_Right(value, 16)
  EndIf
EndSub


'---------------------------------------------------------------
''' transfer the input data to an array
''' module: module address (0..255)
''' count:  number of values / 2
''' array[]:  destination array
''' array_startindex: startindex in the destination array
''' This Sub is only FOr (ADSP) processors
'''-------------------------------------------------------------
Sub SEQ_Read_Packed(module, count, array[], array_startindex)
  Dim i As Long

  For i = 1 To count
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, (03Fh + i) Or (Shift_Left(module, 8)))
    array[i + array_startindex - 1] = Peek(D32)
    Sub_End_Critical_Section
  Next
EndSub


'---------------------------------------------------------------
''' transfer the input data of all 32 channels to an array
''' module: module address (0..255)
''' array[]:  destination array
''' array_startindex: startindex in the destination array
''' This Sub is only for (ADSP) processors
'''-------------------------------------------------------------
Sub SEQ_Read32(module, array[], array_startindex)
  Dim value As Long

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, (040h) Or (Shift_Left(module, 8)))
  value = Peek(D32I)
  array[array_startindex] = value And 0FFFFh
  array[1 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[4 + array_startindex] = value And 0FFFFh
  array[5 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[8 + array_startindex] = value And 0FFFFh
  array[9 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[12 + array_startindex] = value And 0FFFFh
  array[13 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[16 + array_startindex] = value And 0FFFFh
  array[17 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[20 + array_startindex] = value And 0FFFFh
  array[21 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[24 + array_startindex] = value And 0FFFFh
  array[25 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[28 + array_startindex] = value And 0FFFFh
  array[29 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[2 + array_startindex] = value And 0FFFFh
  array[3 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[6 + array_startindex] = value And 0FFFFh
  array[7 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[10 + array_startindex] = value And 0FFFFh
  array[11 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[14 + array_startindex] = value And 0FFFFh
  array[15 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[18 + array_startindex] = value And 0FFFFh
  array[19 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[22 + array_startindex] = value And 0FFFFh
  array[23 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32I)
  array[26 + array_startindex] = value And 0FFFFh
  array[27 + array_startindex] = Shift_Left(value, -16)
  value = Peek(D32)
  array[30 + array_startindex] = value And 0FFFFh
  array[31 + array_startindex] = Shift_Left(value, -16)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' transfer the input data of all 32 channels to an array
''' module: module address (0..255)
''' array[]:  destination array
''' array_startindex: startindex in the destination array
''' This Sub is only for (ADSP) processors
'''-------------------------------------------------------------
Sub SEQ_Read32_Packed(module, array[], array_startindex)
  Dim value As Long

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, (040h) Or (Shift_Left(module, 8)))
  NOP_T9
  NOP_T9
  array[array_startindex] = Peek(D32I)
  array[2 + array_startindex] = Peek(D32I)
  array[4 + array_startindex] = Peek(D32I)
  array[6 + array_startindex] = Peek(D32I)
  array[8 + array_startindex] = Peek(D32I)
  array[10 + array_startindex] = Peek(D32I)
  array[12 + array_startindex] = Peek(D32I)
  array[14 + array_startindex] = Peek(D32I)
  array[1 + array_startindex] = Peek(D32I)
  array[3 + array_startindex] = Peek(D32I)
  array[5 + array_startindex] = Peek(D32I)
  array[7 + array_startindex] = Peek(D32I)
  array[9 + array_startindex] = Peek(D32I)
  array[11 + array_startindex] = Peek(D32I)
  array[13 + array_startindex] = Peek(D32I)
  array[15 + array_startindex] = Peek(D32)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
' Convert the digitial value to an analog output
' module: module address (0..255)
' dac_no: channel number of analog output
' value:  output value (0..65535)
'---------------------------------------------------------------
Sub DAC_OLD(module, dac_no, value) ''<HIDE>
  Dim addr, dac_n, out_value As Long

  out_value = value
  If (out_value < 0) Then out_value = 0
  If (out_value > 0FFFFh) Then out_value = 0FFFFh
  dac_n = dac_no - 1
  addr = (dac_n Or 080h) Or (Shift_Left(module, 8))

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, out_value)
  Sub_End_Critical_Section
  addr = 090h Or (Shift_Left(module, 8))

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Convert the digitial value to an analog output
''' module: module address (0..255)
''' dac_no: channel number of analog output
''' value:  output value (0..65535)
'''-------------------------------------------------------------
Sub DAC(module, dac_no, value)
  Dim addr, out_value As Long

  out_value = value
  If (out_value < 0) Then out_value = 0
  If (out_value > 0FFFFh) Then out_value = 0FFFFh
  addr = ((dac_no) + 23 Or 080h) Or (Shift_Left(module, 8))

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, out_value)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Set DAC-register to desired value
''' module: module address (0..255)
''' dac_no: channel number of analog output
''' value:  output value (0..65535)
'''-------------------------------------------------------------
Sub WriteDAC(module, dac_no, value)
  Dim addr, dac_n, out_value As Long

  out_value = value
  If (out_value < 0) Then out_value = 0
  If (out_value > 0FFFFh) Then out_value = 0FFFFh
  dac_n = dac_no - 1
  addr = (dac_n Or 080h) Or (Shift_Left(module, 8))

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, out_value)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Set DAC-register to desired value
''' module: module address (0..255)
''' dac_no:
'''+         0 = Channel 1 and 2
'''+         1 = Channel 3 and 4
'''+         2 = Channel 5 and 6
'''+         3 = Channel 7 and 8
''' value:  output value 32 Bit
''' This Sub is only for ADSP processors and AOUT Rev B oder Rev C
'''-------------------------------------------------------------
Sub WriteDAC32(module, dac_no, value)
  Dim addr As Long

  addr = ((dac_no) Or 0A0h) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, value)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Simultaneously start conversion of all DAC on this module.
''' module: module address (0..255)
'''-------------------------------------------------------------
Sub Start_DAC(module)
  Dim addr As Long

  addr = 090h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
' NEW COMMANDS for DAC Module with MEM option
'---------------------------------------------------------------

'---------------------------------------------------------------
''' set the mode of the dac modul
''' module: module address (0..255)
''' mode:   
'''+      0 normal mode
'''+      1 frequency generator mode
''' This Sub is only for ADSP processors and AOUT with MEM option
'''--------------------------------------------------------------
Sub FG_Mode(module, mode)
  Dim addr As Long

  addr = (23 Or 080h) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section
  Bus_Sleep(100)
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, mode)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' set the delay between two steps
''' module: module address (0..255)
''' dac_no: channel number of analog output
''' scale:  F_output = 80 MHz/scale
''' This Sub is only for ADSP processors and AOUT with MEM option
'''--------------------------------------------------------------
Sub FG_Delay(module, dac_no, scale)
  Dim addr As Long

  addr = (10 Or 080h) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, (scale-2) Or Shift_Left((dac_no) - 1, 29))
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' set the buffer of each channel
''' module: module address (0..255)
''' dac_no: channel number of analog output
''' startadr: start_adr of memory
''' memsize:  size of memory for this channel
''' This Sub is only for ADSP processors and AOUT with MEM option
'''-------------------------------------------------------------
Sub FG_def(module, dac_no, startadr, memsize)
  Dim addr As Long

  addr = (8 Or 080h) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, (startadr) Or Shift_Left((dac_no - 1), 29))
  Sub_End_Critical_Section
  Inc addr
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, (memsize) Or Shift_Left((dac_no - 1), 29))
  Bus_Sleep(100)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' transfer the output data from a array to the memory of the dac module
''' module:        module address (0..255)
''' mem_start_adr: start_adr of memory
''' count:         number of values (only even-numbered)
''' array[]:         source array
''' array_startindex: startindex in the source array
'''This Sub is only for ADSP processors and AOUT with MEM option
'''-------------------------------------------------------------
Sub FG_Write(module, mem_start_adr, count, array[], array_startindex)
  Dim addr As Long
  Dim value As Long
  Dim i As Long
  Dim lenint As Long
  Dim pointer As Long
  Dim hw As Long
  Dim lw As Long

  addr = (18 Or 080h) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, ((mem_start_adr) Or (080000000h)))
  Sub_End_Critical_Section

  pointer = array_startindex
  Inc addr
  lenint = count
  Bus_Sleep(100)
  If (lenint>1) Then
    For i = 1 To lenint Step 2
      lw = array[pointer] And 0FFFFh
      Inc pointer
      hw = Shift_Left(array[pointer], 16)
      Inc pointer
      value = lw Or hw
      Sub_Begin_Critical_Section
      Poke(ADWR, addr)
      NOP_T9
      Poke_NOP(D32, value)
      Sub_End_Critical_Section
#If PROZESSOR = T11 Then
      Bus_Sleep(20)
#EndIf
    Next
  EndIf
EndSub


'---------------------------------------------------------------
''' transfer the waveform data from memory to an array
''' module:       module address (0..255)
''' ramstart_adr: start_adr of memory
''' length:       number of values (only even-numbered)
''' array[]:        destination array
''' array_startindex: startindex in the destination array
'''This Sub is only for ADSP processors and AOUT with MEM option
'''-------------------------------------------------------------
Sub FG_Read(module, ramstart_adr, length, array, array_startindex) ''<HIDE>
  Dim addr As Long
  Dim value As Long
  Dim i As Long
  Dim lenint As Long
  Dim pointer As Long
  Dim hw As Long
  Dim lw As Long

  addr = (18 Or 080h) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, (ramstart_adr))
  Sub_End_Critical_Section
  pointer = array_startindex
  Inc addr
  Bus_Sleep(100)
  lenint = length
  If (lenint>1) Then
    For i = 1 To lenint Step 2
      Sub_Begin_Critical_Section
      Poke_NOP_RD(ADRD, addr)
      value = Peek(D32)
      Sub_End_Critical_Section
      array[pointer] = value And 0FFFFh
      Inc pointer
      array[pointer] = Shift_Right(value, 16)
      Inc pointer
    Next
  EndIf
EndSub


'---------------------------------------------------------------
''' Reads the actual output-position of channel 1..8 in the RAM
''' module: module address (0..255)
''' dac_no: channel number of analog output
''' This Sub is only for ADSP processors and AOUT with MEM option
'''-------------------------------------------------------------
Function FG_Read_Index(module, dac_no) As Long
  Dim addr As Long

  addr = ((7 + (dac_no))  Or 080h) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  FG_Read_Index = Peek(D32) And 01FFFFFh
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' START/STOP FREQUENCYGENERATOR
''' module:  module address (0..255)
''' pattern: bitcombination ; each bit corresponds with an output
''' run_mode: 
'''+        action = 0 starts output of Dacs immediately
'''+        action = 1 stops output of Dacs immediately
'''+        action = 2 stops output of Dacs after the period
''' This Sub is only for ADSP processors and AOUT with MEM option
'''--------------------------------------------------------------
Sub FG_Control(module, pattern, run_mode)
  Dim addr As Long

  addr = ((20 Or 080h) Or (Shift_Left(module, 8))) + run_mode
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, (pattern) And 0FFFFh)
  Bus_Sleep(100)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Read Status
''' module: module address (0..255)
''' This Sub is only for ADSP processors and AOUT with MEM option
'''-------------------------------------------------------------
Function FG_Status(module) As Long
  Dim addr As Long

  addr = (20 Or 080h) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  FG_Status = Peek(DLX) And 0Fh
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Initialisation of a digital I/O module (channel 0-15)
''' module: module address (0..255)
''' pattern: each bit corresponds to a channel
'''+           0 = input
'''+           1 = output
'''-------------------------------------------------------------
Sub DigProg1(module, pattern)
  Dim addr, old As Long

  addr = 32 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  old = Peek(DHX)
  NOP_T9
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke(DH, old And 0FFFFh)
  NOP_T9
  Poke_NOP(DLX, pattern And 0FFFFh)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Initialisation of a digital I/O module (channel 16-31)
''' module: module address (0..255)
''' pattern: each bit corresponds to a channel
'''+           0 = input
'''+           1 = output
'''-------------------------------------------------------------
Sub DigProg2(module, pattern)
  Dim addr, old As Long

  addr = 32 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  old = Peek(DLX)
  NOP_T9
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke(DL, old And 0FFFFh)
  NOP_T9
  Poke_NOP(DHX, pattern And 0FFFFh)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Reads the digital inputs (channel 0 - 15)
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Digin_Word1(module) As Long
  Dim addr As Long

  addr = 16 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Digin_Word1 = Peek(DLX)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Reads the digital inputs (channel 16 - 31)
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Digin_Word2(module) As Long
  Dim addr As Long

  addr = 16 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Digin_Word2 = Peek(DHX)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Reads the digital inputs (channel 0 - 31)
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Digin_Long(module) As Long
  Dim addr As Long

  addr = 16 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Digin_Long = Peek(D32)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Reads the digital inputs (channel 0 - 31)
''' module: module address (0..255)
''' only for modules newer 1/2001 and ADSP CPU
'''-------------------------------------------------------------
Function Digin_Long_F(module) As Long
  Dim addr As Long

  addr = 16 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Digin_Long_F = Peek(D32)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Sets the digital outputs (bits 0..15)
''' module:  module address (0..255)
''' pattern: each bit corresponds to a channel
'''-------------------------------------------------------------
Sub Digout_Word1(module, pattern)
  Dim addr As Long

  addr = Shift_Left(module, 8)
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern And 0FFFFh)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Sets the digital outputs (bits 16..31)
''' module:  module address (0..255)
''' pattern: each bit corresponds to a channel
''''------------------------------------------------------------
Sub Digout_Word2(module, pattern)
  Dim addr As Long

  addr = 1 Or Shift_Left(module, 8)
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DHX, pattern And 0FFFFh)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Sets the digital outputs (bits 0..31)
''' module:  module address (0..255)
''' pattern: each bit corresponds to a channel
'''-------------------------------------------------------------
Sub Digout_Long(module, pattern)
  Dim addr As Long

  addr = 2 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Sets the digital outputs (bits 0..31)
''' module:  module address (0..255)
''' pattern: each bit corresponds to a channel
'''+ only for modules newer 1/2001 
'''-------------------------------------------------------------
Sub Digout_Long_F(module, pattern)
  Dim addr As Long

  addr = 2h Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Sets and resets selected digital outputs
''' module: module address (0..255)
''' set:    Bitstring indicating the outputs which should be set
''' clear:  Bitstring indicating the outputs which should be reset
'''-------------------------------------------------------------
Sub Digout_Bits(module, set, clear)
  Dim old As Long

  'getting actual value and manipulating Bits
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, Shift_Left(module, 8))
  old = (((Peek(D32)) Or set) And not(clear))
  Sub_End_Critical_Section

  'writing to output
  Sub_Begin_Critical_Section
  Poke(ADWR, Shift_Left(module, 8) Or 2)
  NOP_T9
  Poke_NOP(D32, old)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Sets and resets selected digital outputs
'''+ only for DIO32RB 
''' module: module address (0..255)
''' set: Bitstring indicating the outputs which should be set
''' clear: Bitstring indicating the outputs which should be reset
'''-------------------------------------------------------------
Sub Digout_Bits_F(module, set, clear)
  Dim addr As Long

  addr = 5 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, clear)
  Sub_End_Critical_Section
  Dec addr

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, set)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' read back of the output value of the digital outputs (bits 0..15))
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Get_Digout_Word1(module) As Long
  Dim addr As Long

  addr = Shift_Left(module, 8)
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Get_Digout_Word1 = Peek(DLX)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' read back of the output value of the digital outputs (bits 16..31))
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Get_Digout_Word2(module) As Long
  Dim addr As Long

  addr = Shift_Left(module, 8)
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Get_Digout_Word2 = Peek(DHX)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' read back of the output value of the digital outputs (bits 0..31))
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Get_Digout_Long(module) As Long
  Dim addr As Long

  addr = Shift_Left(module, 8)
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Get_Digout_Long = Peek(D32)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Sets or resets one channel of a digital output
''' module:  module address (0..255)
''' channel: channel (0..31)
''' value:   
'''+        0 = reset channel
'''+        1 = set channel
'''-------------------------------------------------------------
SUB Digout(module, channel, value)
  DIM new as Long
  SUB_BEGIN_CRITICAL_SECTION
  poke_nop(ADRD, SHIFT_LEFT(module, 8))
  new = ((Shift_Left(PEEK(DH), 16)+PEEK(DLX)) AND (NOT(SHIFT_LEFT(1, channel)))) or shift_left(value, channel)
  SUB_END_CRITICAL_SECTION
  
  if (channel<16) then
    SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR, SHIFT_LEFT(module, 8))
    nop_t9
    poke_nop(DLX, new AND 0FFFFH)
    SUB_END_CRITICAL_SECTION
  else
    SUB_BEGIN_CRITICAL_SECTION
    poke(ADWR, SHIFT_LEFT(module, 8)+1)
    nop_t9
    poke_nop(DHX, shift_right(new, 16))
    SUB_END_CRITICAL_SECTION
  endif
ENDSUB



'---------------------------------------------------------------
''' Sets or resets one channel of a digital output
'''+ only for DIO32RB 
''' module: module address (0..255)
''' channel: channel (0..31)
''' value:   
'''+     0 = reset channel
'''+     1 = set channel
'''-------------------------------------------------------------
Sub Digout_F(module, channel, value)
  Sub_Begin_Critical_Section
  Poke(ADWR, ((5h - value) Or (Shift_Left(module, 8))))
  NOP_T9
  Poke_NOP(D32, Shift_Left(1, (channel)))
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' latches the digital I/O module.
''' Inputs are latched in the input registers.
''' Outputs are set to the output register.
''' module: module address (0..255)
'''-------------------------------------------------------------
Sub Dig_Latch(module)
  Dim addr As Long

  addr = 22 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' reads the input latch register (bits 0..15)
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Dig_ReadLatch1(module) As Long
  Dim addr As Long

  addr = 20 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Dig_ReadLatch1 = Peek(DLX)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' reads the input latch register (bits 16..31)
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Dig_ReadLatch2(module) As Long
  Dim addr As Long

  addr = 20 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Dig_ReadLatch2 = Peek(DHX)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' sets output register (bits 0..31)
''' module: module address (0..255)
''' pattern: each bit corresponds to a channel
'''-------------------------------------------------------------
Sub Dig_WriteLatch32(module, pattern)
  Dim addr As Long

  addr = 18 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' sets output register (bits 0..15)
'''+ ATTENTION: Do not use in combination with Dig_WriteLatch2
''' module:   module address (0..255)
''' pattern: each bit corresponds to a channel
'''-------------------------------------------------------------
Sub Dig_WriteLatch1(module, pattern)
  Dim addr As Long

  addr = 18 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' sets output register (bits 16..31)
'''+ATTENTION: Do not use in combination with Dig_WriteLatch1
''' module:  module address (0..255)
''' pattern: each bit corresponds to a channel
'''-------------------------------------------------------------
Sub Dig_WriteLatch2(module, pattern)
  Dim addr As Long

  addr = 18 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DHX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'
' The following functions and procedures
' are for accessing counter modules.
'
'---------------------------------------------------------------
'---------------------------------------------------------------
'''activate / deaktivate counter
''' module:  module address (0..255)
''' pattern: each bit corresponds to a counter
'''-------------------------------------------------------------
Sub CNT_Enable(module, pattern)
  Dim addr As Long

  addr = 20 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''reset counter
''' module:  module address (0..255)
''' pattern: each bit corresponds to a counter
'''-------------------------------------------------------------
Sub CNT_Clear(module, pattern)
  Dim addr As Long

  addr = 18 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''latch couner value to register
''' module:  module address (0..255)
''' pattern: each bit corresponds to a counter
'''-------------------------------------------------------------
Sub CNT_Latch(module, pattern)
  Dim addr As Long

  addr = 16 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''set modus for counter
''' module: module address (0..255)
''' value:  each bit corresponds to a counter
'''-------------------------------------------------------------
Sub CNT_SetMode(module, pattern)
  Dim addr As Long

  addr = 22 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub

'---------------------------------------------------------------
''' set modus for a counter
''' module: module address (0..255)
''' cnt_no: number of the counter
''' mode:   
'''+      0 = quadrature encoder input
'''+      1 = forward / backward counter
'''+      2 = PW input
'''-------------------------------------------------------------
Sub CO4_SetMode(module, cnt_no, mode)
  Dim addr1 As Long
  Dim addr2 As Long
  Dim mode1 As Long
  Dim mode2 As Long
  Dim readback1 As Long
  Dim readback2 As Long

  addr1 = 22 Or (Shift_Left(module, 8))
  addr2 = addr1 + 1
  mode1 = Shift_Left(mode And 1, cnt_no - 1)
  mode2 = Shift_Left(Shift_Right((mode And 2), 1), cnt_no - 1)

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr1)
  readback1 = Peek(DLX) And not (Shift_Left(1, cnt_no - 1))
  NOP_T9
  Sub_End_Critical_Section

  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr2)
  readback2 = Peek(DLX) And not(Shift_Left(1, cnt_no - 1))
  NOP_T9
  Sub_End_Critical_Section
  mode1 = mode1 Or readback1
  mode2 = mode2 Or readback2

  Sub_Begin_Critical_Section
  Poke(ADWR, addr1)
  NOP_T9
  Poke_NOP(DLX, mode1)
  Sub_End_Critical_Section
  Sub_Begin_Critical_Section
  Poke(ADWR, addr2)
  NOP_T9
  Poke_NOP(DLX, mode2)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''read latch register 32 Bit
'''+remark: It is checked if a new counter value has been
'''+         latched between reading the high-word and the
'''+         low word. In this case it will be read again.
'''+         (hardware latch)
''' module: module address (0..255)
''' cnt_no: number of the counter
'''-------------------------------------------------------------
Function CNT_ReadLatch32(module, cnt_no) As Long
  Dim addr_h, addr_l As Long
  Dim old_hword, old_lword As Long
  Dim hword, lword As Long

  addr_h = (2 * cnt_no - 1) Or (Shift_Left(module, 8))
  addr_l = (2 * cnt_no - 2) Or (Shift_Left(module, 8))
  Do
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr_l)
    old_lword = Peek(DLX)
    Sub_End_Critical_Section
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr_h)
    old_hword = Peek(DLX)
    Sub_End_Critical_Section
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr_l)
    lword = Peek(DLX)
    Sub_End_Critical_Section
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr_h)
    hword = Peek(DLX)
    Sub_End_Critical_Section
  Until ((old_lword = lword) And (old_hword = hword))
  CNT_ReadLatch32 = Shift_Left(hword, 16) + (lword And 0FFFFh)
EndFunction


'---------------------------------------------------------------
''' reads latch register 32 Bit
''' module: module address (0..255)
''' cnt_no: number of the counter
'''-------------------------------------------------------------
Function CO4_ReadLatch(module, cnt_no) As Long
  Dim addr As Long

  addr = (cnt_no - 1) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  CO4_ReadLatch = Peek(D32)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' only for moduls newer than 08/2002
'''+ set modus of the 3. PWM-Register and
'''+ set destination of the softwarelatch
''' module:  module address (0..255)
''' pattern: 
'''+     bit 0..3 each bit corresponds to a counter (3. PWM-Register)
'''+          0->latch with high-edge (default)
'''+          1->latch with low-edge
'''+     bit 4..7 each bit corresponds to a counter (softwarelatch)
'''+          0->latch into low-register (default)
'''+          1->latch into high-register
'''-------------------------------------------------------------
Sub CO4_Set_LatchMode(module, pattern)
  Dim addr As Long

  addr = 25 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' read latch register 16 Bit
''' module: module address (0..255)
''' cnt_no: number of the counter
'''-------------------------------------------------------------
Function CNT_ReadLatch16(module, cnt_no) As Long
  Dim addr As Long

  If (cnt_no<9) Then
    addr = (2 * cnt_no - 2) Or (Shift_Left(module, 8))
  Else
    addr = (2 * cnt_no - 17) Or (Shift_Left(module, 8))
  EndIf
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  CNT_ReadLatch16 = Peek(DLX) And 0FFFFh
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' read counter value 32 Bit
''' module: module address (0..255)
''' cnt_no: number of the counter
'''-------------------------------------------------------------
Function CNT_Read32(module, cnt_no) As Long
  Dim addr, hword As Long

  addr = 16 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, Shift_Left(1, (cnt_no - 1)))   'latch counter
  Sub_End_Critical_Section
  addr = (2 * cnt_no - 1) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  hword = Shift_Left(Peek(DLX), 16)            'read HighWord
  Sub_End_Critical_Section
  addr = (2 * cnt_no - 2) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  CNT_Read32 = hword + (Peek(DLX) And 0FFFFh) 'read LowWord
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' read counter value 32 Bit (new counter board)
''' module: module address (0..255)
''' cnt_no: number of the counter
'''-------------------------------------------------------------
Function CO4_Read(module, cnt_no) As Long
  Dim addr As Long

  addr = 16 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, Shift_Left(1, (cnt_no - 1)))    'latch counter
  Sub_End_Critical_Section

  addr = (cnt_no - 1) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  CO4_Read = Peek(D32)                     'read 32 Bit-value
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' read counter value 16 Bit
''' module: module address (0..255)
''' cnt_no: number of the counter
'''-------------------------------------------------------------
Function CNT_Read16(module, cnt_no) As Long
  Dim addr, hword As Long

  addr = 16 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, Shift_Left(1, (cnt_no - 1)))   'latch counter
  Sub_End_Critical_Section
  If (cnt_no<9) Then
    addr = (2 * cnt_no - 2) Or (Shift_Left(module, 8))
  Else
    addr = (2 * cnt_no - 17) Or (Shift_Left(module, 8))
  EndIf
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  CNT_Read16 = Peek(DLX) And 0FFFFh            'read LowWord
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' reads the status of a counter input
''' module: module address (0..255)
''' cnt_no: number of the counter
'''-------------------------------------------------------------
Function CO4_GetStatus(module, cnt_no) As Long
  Dim addr As Long

  addr = (27 + cnt_no) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  CO4_GetStatus = Peek(D32)           'read 32 Bit-value
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' resets tihe error bits of the status register
''' module: module address (0..255)
''' pattern : bitcombination ; each bit corresponds with counter
'''-------------------------------------------------------------
Sub CO4_ResetStatus(module, pattern) As Long
  Dim addr As Long

  addr = 27 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' enables the hardware clear input of a counter
''' module: module address (0..255)
''' pattern: bitcombination ; each bit corresponds with counter
'''-------------------------------------------------------------
Sub CO4_ClearEnable(module, pattern) As Long
  Dim addr As Long

  addr = 24 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' enables the hardware latch input of a counter
''' module:  module address (0..255)
''' pattern: each bit corresponds with counter
'''-------------------------------------------------------------
Sub CO4_LatchEnable(module, pattern) As Long
  Dim addr As Long

  addr = 26 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' read SSI encoder value 32 Bit 
''' module:  module address (0..255)
''' channel: number of the SSI counter
'''-------------------------------------------------------------
Function SSI_Read(module, channel) As Long
  Dim addr As Long

  addr = (34 + channel) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  SSI_Read = Peek(D32)            'read 32 Bit-value
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' sets the number of databits for the SSI Interface
''' module:  module address (0..255)
''' channel: number of the SSI counter
''' value:   number of bits
'''-------------------------------------------------------------
Sub SSI_Set_Bits(module, channel, value)
  Dim addr As Long
  addr = (36 + channel) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, value)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' sets frequency of the SSI clock
''' module: module address (0..255)
''' prescale: frequency = 10MHZ / value
'''-------------------------------------------------------------
Sub SSI_Set_Clock(module, prescale)
  Dim addr As Long

  addr = 34 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, prescale)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Starts the SSI interface
''' module: module address (0..255)
''' pattern: each bit corresponts to one counter
'''-------------------------------------------------------------
Sub SSI_Start(module, pattern)
  Dim addr As Long
  Dim value As Long

  addr = 17 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  value = Peek(DLX)
  Sub_End_Critical_Section
  value = (pattern And 03h) Or value

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, value)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Sets the SSI mode
''' module:  module address (0..255)
''' pattern: each bit corresponts to one counter
'''+          0 = single start mode
'''+          1 = continuous start mode
'''-------------------------------------------------------------
Sub SSI_Mode(module, pattern)
  Dim addr As Long
  Dim value As Long

  value = pattern And 03h
  addr = 17 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, (Shift_Left(value, 2)))
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Reads the SSI status
'''+ return value : 
'''+                0 = SSI value compleated
'''+                1 = SSI transfer running
''' module: module address (0..255)
''' channel: number of the SSI counter
'''-------------------------------------------------------------
Function SSI_Status(module, channel) As Long
  Dim addr As Long
  Dim value As Long

  addr = 17 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrD, addr)
  value = Peek(DLX)
  Sub_End_Critical_Section
  value = Shift_Right(value, (channel - 1))
  SSI_Status = value And 01h
EndFunction


'---------------------------------------------------------------
''' sets and updates the PWM-4 modul
''' module:    module address (0..255)
''' channel:   number of the output
''' prescaler: value 0..7 corresponds to division by 2^0..2^7
''' low:       Number of cycles after the prescaler for LOW time
''' high:      Number of cycles after the prescaler for HIGH time
'''-------------------------------------------------------------
Sub PWM_Set(module, channel, prescaler, low, high)
  Dim addr_t, addr_l, addr_h As Long

  addr_t = (channel * 2 - 1) Or (Shift_Left(module, 8))
  addr_l = (channel * 2 + 6) Or (Shift_Left(module, 8))
  addr_h = (channel * 2 - 2) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr_t)
  NOP_T9
  Poke_NOP(DLX, prescaler)
  Sub_End_Critical_Section
  Sub_Begin_Critical_Section
  Poke(ADWR, addr_l)
  NOP_T9
  Poke_NOP(DLX, LOW)
  Sub_End_Critical_Section
  Sub_Begin_Critical_Section
  Poke(ADWR, addr_h)
  NOP_T9
  Poke_NOP(DLX, HIGH)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' enable a output of the PWM module
''' module:  module address (0..255)
''' pattern: each bit corresponds to a counter
'''-------------------------------------------------------------
Sub PWM_Enable(module, pattern)
  Dim addr_en, addr_clr As Long

  addr_clr = 18 Or (Shift_Left(module, 8))
  addr_en = 20 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr_clr)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
  Sub_Begin_Critical_Section
  Poke(ADWR, addr_en)
  NOP_T9
  Poke_NOP(DLX, pattern)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''External Latch enable/disable
''' module:     module address (0..255)
''' cnt_select: 
'''+           1 = enable
'''+           0 = disable
'''-------------------------------------------------------------
Sub ExtLch_Enable(module, cnt_select)
  Dim addr As Long
  addr = 24 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, cnt_select)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' set/reset a output of the PWM modul
''' module:  module address (0..255)
''' channel: number of the output
''' level:   
'''+       0 = output voltage = 0V
'''+       1 = output voltage = external voltage
'''-------------------------------------------------------------
Sub PWM_OUT(module, channel, level)
  Dim addr_clr, addr_upd As Long

  addr_clr = 18 Or (Shift_Left(module, 8))
  addr_upd = 24 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr_clr)
  NOP_T9
  Poke_NOP(DLX, Shift_Left(1, channel - 1))
  Sub_End_Critical_Section
  Sub_Begin_Critical_Section
  Poke(ADWR, addr_upd)
  NOP_T9
  Poke_NOP(DLX, Shift_Left(1, channel - 1))
  Sub_End_Critical_Section
  PWM_SET(module, channel, 0, 1 - level, level)
EndSub


'---------------------------------------------------------------
' The following functions and procedures
' are for accessing the STORAGE modules.
'---------------------------------------------------------------

'---------------------------------------------------------------
''' Reads the status word from the glue logic.
'''+ status
'''+Bit 0=1 Media in Slot
'''+Bit 1=1 Error
'''+Bit 2=1 Busy
'''+Bit 3=1 Data Can be read
'''+Bit 4=1 Data written
'''+Bit 5=1 Reset
'''+Bit 6 NA   (Might be set by other function calls)
'''+Bit 7 NA   (Might be set by other function calls)
'''+Bit 8-11
'''+                0  0  0  1 = 1d : Time-Out READY-Signal
'''+                0  0  1  0 = 2d : Time-Out WAIT-Signal
'''+                0  0  1  1 = 3d : Media was removed
'''+                0  1  0  0 = 4d : Error at READY
'''+                0  1  0  1 = 5d : Time-Out READY
'''+                0  1  1  0 = 6d : Error at DRQ (Data ReQuest)
'''+                0  1  1  1 = 7d : Time-Out DRQ (Data ReQuest)
'''+                1  0  0  0 = 8d : Media not inserted
'''+Bit 12-31 NA
''' module:  module address (0..255)
'''---------------------------------------------------------------
Function Media_Stat(module) As Long ''
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, 3 Or Shift_Left(module, 8))
  Media_Stat = Peek(D32)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
' Reads a 32 bit Long value from the glue logic which was previously
' read from the media.
' module: module address
'---------------------------------------------------------------
Function Media_RD_Dat(module) As Long  ''<HIDE>
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, 15 Or Shift_Left(module, 8))
  Media_RD_Dat = Peek(D32)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
' Writes an instruction word to the glue logic.
'  module:   module address  (0..255)
'  code:   instruction code (Long), possible codes are:
'          6 - write sectors
'          8 - read identifier of media (256 bytes Long)
'          9 - read sectors
'  sector: sector number (Long)
'  cnt:    sector count (Long: 1...12)
'---------------------------------------------------------------
Sub Media_WR_Cmd(module, code, sector, cnt)  ''<HIDE>
  Sub_Begin_Critical_Section
  Poke(ADWR, code Or Shift_Left(module, 8))
  NOP_T9
  Poke_NOP(D32, (sector Or Shift_Left(cnt, 28)))
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
' Writes one 32 bit data word to the SRAM of the glue logic.
'  module : module address (Long)
'  daten: 32 bit data word (Long or Float)
'---------------------------------------------------------------
Sub Media_WR_Dat(module, daten)  ''<HIDE>
  Sub_Begin_Critical_Section
  Poke(ADWR, 7 Or Shift_Left(module, 8))
  NOP_T9
  Poke_NOP(D32, daten)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
' Sends a RESET command to the media for initialization or recovering
' from unexpected fault conditions.
'  module: module address (Long)
'---------------------------------------------------------------
Sub Media_RST(module)  ''<HIDE>
  Sub_Begin_Critical_Section
  Poke(ADWR, 20 Or Shift_Left(module, 8))
  NOP_T9
  Poke_NOP(D32, 0)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
' Waits for respond of the media for a specified amount of time.
'  module: module address (1...255)
'  term: Abort condition (As described in Media_Stat())
'  time: Abort time in 100s steps
'  return value: Media status As described in Media_Stat() (Long) or
'                 80h -> Media does not respond (time-out)
'---------------------------------------------------------------
Function Media_WFR(module, term, time) As Long  ''<HIDE>
  Dim t1, t2, t3, stat, ret, div As Long

  div = 2
  t1 = Read_Timer()
  t3 = time / (div + 1) * 30000           '1/3 of the necessary time
  Do
    t2 = Read_Timer()
    stat = Media_Stat(module)
    If ((stat And 1) = 0) Then        'media not inserted
      ret = stat
      stat = 0
    Else
      If ((t2-t1)>t3) Then    'time-out
        If (div>0) Then
          t1 = Read_Timer()
          Dec div
        Else            'after 3 loops: RESET
          Media_RST(module)
          ret = 80h
          stat = 0
        EndIf
      Else
        ret = stat
      EndIf
    EndIf
  Until ((stat And term) = 0h)
  Media_WFR = ret
EndFunction


'---------------------------------------------------------------
''' Writes blocks (1...12 with 128 Longs each) of data to media.
'''+  return value: Media status As described in Media_Stat() (Long) or
'''+                 40h -> number of blocks exceeding EOF, 
'''+                        no data written to media
'''  module: Module address (Long: 0...255)
'''  f_info[]: Name of array that holds the file informations
'''  file: File number (Long: 1...10)
'''  s_sec: Rel. sector number of start sector in file (Long: 1...m)
'''  s_cnt: Number of blocks with 128 Longs each (Long: 1...12)
'''  array[]: Source array to copy data from
'''  idx: First array element to copy from (Long: 1...n)
'''---------------------------------------------------------------
Function Media_WR_Blk_L(module, f_info[], file, s_sec, s_cnt, array[], idx) As Long
  Dim i, first, last, stat, type As Long

  last = f_info[file * 2 + 2]
  first = f_info[file * 2 + 1]
  If ((last - first + 2)<(s_sec + s_cnt)) Then
    stat = 40h                        'Block will be written beyond EOF!!!
  Else
    stat = Media_WFR(module, 26h, 150000)
    Media_WR_Cmd(module, 6, (s_sec - 1 + first), s_cnt)
    For i = 1 To s_cnt * 128
      Media_WR_Dat(module, array[idx - 1 + i])
    Next i
    stat = Media_Stat(module)
  EndIf
  Media_WR_Blk_L = stat
EndFunction



'---------------------------------------------------------------
''' Writes blocks (1...12 with 128 Longs each) of data to media.
'''+  return value: Media status As described in Media_Stat() (Long) or
'''+                 40h -> number of blocks exceeding EOF, 
'''+                        no data written to media
'''  module: Module address (Long: 0...255)
'''  f_info[]: Name of array that holds the file informations
'''  file: File number (Long: 1...10)
'''  s_sec: Rel. sector number of start sector in file (Long: 1...m)
'''  s_cnt: Number of blocks with 128 Longs each (Long: 1...12)
'''  array[]: Source array to copy data from
'''  idx: First array element to copy from (Long: 1...n)
'''---------------------------------------------------------------
Function Media_WR_Blk(module, f_info[], file, s_sec, s_cnt, array[], idx) As Long
  Media_WR_Blk = Media_WR_Blk_L(module, f_info, file, s_sec, s_cnt, array, idx)
EndFunction


'---------------------------------------------------------------
''' Writes blocks (1...12 with 128 Floats each) of data to media.
'''+  return value : Media status As described in Media_Stat() (Long) or
'''+                 40h -> number of blocks exceeding EOF, 
'''+                        no data written to media
'''  module: Module address (Long: 0...255)
'''  f_info[]: Name of array that holds the file informations
'''  file: File number (Long: 1...10)
'''  s_sec: Rel. sector number of start sector in file (Long: 1...m)
'''  s_cnt: Number of blocks with 128 Floats each (Long: 1...12)
'''  array[]: Source array to copy data from
'''  idx: First array element to copy from (Long: 1...n)
'''---------------------------------------------------------------
Function Media_WR_Blk_F(module, f_info[], file, s_sec, s_cnt, array[], idx) As Long
  Dim i, first, last, stat, type As Long
  last = f_info[file * 2 + 2]
  first = f_info[file * 2 + 1]
  If ((last - first + 2)<(s_sec + s_cnt)) Then
    stat = 40h                        'Block will be written beyond EOF!!!
  Else
    stat = Media_WFR(module, 26h, 150000)
    Media_WR_Cmd(module, 6, (s_sec - 1 + first), s_cnt)
    stat = Media_WFR(module, 26h, 150000)
    For i = 1 To s_cnt * 128
      Media_WR_Dat(module, Cast_FloatToLong(array[idx - 1 + i]))
    Next i
    stat = Media_Stat(module)
  EndIf
  Media_WR_Blk_F = stat
EndFunction


'---------------------------------------------------------------
''' Reads blocks (1...12 with 128 Longs each) of data from media.
'''+  return value : Media status As described in Media_Stat() (Long) or
'''+                 40h -> number of blocks exceeding EOF, 
'''+                        no data read from media
'''  module: Module address (Long: 0...255)
'''  f_info[]: Name of array that holds the file informations
'''  file: File number (Long: 1...10)
'''  s_sec: Rel. sector number of start sector in file (Long: 1...n)
'''  s_cnt: Number of blocks with 128 Longs/Floats each (Long: 1...12)
'''  array[]: Destination array to copy data to
'''  idx: First array element to copy To (Long: 1...n)
'''-------------------------------------------------------------
Function Media_RD_Blk_L(module, f_info[], file, s_sec, s_cnt, array[], idx) As Long
  Dim i, first, last, stat As Long

  last = f_info[file * 2 + 2]
  first = f_info[file * 2 + 1]
  If ((last - first + 2)<(s_sec + s_cnt)) Then
    stat = 40h                        'Block will be read beyond EOF!!!
  Else
    stat = Media_WFR(module, 26h, 150000)
    Media_WR_Cmd(module, 9, (s_sec - 1 + first), s_cnt)
    stat = Media_WFR(module, 26h, 150000)
    For i = 1 To s_cnt * 128
      array[idx - 1 + i] = Media_RD_Dat(module)
    Next i
    stat = Media_Stat(module)
  EndIf
  Media_RD_Blk_L = stat
EndFunction


'---------------------------------------------------------------
''' Reads blocks (1...12 with 128 Floats each) of data from media.
'''+  return value : Media status As described in Media_Stat() (Long) or
'''+                40h -> number of blocks exceeding EOF, 
'''+                       no data read from media
'''  module: Module address (Long: 0...255)
'''  f_info[]: Name of array that holds the file informations
'''  file: File number (Long: 1...10)
'''  s_sec: Rel. sector number of start sector in file (Long: 1...n)
'''  s_cnt: Number of blocks with 128 Longs/Floats each (Long: 1...12)
'''  array[]: Destination array to copy data to
'''  idx: First array element to copy To (Long: 1...n)
'''--------------------------------------------------------------
Function Media_RD_Blk_F(module, f_info[], file, s_sec, s_cnt, array[], idx) As Long
  Dim i, first, last, stat As Long

  last = f_info[file * 2 + 2]
  first = f_info[file * 2 + 1]
  If ((last - first + 2)<(s_sec + s_cnt)) Then
    stat = 40h                        'Block will be read beyond EOF!!!
  Else
    stat = Media_WFR(module, 26h, 150000)
    Media_WR_Cmd(module, 9, s_sec - 1 + first, s_cnt)
    stat = Media_WFR(module, 26h, 150000)
    For i = 1 To s_cnt * 128
      array[idx - 1 + i] = CAST_LongTOFloat(Media_RD_Dat(module))
    Next i
    stat = Media_Stat(module)
  EndIf
  Media_RD_Blk_F = stat
EndFunction


'---------------------------------------------------------------
''' Resets media and reads from sector 2 the file information table, 
'''+ where all start and end sectors of the data files are stored.
'''+ Unable to read sector 2 if RESET, BUSY, ERROR, no media in slot!
'''+  return value : Media status As described in Media_Stat() (Long)
'''  module: module address (Long: 1...255)
'''  array[]: Name of array (>= 22 elements) to store start & end sectors
'''---------------------------------------------------------------
Function Media_RD_FileInfo(module, array[]) As Long
  Dim n, stat As Long

  stat = Media_Stat(module)
  If ((stat And 1h) = 1h) Then
    Media_RST(module)
    stat = Media_WFR(module, 26h, 1200)
    Media_WR_Cmd(module, 9, 2, 1)
    stat = Media_WFR(module, 26h, 150000)
    For n = 1 To 22
      array[n] = Media_RD_Dat(module)
    Next n
  EndIf
  Media_RD_FileInfo = stat
EndFunction


'---------------------------------------------------------------
''' Real-Time-Clock (RTC):
' The 32 bit value holds the information for year, month, day, 
' hour, minute and second in the following manner:
'   bits: | 31:26 | 25:22 | 21:17 | 16:12 | 11:06 | 05:00 |
'   ------ + ------- + ------- + ------- + ------- + ------- + ------- + 
'         | year  | month |  day  | hour  |minute |second |

'---------------------------------------------------------------
' Writes the coded 32 bit word containing the date and time infor-
' mation to the RTC.
'  module: Module address (Long: 1...255)
'---------------------------------------------------------------
Sub RTC_WR(module, value)  ''<HIDE>
  Sub_Begin_Critical_Section
  Poke(ADWR, 16 Or Shift_Left(module, 8))
  NOP_T9
  Poke_NOP(D32, value)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
' Reads the coded 32 bit word containing the date and time information
' from the RTC.
'  module: Module address (Long: 1...255)
'---------------------------------------------------------------
Function RTC_RD(module) As Long  ''<HIDE>
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, 17 Or Shift_Left(module, 8))
  RTC_RD = Peek(D32)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Sets the RTC to the desired value. if any of the entries are not
'''+ valid neither value will be accepted and the RTC remains unchanged!
'''  module:   Module address (Long: 0...255)
'''  year:   Last two digits of the year 0...63 (Long)
'''  month:  1...12 (Long)
'''  day:    1...31 (Long)
'''  hour:   0...23 (Long)
'''  minute: 0...59 (Long)
'''  second: 0...59 (Long)
'''-------------------------------------------------------------
Sub RTC_Set(module, year, month, day, hour, min, sec)
  Dim value As Long

  value = 0
  value = Shift_Left(year And 3Fh, 26)                   'Bits 31:26
  value = value Or Shift_Left(month And 0Fh, 22)         'Bits 25:22
  value = value Or Shift_Left(day And 1Fh, 17)           'Bits 21:17
  value = value Or Shift_Left(hour And 1Fh, 12)          'Bits 16:12
  value = value Or Shift_Left(min And 3Fh, 6)            'Bits 11:06
  value = value Or (sec And 3Fh)                        'Bits 05:00
  RTC_WR(module, value)
EndSub


'---------------------------------------------------------------
''' Reads out the current date and time from the RTC at once.
'''+ Parameters are preferably Longs.
'''  module:   Module address (Long: 0...255)
'''  year:   Last two digits of the year 0...63 (Long)
'''  month:  1...12 (Long)
'''  day:    1...31 (Long)
'''  hour:   0...23 (Long)
'''  minute: 0...59 (Long)
'''  second: 0...59 (Long)
'''-------------------------------------------------------------
Sub RTC_Get(module, year, month, day, hour, min, sec)
  Dim value As Long

  value = RTC_RD(module)
  year = Shift_Right(value, 26) And 3Fh                'Bits 31:26
  month = Shift_Right(value, 22) And 0Fh               'Bits 25:22
  day = Shift_Right(value, 17) And 1Fh                 'Bits 21:17
  hour = Shift_Right(value, 12) And 1Fh                'Bits 16:12
  min = Shift_Right(value, 6) And 3Fh                  'Bits 11:06
  sec = value And 3Fh                                 'Bits 05:00
EndSub


'---------------------------------------------------------------
' Reads out the current year from the RTC (2000...2063).
'  module: Module address (Long: 0...255)
'---------------------------------------------------------------
Function RTC_Get_Year(module) As Long ''<HIDE>
  RTC_Get_Year = Shift_Right(RTC_RD(module), 26) + 2000
EndFunction


'---------------------------------------------------------------
' Reads out the current month from the RTC (1...12)
'  module: Module address (Long: 0...255)
'---------------------------------------------------------------
Function RTC_Get_Month(module) As Long ''<HIDE>
  RTC_Get_Month = Shift_Right(RTC_RD(module), 22) And 0Fh
EndFunction


'---------------------------------------------------------------
' Reads out the current day from the RTC
' (value ranges from 1...28/29/30/31 depending on month and leapyear)
'  module: Module address (Long: 0...255)
'---------------------------------------------------------------
Function RTC_Get_Day(module) As Long ''<HIDE>
  RTC_Get_Day = Shift_Right(RTC_RD(module), 17) And 1Fh
EndFunction


'---------------------------------------------------------------
' Reads out the current hour from the RTC (0...23, military notation)
'  module: Module address (Long: 0...255)
'---------------------------------------------------------------
Function RTC_Get_Hour(module) As Long ''<HIDE>
  RTC_Get_Hour = Shift_Right(RTC_RD(module), 12) And 1Fh
EndFunction


'---------------------------------------------------------------
' Reads out the current minute from the RTC (0...59)
'  module: Module address (Long: 0...255)
'---------------------------------------------------------------
Function RTC_Get_Minute(module) As Long ''<HIDE>
  RTC_Get_Minute = Shift_Right(RTC_RD(module), 6) And 3Fh
EndFunction


'---------------------------------------------------------------
' Reads out the current second from the RTC (0...59)
'  module: Module address (Long: 0...255)
'---------------------------------------------------------------
Function RTC_Get_Second(module) As Long ''<HIDE>
  RTC_Get_Second = RTC_RD(module) And 3Fh
EndFunction


'---------------------------------------------------------------
' COMP 16
'---------------------------------------------------------------
''' SET HYSTERESIS SWITCH POINTS
''' module: module address (0..255)
''' channel: channel (1..16)
''' value_high switch point to set output bit to 1
''' value_low switch point to set output bit to 0
'''-------------------------------------------------------------
Sub Comp_Set(module, channel, value_high, value_low)
  Dim addr As Long
  Dim ch, high, low As Long

  addr = 20 Or (Shift_Left(module, 8))
  ch = Shift_Left(((channel - 1) And 0Fh), 20)
  high = Shift_Left((value_high And 3FFh), 10)
  low = value_low And 3FFh

  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, (ch Or high Or low))
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Reads the digital inputs (channel 0..15)
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Comp_Digin_Word(module) As Long
  Dim addr As Long

  addr = 16 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Comp_Digin_Word = Peek(DLX)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Reads the digital inputs (channel 0..7) by diff
''' module: module address (0..255)
'''-------------------------------------------------------------
Function Comp_Digin_Word_Diff(module) As Long
  Dim addr As Long
  addr = 23 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Comp_Digin_Word_Diff = Peek(D32)
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Reads the analog value, min value or max value
''' module: module address (0..255)
''' channel: nummber of channel (1..16)
''' select_val: 
'''+         0 = read value
'''+         1 = read min value
'''+         2 = read max value
'''-------------------------------------------------------------
Function Comp_Read(module, channel, select_val) As Long
  Dim addr As Long
  Dim value As Long

  addr = (23 + channel) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  value = Peek(D32)
  Sub_End_Critical_Section

  Comp_Read = (Shift_Right(value, (10 * select_val))) And 3FFh
EndFunction


'---------------------------------------------------------------
''' RESET min / max value (max = 0 min = 1024)
''' module: module address (0..255)
''' pattern: each bit corresponds to a channel
'''-------------------------------------------------------------
Sub Comp_Reset(module, pattern)
  Dim addr As Long

  addr = 21 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, (pattern))
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Select the channels to write to the internal FIFO
''' module: module address (0..255)
''' pattern: bit0 = channel 1/2, bit1 = channel 3/4 ...
'''-------------------------------------------------------------
Sub Comp_FIFO_Select(module, pattern)
  Dim addr As Long

  addr = 17 Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, (pattern + 1))
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' reads the last 2 x 1 024 measurement values of a channel pair from the internal FIFO memory and transfers the values to 2 arrays.
''' module: module address (0..255)
''' arrayLowChannel[]: values of low channels
''' arrayHighChannel[]: values of high channels
'''---------------------------------------------------------------
Sub Comp_FIFO_Read(module, arrayLowChannel[], arrayHighChannel[])
  Dim addr As Long
  Dim i As Long
  Dim value As Long
  Dim select As Long

  addr = 18 Or (Shift_Left(module, 8))
  'read select for new start
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRd, addr - 1)
  NOP_T9
  select = Peek(Dlx)
  NOP_T9
  Sub_End_Critical_Section

  'stop write to FIFO
  Sub_Begin_Critical_Section
  Poke(ADWR, addr - 1)
  NOP_T9
  Poke_NOP(D32, (0))
  Sub_End_Critical_Section

  'set adress
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, 0)
  Sub_End_Critical_Section

  'read value
  For i = 1 To 1024
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr - 4)
    value = Peek(D32)
    Sub_End_Critical_Section
    arrayHighChannel[i] = value And 0FFFFh
    arrayLowChannel[i] = Shift_Right(value, 16)
  Next

  'start write to FIFO
  Sub_Begin_Critical_Section
  Poke(ADWR, addr - 1)
  NOP_T9
  Poke_NOP(D32, select)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
' calculates address value
'---------------------------------------------------------------
Function Functions_Wert(befehl, module, typ) As Long ''<HIDE>
  Functions_Wert = (befehl Or typ) Or (Shift_Left(module, 8))
EndFunction

'---------------------------------------------------------------
'''  switches a LED on or off
'''  module:     module address (0..255)
'''  moduletype: type of module (AD, DA, DIO, EXT)
'''  value:      0->off, 1->on
'''-------------------------------------------------------------
Sub SetLED(module, moduletype, value)
  Dim addr As Long

  If (moduletype = cpu) Then
    Sub_Begin_Critical_Section
    Poke(CPU_LED, value)
    NOP_T9
    Sub_End_Critical_Section
  Else
    addr = Functions_Wert(42, module, moduletype)
    Sub_Begin_Critical_Section
    Poke(ADWR, addr)
    NOP_T9
    Poke_NOP(DLX, value)
    Sub_End_Critical_Section
  EndIf
EndSub


'---------------------------------------------------------------
'''  checks the LED on a module
'''  module:    module address (0..255)
'''  moduletype: type of module (AD, DA, DIO, EXT)
'''-------------------------------------------------------------
Function CheckLED(module, moduletype) As Long
  Dim addr As Long

  If (moduletype = cpu) Then
    Sub_Begin_Critical_Section
    CheckLED = (Peek(CPU_LED) And 1)
    NOP_T9
    Sub_End_Critical_Section
  Else
    addr = Functions_Wert(42, module, moduletype)
    Sub_Begin_Critical_Section
    Poke_NOP_RD(ADRD, addr)
    CheckLED = Peek(DLX) And 1
    NOP_T9
    Sub_End_Critical_Section
  EndIf
EndFunction


'---------------------------------------------------------------
'''  activates or deactivates the external Event input
'''  module:    module address (0..255)
'''  moduletype: type of module (AD, DA, DIO, EXT)
'''  value:     
'''+  0->deactivate 
'''+  1->activate
'''---------------------------------------------------------------
Sub EventEnable(module, moduletype, value)
  Dim addr As Long

  Sub_Begin_Critical_Section
  Poke(cpu_EVENT, 256 * value)              'enable the EVENT on the processormodule
#If PROZESSOR = T11 Then
  Bus_Sleep(9)
#EndIf
  Sub_End_Critical_Section
  addr = Functions_Wert(56, module, moduletype)
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, 9 - value)                ' EVENT on module
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''  Define whether rising/falling edge is triggering the Event
'''  module:    module address
'''  moduletype: type of module (AD, DA, DIO, EXT)
'''  value:    
'''+          0  rising edge              (= steigende Flanke)
'''+          1  rising edge              (= steigende Flanke)
'''+          2  falling edge             (= fallende Flanke)
'''+          3  rising and falling edge  (= beide Flanken)
'---------------------------------------------------------------
Sub EventSource(module, moduletype, value) ''<HIDE>
  Dim addr As Long

  addr = Functions_Wert(59, module, moduletype)
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, value)          'EVENTSOURCE on module
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''  activate- or deactivate the Sync-function of a module
'''  module:    module address (0..255)
'''  moduletype: type of module
'''  enable:    
'''+             0->deactivate, 
'''+             1->activate
'''---------------------------------------------------------------
Sub SyncEnable(module, moduletype, enable)
  Dim addr As Long

  addr = Functions_Wert(58, module, moduletype)
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(DLX, enable)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' latch all those modules, which have been activated with the
''' SyncEnable command
'---------------------------------------------------------------
Sub SyncAll()
  Sub_Begin_Critical_Section
  Poke(ADWR, 52)
  NOP_T9
  Poke_NOP(DLX, 255)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''  checks, whether the Sync-function of a module is activated
'''+  result:    0->activated, 1->deactivated
'''  module:    module address (0..255)
'''  moduletype: type of module (AD, DA, DIO, EXT)
'''---------------------------------------------------------------
Function SyncStat(module, moduletype) As Long
  Dim addr As Long

  addr = Functions_Wert(58, module, moduletype)
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  SyncStat = Peek(DLX) And 1
  NOP_T9
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
' commands for processor module
'---------------------------------------------------------------
'---------------------------------------------------------------
''' activate watchdog
'''-------------------------------------------------------------
Sub StartWatchdog()
  Sub_Begin_Critical_Section
  Poke(watchdog, 1)
  NOP_T9
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' deactivate watchdog
'''-------------------------------------------------------------
Sub StopWatchdog()
  Sub_Begin_Critical_Section
  Poke(watchdog, 0)
  NOP_T9
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' reset the watchdog timer
'''+ If the watchdog is activated, the user program has to call
'''+ this function at least every 80ms.
'''+ the minimum time interval is 1600 ms.
'---------------------------------------------------------------
Sub ResetWatchdogTimer()
  Sub_Begin_Critical_Section
  Poke(WD_TIMER, 1)
  NOP_T9
  Sub_End_Critical_Section
EndSub


'-----------------Thermocouple
'---------------------------------------------------------------
''' Setting the thermocouple multipexer
'''  module:  module address (0..255)
''' channel: multiplexer channel
'''-------------------------------------------------------------
Sub TC_Select(module, channel)
  Dim addr As Long

  addr = 0D0h Or (Shift_Left(module, 8))

  Sub_Begin_Critical_Section
  Poke (ADWR, addr)
  NOP_T9
  Poke_NOP (DLX, channel - 1)
  Sub_End_Critical_Section
EndSub


'-------------------serial interface
'---------------------------------------------------------------
''' Setting a register of the seriell controller
''' module:      module address (0..255)
''' register_no: register on the serial controller
''' value:      value for the selected register
'''---------------------------------------------------------------
Sub Set_RS(module, register_no, value)
  Dim addr As Long

  addr = (0C0h + register_no) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke (adwr, addr)
  NOP_T9
  Poke_NOP (dlx, value)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' reads the value of a register of the serial controller
''' module:      module address (0..255)
''' register_no: register on the serial controller
'''-------------------------------------------------------------
Function Get_RS(module, register_no) As Long
  Dim addr As Long

  addr = (0C0h + register_no) Or (Shift_Left(module, 8))
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrd, addr)
  Get_RS = Peek(DLX)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Initialisation of a serial interface
''' module:      module address (0..255)
''' channel: number of the serial interface (one ADwin-Pro module contains 2 or 4 interfaces)
''' Baud: Baudrate for the serial comunication
'''+ 2304000
'''+ 1152000
'''+  460800
'''+  230400
'''+  115200
'''+   57600
'''+   38400
'''+   19200
'''+    9600
'''+    4800
'''+    2400
'''+    1200
'''+     600
'''+     300
''' parity :     
'''+           0 = no parity
'''+           1 = even
'''+           2 = odd
''' bits: Number of databits for the serial comunication(5..8)
''' stop         
'''+           0 = 1 Stopbit
'''+           1 = 1, 5 Stopbits by using 5 Databits
'''+           1 = 2 Stopbits bei 6, 7 by using 8 Databits
''' handshake:   
'''+           0 = RS-232 no handshake
'''+           1 = RS-232 Hardware handshake (RTS/CTS)
'''+           2 = RS-232 Software handshake (Xon/Xoff)
'''+           3 = RS-485 no handshake
'''---------------------------------------------------------------
Sub RS_Init(module, channel, baud, parity, bits, stop, handshake)
  Dim hard_addr As Long                                        ' physical address of the ADwin module (basic address)
  Dim offset As Long                                           ' offset for the selected serial interface
  Dim divisor As Long                                          ' value by which the external clock has to be divided to get the selected baudrate
  Dim dll_value As Long                                        ' value for the DLL register
  Dim dlh_value As Long                                        ' value for the DLH register
  Dim lcr_value As Long                                        ' value for the LCR register

  offset = ((channel - 1) And 1) * 8
  If (channel >= 3) Then                                       ' for ADwin-Pro modules with more the 2 serial interfaces
    hard_addr = module + 1                                     ' The hardware address for the serial interfaces 3 and 4 is dip switch + 1
  Else
    hard_addr = module                                         ' The hardware address for the serial interfaces 3 and 4 is dip switch
  EndIf
  divisor = (36864000/1) / (baud * 16)                         ' calculates the the divider for the external clock
  dll_value = divisor And 0FFh                                 ' value for the DLL register
  dlh_value = Shift_Right((divisor And 0FF00h), 8)             ' value for the DLH register

  lcr_value = bits - 5
  lcr_value = lcr_value Or Shift_Left(stop, 2)
  If (parity = 1) Then lcr_value = lcr_value Or 011000b
  If (parity = 2) Then lcr_value = lcr_value Or 001000b        'value for the LCR register

  Set_RS(hard_addr, offset + 3, 080h)                          ' LCR-bit7 = 1    Divisor latch enable
  Set_RS(hard_addr, offset + 0, dll_value)                     ' DLL-reg: setting baudrate
  Set_RS(hard_addr, offset + 1, dlh_value)                     ' DLH-reg: setting baudrate
  Set_RS(hard_addr, offset + 3, (0BFh))                        ' LCR-reg: Enhanced feature reg enable
  Set_RS(hard_addr, offset + 4, 011h)                          ' setting character for softwarehandshake Xon1
  Set_RS(hard_addr, offset + 5, 012h)                          ' setting character for softwarehandshake Xon2
  Set_RS(hard_addr, offset + 6, 013h)                          ' setting character for softwarehandshake Xoff1
  Set_RS(hard_addr, offset + 7, 014h)                          ' setting character for softwarehandshake Xoff2
  If (handshake = 0) Then
    Set_RS(hard_addr, offset + 2, 010h)                        ' EFR-reg: no handshake(RS232) + enhanced functions enabeld
  EndIf
  If (handshake = 1) Then
    Set_RS(hard_addr, offset + 2, 0D0h)                        ' EFR-reg: hardware handshake(RS232) + enhanced functions enabeld
  EndIf
  If (handshake = 2) Then
    Set_RS(hard_addr, offset + 2, 01Ah)                        ' EFR-reg: software handshake(RS232) (Xon1/Xoff1) + enhanced functions enabeld
  EndIf
  If (handshake = 3) Then
    Set_RS(hard_addr, offset + 2, 090h)                        ' EFR-reg: no handshake (RS485) + enhanced functions enabeld
  EndIf
  Set_RS(hard_addr, offset + 3, lcr_value)                     ' LCR-reg: Divisor latch disable; 8 Databits
  Set_RS(hard_addr, offset + 4, 040h)                         ' MCR reg: enable access to TCR and TLR register
  Set_RS(hard_addr, offset + 6, 087h)                         ' TCR reg: FIFO trigger level
  Set_RS(hard_addr, offset + 4, 04h)                          ' MCR reg: FIFOrdy reg enable; is necessary to get status information of the FIFO
  Set_RS(hard_addr, offset + 2, 0Fh)                           ' FCR-reg: FIFOs enable, FIFOs clear, DMA Mode1
EndSub


'---------------------------------------------------------------
''' Reset for ADwin module (serial interface module)
''' module:  module address (0..255)
'''---------------------------------------------------------------
Sub RS_Reset(module)
  Set_RS(module, 23, 1)                             ' reset active
  Set_RS(module, 23, 0)                             ' reset not active
EndSub


'---------------------------------------------------------------
''' Writes a byte to the transmit FIFO, If the FIFO is not full
'''+ return value: 0 = byte is written
'''+               1 = FIFO full
''' module: module address (0..255)
''' channel: number of the serial interface (one ADwin-Pro module contains 2 or 4 interfaces)
''' value:   value which should be written to the FIFO
'''-------------------------------------------------------------
Function Write_FIFO(module, channel, value) As Long
  Dim hard_addr As Long                         ' physical address of the ADwin module (basic address)
  Dim offset As Long                            ' offset for the selected serial interface
  Dim bit As Long
  Dim fifo_free As Long                         ' FIFO status

  bit = channel
  hard_addr = module

  If (channel = 2) Then bit = 08h               ' select the bit, which indicates the status of the selected FIFO
  If (channel = 3) Then bit = 02h

  If (channel >= 3) Then  hard_addr = hard_addr + 1
  offset = ((channel - 1) And 1) * 8
  fifo_free = Get_RS(hard_addr, 7 + offset) And bit
  If (fifo_free <> 0) Then                     ' If the FIFO is not full Then the byte is written
    Set_RS(hard_addr, offset, value)             ' Write byte to transmit FIFO
    Write_FIFO = 0                              ' return value: byte is written successfully to the transmit FIFO
  Else
    Write_FIFO = 1                              ' return value: FIFO full; byte is not written
  EndIf
EndFunction


'---------------------------------------------------------------
''' checks if there is any more data to transmit
'''+ return value: 
'''+             0 = Shift register and transmit hold are empty
'''+             1 = Shift register and transmit hold are not empty
''' module:  module address (0..255)
''' channel: number of the serial interface (one ADwin-Pro module contains 2 or 4 interfaces)
'''-------------------------------------------------------------
Function Check_Shift_Reg(module, channel) As Long
  Dim hard_addr As Long                         ' physical address of the ADwin module (basic address)
  Dim offset As Long                            ' offset for the selected serial interface
  Dim status As Long                            ' status byte

  offset = ((channel - 1) And 1) * 8
  If (channel >= 3) Then
    hard_addr = module + 1
  Else
    hard_addr = module
  EndIf
  status = Get_RS(hard_addr, offset + 5) And 64  ' read status byte
  If (status = 64) Then
    Check_Shift_Reg = 0
  Else
    Check_Shift_Reg = 1
  EndIf
EndFunction


'---------------------------------------------------------------
''' Read byte from the receive FIFO
'''+ return value: 0..255 = value of the received byte
'''+                  -1 = no bytes in the receive FIFO
''' module:  module address (0..255)
''' channel: number of the serial interface (one ADwin-Pro module contains 2 or 4 interfaces)
'''-------------------------------------------------------------
Function Read_FIFO(module, channel) As Long
  Dim hard_addr As Long                         ' physical address of the ADwin module (basic address)
  Dim bit As Long
  Dim offset As Long                            ' offset for the selected serial interface
  Dim fifo_status As Long                       ' FIFO status

  offset = ((channel - 1) And 1) * 8
  If (channel >= 3) Then
    hard_addr = module + 1
  Else
    hard_addr = module
  EndIf
  fifo_status = Get_RS(hard_addr, offset + 5) And 1
  If (fifo_status <> 0) Then                   ' read byte, if there is a byte in the receive FIFO
    Read_FIFO = Get_RS(hard_addr, offset)       ' read byte from receive FIFO (return value = value of the received byte)
  Else
    Read_FIFO = -1                             ' no new byte in the receive FIFO (return value = -1)
  EndIf
EndFunction


'---------------------------------------------------------------

''' Selects whether the interface is sending data or is listening on the bus.
'''+Only for RS485.
''' module:  module address (0..255)
''' channel: number of the serial interface (one ADwin-Pro module contains 2 or 4 interfaces)
'''dir:
'''+          0 = Listening
'''+          1 = Sending Data
'''+          2 = Sending Data + Listening
'''---------------------------------------------------------------
Sub RS485_Send(module, channel, dir)
  Dim hard_addr As Long                        ' physical address of the ADwin module (basic address)
  Dim offset As Long                           ' offset for the selected serial interface
  Dim reg_value As Long

  If (dir = 0) Then reg_value = 5
  If (dir = 1) Then reg_value = 6
  If (dir = 2) Then reg_value = 7
  offset = ((channel - 1) And 1) * 8
  If (channel >= 3) Then
    hard_addr = module + 1
  Else
    hard_addr = module
  EndIf
  Set_RS(hard_addr, offset + 4, reg_value)       'setting the RTS-Pin
EndSub


'------------------CAN

'---------------------------------------------------------------
''' Enables a message object for receiving messages.
'''+Disables all interrups of the message object.
''' module:  module address (0..255)
''' channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
''' msg_no:  Number of the message object
''' identifier: incomming frames are accepted by this message object, if the identifier matches the frame identifier
''' extended: Determines whether the identifier is 11 or 29 Bit
'''+             0 = 11 Bit identifier
'''+             1 = 29 Bit identifier
'''---------------------------------------------------------------
Sub En_Receive(module, channel, msg_no, identifier, extended)
  Set_CAN_Reg(module, channel, (msg_no) * 16, 149)                                       'enable message object
  If (extended = 0) Then
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 6, 128)                                 'read; DLC = 8 ; 11 Bit identifier
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 3) And 255))  'Set identifier
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 3, (Shift_Left(identifier, 5) And 255))
  Else
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 6, 132)                                 'read; DLC = 8 ; 29 Bit identifier
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 21) And 255)) 'Set identifier
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 3, (Shift_Right(identifier, 13) And 255))
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 4, (Shift_Right(identifier, 5) And 255))
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 5, (Shift_Left(identifier, 3) And 255))
  EndIf
EndSub


'---------------------------------------------------------------
''' Enables a message object for transmitting messages.
'''+ Disables all interrups of the message object.
''' module:  module address (0..255)
''' channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
''' msg_no:  Number of the message object
''' identifier: identifier for the frames which will be transmitted
''' extended: Determines whether the identifier is 11 or 29 Bit
'''+             0 = 11 Bit identifier
'''+             1 = 29 Bit identifier
'''---------------------------------------------------------------
Sub En_Transmit(module, channel, msg_no, identifier, extended)
  Dim bit As Long
  Set_CAN_Reg(module, channel, (msg_no) * 16, 149)                                       'enable message object
  If ((extended And 2) = 0) Then
    bit = 0
  Else
    bit = 8
  EndIf
  If ((extended And 1) = 0) Then
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 6, (136 - bit))                          'write; DLC = 8 ; 11 bit identifier
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 3) And 255))   'Set identifier
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 3, (Shift_Left(identifier, 5) And 255))
  Else
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 6, (140 - bit))                          'write; DLC = 8 ; 29 bit identifier
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 21) And 255))  'Set identifier
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 3, (Shift_Right(identifier, 13) And 255))
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 4, (Shift_Right(identifier, 5) And 255))
    Set_CAN_Reg(module, channel, (msg_no) * 16 + 5, (Shift_Left(identifier, 3) And 255))
  EndIf
EndSub


'---------------------------------------------------------------
''' Initialisation of the CAN-controller.
'''+ All message objects will be disabled.
'''+ Bitrate: 1MBit/s
'''+ Acceptance filter : Must match
''' module:  module address (0..255)
''' channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''---------------------------------------------------------------
Sub Init_CAN(module, channel)
  Dim counter As Long
  Dim addr As Long

  addr = 0C0h Or (Shift_Left(module, 8)) Or (38 + channel)
  Sub_Begin_Critical_Section
  Poke(adwr, addr)                                          ' Reset the CAN-Controllers (Hardwarereset)
  NOP_T9
  Poke_NOP(dlx, 1)
  Sub_End_Critical_Section
  P1_Sleep(100000)                                            ' Reset pin must be low for at least 1 ms

  Sub_Begin_Critical_Section
  Poke(adwr, addr)
  NOP_T9
  Poke_NOP(dlx, 0)
  Sub_End_Critical_Section

  Set_CAN_Reg(module, channel, 0, 65)                           'Access to the registers of the controller only for CPU
  Set_CAN_Reg(module, channel, 2, 65)                           'CPU interface register
  
  for counter=6 to 15
    Set_CAN_Reg(module, channel, counter, 0FFh)                       'Setting all masks to "must match"
  next  
  'Set_CAN_Reg(module, channel, 06h, 0FFh)                       'Setting all masks to "must match"
  'Set_CAN_Reg(module, channel, 07h, 0FFh)
  'Set_CAN_Reg(module, channel, 08h, 0FFh)
  'Set_CAN_Reg(module, channel, 09h, 0FFh)
  'Set_CAN_Reg(module, channel, 0Ah, 0FFh)
  'Set_CAN_Reg(module, channel, 0Bh, 0FFh)
  'Set_CAN_Reg(module, channel, 0Ch, 0FFh)
  'Set_CAN_Reg(module, channel, 0Dh, 0FFh)
  'Set_CAN_Reg(module, channel, 0Eh, 0FFh)
  'Set_CAN_Reg(module, channel, 0Fh, 0FFh)
  Set_CAN_Reg(module, channel, 01Fh, 0)                         ' Clock Out Register
  Set_CAN_Reg(module, channel, 02Fh, 0)                         ' Bus configuration register
  Set_CAN_Reg(module, channel, 03Fh, 0)                         ' Bit Timing register 0
  Set_CAN_Reg(module, channel, 04Fh, 032h)                      ' Bit Timing register 1

  For counter = 1 To 15                                       'Disable all message objects
    Set_CAN_Reg(module, channel, counter * 16, 85)
    Set_CAN_Reg(module, channel, counter * 16 + 1, 85)
  Next counter
  Set_CAN_Reg(module, channel, 0, 0)                            'Access to the registers of the controller only for Application
EndSub


'---------------------------------------------------------------
' Aid sub for Read_Msg_Con and Read_Msg.
'---------------------------------------------------------------
Sub read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_lenght)''<HIDE>
  Dim counter As Long
  Dim buffer As Long

  buffer = (Get_CAN_Reg(module, channel, (msg_no) * 16 + 6))
  CAN_msg[9] = Shift_Right((buffer And 0F0h), 4)             ' Number of databytes
  id_lenght = buffer And 4
  id0 = Get_CAN_Reg(module, channel, (msg_no) * 16 + 2)         ' identifier registers
  id1 = Get_CAN_Reg(module, channel, (msg_no) * 16 + 3)
  If (id_lenght = 4) Then
    id2 = Get_CAN_Reg(module, channel, (msg_no) * 16 + 4)
    id3 = Get_CAN_Reg(module, channel, (msg_no) * 16 + 5)
  EndIf
  For counter = 1 To CAN_msg[9]                             ' reading databytes
    CAN_msg[counter] = Get_CAN_Reg(module, channel, ((msg_no) * 16)  + counter + 6)
  Next counter
EndSub


'---------------------------------------------------------------
''' The function checks, if there is a new frame in the selected
'''+ message object. If there is a new frame all databytes are read
'''+ and then written to the array "CAN_msg".
'''+ The number of dadabytes is written to the element 9 of the array "CAN_msg".
'''+ The return value of the function is the identifier of the frame.
'''+ If there is no new frame in the message box the return value is -1.
''' module:  module address (0..255)
''' channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
''' msg_no: number of the message object
'''---------------------------------------------------------------
Function Read_Msg(module, channel, msg_no) As Long
  Dim new As Long                                             ' new message in the message object
  Dim id0, id1, id2, id3 As Long                                 ' identifier Byte 0 and 1
  Dim id_lenght As Long                                       ' buffer to distinguish 11 and 29 bit identifier

  new = Get_CAN_Reg(module, channel, (msg_no) * 16 + 1) And 3   ' Check, if a new frame in arrived
  If (new = 2) Then                                            ' New frame is arrived
    read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_lenght)
    Set_CAN_Reg(module, channel, (msg_no) * 16, 0FDh)           ' reset interrupt
    Set_CAN_Reg(module, channel, (msg_no) * 16  + 1, 85)        ' reset the new data flag
    If (id_lenght = 0) Then
      Read_Msg = (Shift_Right(id1, 5)) Or (Shift_Left(id0, 3))  ' return value = 11 bit identifier
    Else
      Read_Msg = (Shift_Right(id3, 3)) Or (Shift_Left(id2, 5)) Or (Shift_Left(id1, 13)) Or (Shift_Left(id0, 21))        ' return value = 29 bit identifier
    EndIf
  Else
    Read_Msg = -1                                             ' return value = 0
  EndIf
EndFunction


'---------------------------------------------------------------
''' The function checks, if there is a new frame in the selected
'''+ message object. If there is a new frame all databytes are read
'''+ and then written to the array "CAN_msg".
'''+ The number of databytes is written to the element 9 of the array "CAN_msg".
'''+ The return value of the function is the identifier of the frame.
'''+ If there is no new frame in the message box the return value is -1.
'''+ Checks the consistens of the data and if they ars not consistent
'''+ the datas will be reread.
''' module:  module address (0..255)
''' channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
''' msg_no: number of the message object
'''---------------------------------------------------------------
Function Read_Msg_Con(module, channel, msg_no) As Long
  Dim new As Long                                             ' new message in the message object
  Dim id_lenght As Long                                       ' buffer to distinguish 11 and 29 bit identifier
  Dim id0, id1, id2, id3 As Long                                 ' identifier Byte 0 and 1

  new = Get_CAN_Reg(module, channel, (msg_no) * 16 + 1) And 3     ' Check, if a new frame in arrived
  If (new = 2) Then                                           ' New frame is arrived
    If (msg_no = 15) then
      read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_lenght)
      Set_CAN_Reg(module, channel, (msg_no) * 16, 0FDh)                                            ' reset interrupt
      Set_CAN_Reg(module, channel, (msg_no) * 16 + 1, 85)                                          ' reset the new data flag
      new = Get_CAN_Reg(module, channel, (msg_no) * 16 + 1) And 3                                  ' Check, if a new frame in arrived
      If (new = 2) Then                                                                             ' New frame is arrived
        read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_lenght)
        Set_CAN_Reg(module, channel, (msg_no) * 16, 0FDh)                                          ' reset interrupt
        Set_CAN_Reg(module, channel, (msg_no) * 16 + 1, 85)                                        ' reset the new data flag
      endif
    else
      Set_CAN_Reg(module, channel, (msg_no) * 16  + 1, 85)        ' reset the new data flag
      read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_lenght)
      new = Get_CAN_Reg(module, channel, (msg_no) * 16 + 1) And 3     ' Check, if a new frame in arrived
      If (new = 2) Then                                           ' New frame is arrived
        read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_lenght)
        Set_CAN_Reg(module, channel, (msg_no) * 16  + 1, 85)        ' reset the new data flag
      endif
      Set_CAN_Reg(module, channel, (msg_no) * 16, 0FDh)           ' reset interrupt
    endif  
      
    If (id_lenght = 0) Then
      Read_Msg_Con = (Shift_Right(id1, 5)) Or (Shift_Left(id0, 3))  ' return value = 11 bit identifier
    Else
      Read_Msg_Con = (Shift_Right(id3, 3)) Or (Shift_Left(id2, 5)) Or (Shift_Left(id1, 13)) Or (Shift_Left(id0, 21))        ' return value = 29 bit identifier
    EndIf
  Else
    Read_Msg_Con = -1                                             ' return value = 0
  EndIf
EndFunction


'---------------------------------------------------------------
''' Transmitting a frame.
'''+ The databytes and the number of databytes have to be written in the
'''+ array "CAN_msg" before this subroutine is activated.
'''+ After this subroutine the frame is transmitted as soon as the
'''+ CAN-bus allows it.
''' module:  module address (0..255)
''' channel: number of the CAN interface on the CAN module
''' msg_no : number of the message object
'''-------------------------------------------------------------
Sub Transmit(module, channel, msg_no)
  Dim buffer As Long
  Dim counter As Long

  For counter = 1 To CAN_msg[9]
    Set_CAN_Reg(module, channel, ((msg_no) * 10h) + counter + 6, CAN_msg[counter])       'copy datas
  Next counter

  ' Anzahl der Datenbytes bergeben
  buffer = Get_CAN_Reg(module, channel, ((msg_no) * 10h) + 6)      'read register
  buffer = buffer And 0Fh                                     'change DLC Bits
  buffer = buffer Or Shift_Left(CAN_msg[9], 4)
  Set_CAN_Reg(module, channel, (msg_no) * 16  + 6, buffer)          'write register
  Set_CAN_Reg(module, channel, (msg_no) * 16  + 1, 102)           ' Control register (setting bit to transmit data)
EndSub




'---------------------------------------------------------------
''' Checking if a Messagebox is ready to send. (The last Message is
'''+ alrady send)
'''+ return: 
'''+         Bit 0 = ready to send
'''+         Bit 1 = not ready to send
''' module:  module address (0..255)
''' channel: number of the CAN interface on the CAN module
'''       msg_no : number of the message object
'''---------------------------------------------------------------
Function Transmit_Status(module, channel, msg_no) as long
  Transmit_Status = shift_right(P2_Get_CAN_Reg(module, channel, ((msg_no) * 10h) + 1), 5) and 1    ' Control 1register
EndFunction


'---------------------------------------------------------------
''' Enable the interrupt of a message object.
''' module:  module address (0..255)
''' channel: number of the CAN interface on the CAN module
''' msg_no: number of the message object
'''---------------------------------------------------------------
Sub En_Interrupt(module, channel, msg_no)
  Set_CAN_Reg(module, channel, (msg_no) * 16, 0EBh)              'Enable interrupt of the message object.
  Set_CAN_Reg(module, channel, 0, 02h)                         'Enable global interrupt.
EndSub


'---------------------------------------------------------------
''' Setting a register of the CAN-controller.
''' module:  module address (0..255)
''' channel: number of the CAN interface on the CAN module
''' regno: register which should be set
''' value: value which should be written to the register.
'''-------------------------------------------------------------
Sub Set_CAN_Reg(module, channel, regno, value)
  Dim addr1 As Long
  Dim addr2 As Long
  addr1 = 0C0h Or (Shift_Left(module, 8)) Or ((channel - 1) * 8)
  addr2 = addr1 Or (1 + ((channel - 1) * 8))

  Sub_Begin_Critical_Section
  Poke(adwr, addr2)
  NOP_T9
  Poke_NOP(dlx, regno)
  Poke(adwr, addr1)
  NOP_T9
  Poke_NOP(dlx, value)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Reading a register of the CAN-controller.
'''+ return value : value of the register
''' module: module address  (0..255)
''' channel: number of the CAN interface on the CAN module
'''+          (also necessary if the module provides only one channel)
''' regno: register to read
'''---------------------------------------------------------------
Function Get_CAN_Reg(module, channel, regno) As Long
  Dim addr1 As Long
  Dim addr2 As Long

  addr1 = 0C0h Or (Shift_Left(module, 8)) Or ((channel - 1) * 8)
  addr2 = addr1 Or (2 + ((channel - 1) * 8))

  Sub_Begin_Critical_Section
  Poke(adwr, addr2)
  NOP_T9
  Poke_NOP(dlx, regno)
  Bus_Sleep(60)
  Poke_NOP_RD(adrd, addr1)
  Get_CAN_Reg = Peek(dlx) And 255
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
' Reading the register where the bus error pin of the tranceiver
' is stored.
' The register is set when the a bus error occurs and is reset by
' reading the register.
' module:  module address (0..255)
' channel : number of the CAN interface on the CAN module
'          (also necessary if the module provides only one channel)
' return value : 0 = no error
'                1 = error
' Attention: This command is only for low-speed CAN
'---------------------------------------------------------------
Function Get_Line_Status(module, channel) As Long ''<HIDE>
  Dim addr As Long

  addr = 0C0h Or Shift_Left(module, 8) Or (3Dh - channel)
  Sub_Begin_Critical_Section
  Poke_NOP_RD(ADRD, addr)
  Get_Line_Status = Peek(DLX)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
'Function only For internal use.
'---------------------------------------------------------------
Function Round(value) As Long ''<HIDE>
  Dim buffer As Float

  buffer = value + 0.5
  Round = buffer
EndFunction


'---------------------------------------------------------------
'Function only For internal use.
'---------------------------------------------------------------
Function Int_Check(fl, int) As Long ''<HIDE>
  Dim fbuffer As Float

  fbuffer = fl - int
  If ((fbuffer >= 0.00001) Or (fbuffer <= -0.00001)) Then
    Int_Check = 1                               'not equal
  Else
    Int_Check = 0                               'equal
  EndIf
EndFunction


'---------------------------------------------------------------
''' Function is setting the baudrate of the CAN-Bus.
'''+ return value: 
'''+              0 = baudrate is set
'''+              1 = the selected baudrate is not set
''' module:  module address  (0..255)
''' channel: number of the CAN interface on the CAN module
'''+          (also necessary if the module provides only one channel)
''' baud: CAN-Bus baudrate
'''---------------------------------------------------------------
Function Set_CAN_Baudrate(module, channel, baud) As Long
  Dim scale As Long
  Dim fbuffer As Float
  Dim lbuffer As Long
  Dim back As Long
  Dim tseg1 As Long
  Dim tseg2 As Long
  Dim brp As Long
  Dim btr0 As Long
  Dim btr1 As Long

  Set_CAN_Baudrate = 0                                   'Initialisation
  fbuffer = 8000000 / baud
  scale = Round(fbuffer)                                 'total scale to achive the baudrate
  Set_CAN_Baudrate = Int_Check(fbuffer, scale)            '1 if baudrate not possible
  If (Set_CAN_Baudrate = 0) Then                         'If baudrate possible then find settings
    brp = (scale - 1) / 25                               'Prescaler
    Do                                                   'find the right brp
      fbuffer = (scale / (brp + 1) - 3)
      lbuffer = Round(fbuffer)
      back = Int_Check(fbuffer, lbuffer)                  'Inc prescaler Until tseg1 + tseg 2 is an Long
      Inc(brp)
    Until((back = 0) Or (fbuffer<5))
    Dec(brp)
    If (back <> 0) Then Set_CAN_Baudrate = 1
  EndIf

  If (Set_CAN_Baudrate = 0) Then                         'If there is a correct prescaler
    tseg2 = lbuffer * 0.4
    tseg1 = lbuffer - tseg2
    If (tseg2 > 7) Then
      Do
        Dec(tseg2)
        Inc(tseg1)
      Until(tseg2 = 7)
    EndIf
    btr0 = brp                                           'Synchronization jump width = 1 (bits = 0)
    btr1 = tseg1 + Shift_Left(tseg2, 4)                   'one sampling each Bit
    Set_CAN_Reg(module, channel, 0, 65)                     'enable access to btr regisers
    Set_CAN_Reg(module, channel, 3Fh, btr0)                 'set btr0 regisers
    Set_CAN_Reg(module, channel, 4Fh, btr1)                 'set btr1 regisers
    Set_CAN_Reg(module, channel, 0, 0)                      'disable access to btr regisers
  EndIf
EndFunction


'-------------------Anybus
'---------------------------------------------------------------
''' Getting a byte from the DPRAM of a profibus-DP master or slave
''' module: dip switch address
''' byteno: number of the byte on the DPRAM
'''---------------------------------------------------------------
Function Get_Pro_Byte(module, byteno) As Long
  Dim addr As Long

  addr = 80C0h Or Shift_Left(module, 13) Or (byteno And 0FFFFFFC0h) * 4h Or (byteno And 63)
  Sub_Begin_Critical_Section
  Poke_NOP_RD(adrd, addr)
  Get_Pro_Byte = Peek(dlx)
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' Setting a byte in the DPRAM of a profibus-DP master or slave
''' module: module address
''' byteno: number of the byte on the DPRAM
''' value:  value for the selected byte
'''-------------------------------------------------------------
Sub Set_Pro_Byte(module, byteno, value)
  Dim addr As Long

  addr = 80C0h Or Shift_Left(module, 13) Or (byteno And 0FFFFFFC0h) * 4h Or (byteno And 63)
  Sub_Begin_Critical_Section
  Poke(adwr, addr)
  NOP_T9
  Poke_NOP(dlx, value)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
' Hardware reset on the HMS Module
' module:  module address
'---------------------------------------------------------------
Sub Hardware_Reset(module) ''<HIDE>
  Dim addr As Long

  addr = 0C0h Or (Shift_Left(module, 8)) Or 39
  Sub_Begin_Critical_Section
  Poke(adwr, addr)
  NOP_T9
  Poke_NOP(dlx, 1)
  Sub_End_Critical_Section
  P1_Sleep(500)                         'Reset signal must be low for at least 5s

  Sub_Begin_Critical_Section
  Poke(adwr, addr)
  NOP_T9
  Poke_NOP(dlx, 0)
  Sub_End_Critical_Section
  P1_Sleep(30000000)                    'Wait Until the module has finished his internal initialisation
EndSub



'Slave
'---------------------------------------------------------------
' This function is for mailbox handling. When the in mailbox
' is set the mail is sent with this command.
' module:  module address
'---------------------------------------------------------------
Sub Send_Mail(module) ''<HIDE>
  Dim buffer As Long

  buffer = Get_Pro_Byte(module, APP_IND)
  Set_Pro_Byte(module, APP_IND, buffer xor 80h)
EndSub


'---------------------------------------------------------------
' This function is for mailbox handling. If the in mailbox
' is free to handle a new mailbox communication the return
' value is 0 Else the return value is 1.
' module:  module address
'---------------------------------------------------------------
Function Check_Inbox_Free(module) As Long ''<HIDE>
  Dim buffer1 As Long
  Dim buffer2 As Long

  buffer1 = Get_Pro_Byte(module, APP_IND) And 080h
  buffer2 = Get_Pro_Byte(module, ANY_IND) And 080h
  If (buffer1 = buffer2) Then
    Check_Inbox_Free = 0
  Else
    Check_Inbox_Free = 1
  EndIf
EndFunction


'---------------------------------------------------------------
' This function is for mailbox handling. Checks if new
' data is in the out mailbox. If there is new data the
' return value is 0, Else the return value is 1.
' module:  module address
'---------------------------------------------------------------
Function Check_Outbox_Full(module) As Long ''<HIDE>
  Dim buffer1 As Long
  Dim buffer2 As Long

  buffer1 = Get_Pro_Byte(module, APP_IND) And 040h
  buffer2 = Get_Pro_Byte(module, ANY_IND) And 040h
  If (buffer1 = buffer2) Then
    Check_Outbox_Full = 1
  Else
    Check_Outbox_Full = 0
  EndIf
EndFunction


'---------------------------------------------------------------
' This function is for mailbox handling. The function is
' waiting Until the in mailbox is free to handle a new
' mailbox communication. The return value is 0 when the
' waiting was successful, Else the return value is 08000h.
' module:  module address
'---------------------------------------------------------------
Function Wait_Inbox_Free(module) As Long''<HIDE>
  Dim buffer1 As Long
  Dim counter As Long

  counter = 0
  Do
    Inc counter
    buffer1 = Check_Inbox_Free(module)
  Until((counter > 10000000) Or (buffer1 = 0))
  If (counter > 10000000) Then
    Wait_Inbox_Free = 08000h                                    'mail failed
  Else
    Wait_Inbox_Free = 0                                         'mail sended
  EndIf
EndFunction


'---------------------------------------------------------------
' This function is for mailbox handling. The function is
' waiting Until the out mailbox is full to handle a new
' mailbox communication. The return value is 0 when the
' waiting was successful, Else the return value is 04000h.
' module:  module address
'---------------------------------------------------------------
Function Wait_Outbox_Full(module) As Long ''<HIDE>
  Dim buffer1 As Long
  Dim counter As Long

  counter = 0
  Do
    Inc counter
    buffer1 = Check_Outbox_Full(module)
  Until((counter > 10000000) Or (buffer1 = 0))
  If (counter > 10000000) Then
    Wait_Outbox_Full = 04000h                                   'mail failed
  Else
    Wait_Outbox_Full = 0                                        'mail sended
  EndIf
EndFunction

'---------------------------------------------------------------
'This procedure is for mailbox handling. if a new mail
'is in out mailbox and is read. This command gives an
'ACK. The Next message can be received now.
'---------------------------------------------------------------
Sub Ack_Mail(module) ''<HIDE>
  Dim buffer1 As Long
  Dim buffer2 As Long

  buffer1 = Get_Pro_Byte(module, ANY_IND) And 040h
  buffer2 = ((Get_Pro_Byte(module, APP_IND) And 0BFh) Or buffer1)
  Set_Pro_Byte(module, APP_IND, buffer2)
EndSub

'---------------------------------------------------------------
'This procedure is for initialisation of the anybus module
'via mailbox. The in mailbox is set to start the
'initialisation.
'---------------------------------------------------------------
Sub Set_Mailbox_Start_Init(module)''<HIDE>
  Set_Pro_Byte(module, MAIL_IN_0, 000h)
  Set_Pro_Byte(module, MAIL_IN_1, 001h)
  Set_Pro_Byte(module, MAIL_IN_2, 040h)
  Set_Pro_Byte(module, MAIL_IN_3, 001h)
  Set_Pro_Byte(module, MAIL_IN_4, 000h)
  Set_Pro_Byte(module, MAIL_IN_5, 001h)
  Set_Pro_Byte(module, MAIL_IN_6, 000h)
  Set_Pro_Byte(module, MAIL_IN_7, 000h)
  Set_Pro_Byte(module, MAIL_IN_8, 000h)
  Set_Pro_Byte(module, MAIL_IN_9, 001h)
  Set_Pro_Byte(module, MAIL_IN_A, 000h)
  Set_Pro_Byte(module, MAIL_IN_B, 001h)
  Set_Pro_Byte(module, MAIL_IN_C, 000h)
  Set_Pro_Byte(module, MAIL_IN_D, 000h)
  Set_Pro_Byte(module, MAIL_IN_E, 000h)
  Set_Pro_Byte(module, MAIL_IN_F, 000h)
EndSub


'---------------------------------------------------------------
'This procedure is for initialisation of the anybus module
'via mailbox. The in mailbox is set to terminate the
'initialisation.
'---------------------------------------------------------------
Sub Set_Mailbox_End_Init(module)''<HIDE>
  Set_Pro_Byte(module, MAIL_IN_0, 000h)
  Set_Pro_Byte(module, MAIL_IN_1, 001h)
  Set_Pro_Byte(module, MAIL_IN_2, 040h)
  Set_Pro_Byte(module, MAIL_IN_3, 001h)
  Set_Pro_Byte(module, MAIL_IN_4, 000h)
  Set_Pro_Byte(module, MAIL_IN_5, 003h)
  Set_Pro_Byte(module, MAIL_IN_6, 000h)
  Set_Pro_Byte(module, MAIL_IN_7, 000h)
  Set_Pro_Byte(module, MAIL_IN_8, 000h)
  Set_Pro_Byte(module, MAIL_IN_9, 001h)
  Set_Pro_Byte(module, MAIL_IN_A, 000h)
  Set_Pro_Byte(module, MAIL_IN_B, 001h)
  Set_Pro_Byte(module, MAIL_IN_C, 000h)
  Set_Pro_Byte(module, MAIL_IN_D, 000h)
  Set_Pro_Byte(module, MAIL_IN_E, 000h)
  Set_Pro_Byte(module, MAIL_IN_F, 000h)
EndSub


'---------------------------------------------------------------
'This procedure is for initialisation of the anybus module
'via mailbox. The in mailbox is set to check the bus
'specific hardware.
'---------------------------------------------------------------
Sub Set_Mailbox_HW_CHK(module)''<HIDE>
  Set_Pro_Byte(module, MAIL_IN_0, 000h)
  Set_Pro_Byte(module, MAIL_IN_1, 001h)
  Set_Pro_Byte(module, MAIL_IN_2, 040h)
  Set_Pro_Byte(module, MAIL_IN_3, 001h)
  Set_Pro_Byte(module, MAIL_IN_4, 000h)
  Set_Pro_Byte(module, MAIL_IN_5, 006h)
  Set_Pro_Byte(module, MAIL_IN_6, 000h)
  Set_Pro_Byte(module, MAIL_IN_7, 000h)
  Set_Pro_Byte(module, MAIL_IN_8, 000h)
  Set_Pro_Byte(module, MAIL_IN_9, 001h)
  Set_Pro_Byte(module, MAIL_IN_A, 000h)
  Set_Pro_Byte(module, MAIL_IN_B, 001h)
  Set_Pro_Byte(module, MAIL_IN_C, 000h)
  Set_Pro_Byte(module, MAIL_IN_D, 000h)
  Set_Pro_Byte(module, MAIL_IN_E, 000h)
  Set_Pro_Byte(module, MAIL_IN_F, 000h)
EndSub


'---------------------------------------------------------------
'This procedure is for initialisation of the anybus module
'via mailbox. The in mailbox is set to configure the
'module according to the user Defined values.
'---------------------------------------------------------------
Sub Set_Mailbox_Anybus_Init(module, io_in, par_in, io_out, par_out, input_handling, output_handling, interrupt) ''<HIDE>
  Dim space_in, space_out As Long
  Dim io_in_low, io_in_high, io_out_low, io_out_high, space_in_low, space_in_high, space_out_low, space_out_high As Long

  space_in = io_in + par_in
  space_out = io_out + par_out
  io_in_low = io_in And 0FFh
  io_in_high = Shift_Right(io_in, 8) And 0FFh
  io_out_low = io_out And 0FFh
  io_out_high = Shift_Right(io_out, 8) And 0FFh
  space_in_low = space_in And 0FFh
  space_in_high = Shift_Right(space_in, 8) And 0FFh
  space_out_low = space_out And 0FFh
  space_out_high = Shift_Right(space_out, 8) And 0FFh

  Set_Pro_Byte(module, MAIL_IN_0, 000h)
  Set_Pro_Byte(module, MAIL_IN_1, 00Ah)
  Set_Pro_Byte(module, MAIL_IN_2, 040h)
  Set_Pro_Byte(module, MAIL_IN_3, 001h)
  Set_Pro_Byte(module, MAIL_IN_4, 000h)
  Set_Pro_Byte(module, MAIL_IN_5, 002h)
  Set_Pro_Byte(module, MAIL_IN_6, 000h)
  Set_Pro_Byte(module, MAIL_IN_7, 012h)
  Set_Pro_Byte(module, MAIL_IN_8, 000h)
  Set_Pro_Byte(module, MAIL_IN_9, 001h)
  Set_Pro_Byte(module, MAIL_IN_A, 000h)
  Set_Pro_Byte(module, MAIL_IN_B, 001h)
  Set_Pro_Byte(module, MAIL_IN_C, 000h)
  Set_Pro_Byte(module, MAIL_IN_D, 000h)
  Set_Pro_Byte(module, MAIL_IN_E, 000h)
  Set_Pro_Byte(module, MAIL_IN_F, 000h)

  Set_Pro_Byte(module, 0420h, io_in_high)
  Set_Pro_Byte(module, 0421h, io_in_low)
  Set_Pro_Byte(module, 0422h, space_in_high)
  Set_Pro_Byte(module, 0423h, space_in_low)
  Set_Pro_Byte(module, 0424h, space_in_high)
  Set_Pro_Byte(module, 0425h, space_in_low)
  Set_Pro_Byte(module, 0426h, io_out_high)
  Set_Pro_Byte(module, 0427h, io_out_low)
  Set_Pro_Byte(module, 0428h, space_out_high)
  Set_Pro_Byte(module, 0429h, space_out_low)
  Set_Pro_Byte(module, 042Ah, space_out_high)
  Set_Pro_Byte(module, 042Bh, space_out_low)
  Set_Pro_Byte(module, 042Ch, input_handling)
  Set_Pro_Byte(module, 042Dh, output_handling)
  Set_Pro_Byte(module, 042Eh, 000h)
  Set_Pro_Byte(module, 042Fh, interrupt)
EndSub


'---------------------------------------------------------------
'This function checks, if the responding mail To the
'start_init mail is ok. If ok return value is 0, Else
'return value is 2.
'---------------------------------------------------------------
Function Check_Mailbox_Start_Init(module) As Long ''<HIDE>
  Check_Mailbox_Start_Init = 0
  If (Get_Pro_Byte(module, MAIL_OUT_1) <> 01h) Then Check_Mailbox_Start_Init = 2
  If (Get_Pro_Byte(module, MAIL_OUT_3) <> 01h) Then Check_Mailbox_Start_Init = 2
  If (Get_Pro_Byte(module, MAIL_OUT_5) <> 01h) Then Check_Mailbox_Start_Init = 2
  If (Get_Pro_Byte(module, MAIL_OUT_7) <> 00h) Then Check_Mailbox_Start_Init = 2
  If (Get_Pro_Byte(module, MAIL_OUT_9) <> 01h) Then Check_Mailbox_Start_Init = 2
  If (Get_Pro_Byte(module, MAIL_OUT_B) <> 01h) Then Check_Mailbox_Start_Init = 2
  If (Get_Pro_Byte(module, MAIL_OUT_d) <> 00h) Then Check_Mailbox_Start_Init = 2
  If (Get_Pro_Byte(module, MAIL_OUT_f) <> 00h) Then Check_Mailbox_Start_Init = 2
EndFunction


'---------------------------------------------------------------
'This function checks, if the responding mail To the
'end_init mail is ok. If ok return value is 0, Else
'return value is 080h.
'---------------------------------------------------------------
Function Check_Mailbox_End_Init(module) As Long''<HIDE>
  Check_Mailbox_End_Init = 0
  If (Get_Pro_Byte(module, MAIL_OUT_1) <> 01h) Then Check_Mailbox_End_Init = 080h
  If (Get_Pro_Byte(module, MAIL_OUT_3) <> 01h) Then Check_Mailbox_End_Init = 080h
  If (Get_Pro_Byte(module, MAIL_OUT_5) <> 03h) Then Check_Mailbox_End_Init = 080h
  If (Get_Pro_Byte(module, MAIL_OUT_7) <> 00h) Then Check_Mailbox_End_Init = 080h
  If (Get_Pro_Byte(module, MAIL_OUT_9) <> 01h) Then Check_Mailbox_End_Init = 080h
  If (Get_Pro_Byte(module, MAIL_OUT_B) <> 01h) Then Check_Mailbox_End_Init = 080h
  If (Get_Pro_Byte(module, MAIL_OUT_d) <> 00h) Then Check_Mailbox_End_Init = 080h
  If (Get_Pro_Byte(module, MAIL_OUT_f) <> 00h) Then Check_Mailbox_End_Init = 080h
EndFunction


'---------------------------------------------------------------
'This function checks, if the responding mail To the
'anybus_init mail is ok. If ok return value is 0, Else
'return value is 4.
'---------------------------------------------------------------
Function Check_Mailbox_Anybus_Init(module) As Long''<HIDE>
  Check_Mailbox_Anybus_Init = 0
  If (Get_Pro_Byte(module, MAIL_OUT_1) <> 0Ah) Then Check_Mailbox_Anybus_Init = 4
  If (Get_Pro_Byte(module, MAIL_OUT_3) <> 01h) Then Check_Mailbox_Anybus_Init = 4
  If (Get_Pro_Byte(module, MAIL_OUT_5) <> 02h) Then Check_Mailbox_Anybus_Init = 4
  If (Get_Pro_Byte(module, MAIL_OUT_7) <> 012h) Then Check_Mailbox_Anybus_Init = 4
  If (Get_Pro_Byte(module, MAIL_OUT_9) <> 01h) Then Check_Mailbox_Anybus_Init = 4
  If (Get_Pro_Byte(module, MAIL_OUT_B) <> 01h) Then Check_Mailbox_Anybus_Init = 4
  If (Get_Pro_Byte(module, MAIL_OUT_d) <> 00h) Then Check_Mailbox_Anybus_Init = 4
  If (Get_Pro_Byte(module, MAIL_OUT_f) <> 00h) Then Check_Mailbox_Anybus_Init = 4
  If (Get_Pro_Byte(module, 053Eh) <> 00h) Then Check_Mailbox_Anybus_Init = 4
  If (Get_Pro_Byte(module, 053Fh) <> 00h) Then Check_Mailbox_Anybus_Init = 4
EndFunction


'---------------------------------------------------------------
'This function checks, if the responding mail To the
'hw_chk mail is ok. If ok return value is 0 Else
'return value is 1.
'---------------------------------------------------------------
Function Check_Mailbox_HW_Chk(module) As Long''<HIDE>
  Check_Mailbox_HW_Chk = 0
  If (Get_Pro_Byte(module, MAIL_OUT_1) <> 01h) Then Check_Mailbox_HW_Chk = 1
  If (Get_Pro_Byte(module, MAIL_OUT_3) <> 01h) Then Check_Mailbox_HW_Chk = 1
  If (Get_Pro_Byte(module, MAIL_OUT_5) <> 06h) Then Check_Mailbox_HW_Chk = 1
  If (Get_Pro_Byte(module, MAIL_OUT_7) <> 00h) Then Check_Mailbox_HW_Chk = 1
  If (Get_Pro_Byte(module, MAIL_OUT_9) <> 01h) Then Check_Mailbox_HW_Chk = 1
  If (Get_Pro_Byte(module, MAIL_OUT_B) <> 01h) Then Check_Mailbox_HW_Chk = 1
  If (Get_Pro_Byte(module, MAIL_OUT_d) <> 00h) Then Check_Mailbox_HW_Chk = 1
  If (Get_Pro_Byte(module, MAIL_OUT_f) <> 00h) Then Check_Mailbox_HW_Chk = 1
EndFunction


'---------------------------------------------------------------
'This function checks, if the DPRAM is ok.
'If ok return value is 0, Else return value is 040h.
'The elements of the watchdog and the handshake are not
'checked. This will result in errors.
'---------------------------------------------------------------
Function DPRAM_Test(module) As Long''<HIDE>
  Dim counter As Long
  Dim byte As Long
  Dim buffer As Long

  DPRAM_Test = 0
  For counter = 00h To 07D3h
    byte = Get_Pro_Byte(module, counter)                                   'save value
    Set_Pro_Byte(module, counter, (counter And 0FFh))                       'write new value
    buffer = Get_Pro_Byte(module, counter)                                 'check new value
    Set_Pro_Byte(module, counter, byte)                                     'write back old value
    If (buffer <> (counter And 0FFh)) Then DPRAM_Test = 040h
  Next counter
  For counter = 7D6h To 7FDh
    byte = Get_Pro_Byte(module, counter)
    Set_Pro_Byte(module, counter, (counter And 0FFh))
    buffer = Get_Pro_Byte(module, counter)
    Set_Pro_Byte(module, counter, byte)
    If (buffer <> (counter And 0FFh)) Then DPRAM_Test = 040h
  Next counter
EndFunction


'---------------------------------------------------------------
''' Function to initialize an anybus module.
'''+ Attention: This function can only be used after power up.
'''+ Attention: This function can only be used in a low init part.
'''+            Do not use in a high priority process.
'''+ Attention: input and output size must be equal. (INTERBUS)
'''+ return value:  
'''+                     0 = no error; initialisation OK
'''+                        bit1 = 0:       anybus hardware_check failed
'''+                        bit1 = 1:       mailbox start_init failed
'''+                        bit1 = 2:       mailbox anybus_init failed
'''+                        bit1 = 3:       reseved for further use
'''+                        bit1 = 4:       reseved for further use
'''+                        bit1 = 5:       reseved for further use
'''+                        bit1 = 6:       dpram check failed
'''+                        bit1 = 7:       mailbox end_init failed
'''+                        bit1 = 8:       reseved for further use
'''+                        bit1 = 9:       reseved for further use
'''+                        bit1 = 10:      reseved for further use
'''+                        bit1 = 11:      reseved for further use
'''+                        bit1 = 12:      reseved for further use
'''+                        bit1 = 13:      reseved for further use
'''+                        bit1 = 14:      mail was not received
'''+                        bit1 = 15:      mail was not send
''' module:  module address
''' io_in:         number of input bytes for fast data exchange
''' par_in:                number of input bytes for parameter data exchange
''' io_out:                number of output bytes for fast data exchange
''' par_out:               number of output bytes for parameter data exchange
''' input_handling:        
'''+                     bit0:   0 = input area cleared on application stopped
'''+                             1 = input area freezed on application stopped
'''+                     bit1:   0 = changed data field not activated
'''+                             1 = changed data field activated
''' output_handling:       
'''+                     bit0:   0 = Fieldbus OFF-line
'''+                             1 = Fieldbus ON-line
'''+                     bit1:   0 = output area cleared on fieldbus stopped
'''+                             1 = output area freezed on fieldbus stopped
''' reserved/interrupt:    
'''+                     must be 0
'''---------------------------------------------------------------
Function Init_Slave(module, io_in, par_in, io_out, par_out, input_handling, output_handling, reserved) As Long
  'reserved/interrupt:    
  '                     bit0:   0 = no interrupt on data changed
  '                             1 = interrupt on data changed
  '                     bit1:   0 = no interrupt Fieldbus OFF-line
  '                             1 = interrupt Fieldbus OFF-line
  '                     bit2:   0 = no interrupt Fieldbus ON-line
  '                             1 = interrupt Fieldbus ON-line
  Dim buffer As Long

  Init_Slave = 0
  buffer = Get_Pro_Byte(module, 07FFh)                     'clear interrupt
  buffer = 0

  'DPRAM_check (not via mailbox)
  buffer = DPRAM_Test(module)
  Init_Slave = Init_Slave Or buffer

  'Mailbox operations
  'Hardware_check
  buffer = Wait_Inbox_Free(module)                        'waiting Until in mailbox is free
  Init_Slave = Init_Slave Or buffer
  Set_Mailbox_HW_CHK(module)                              'setting the in mailbox
  Send_Mail(module)                                       'send mail
  buffer = Wait_Inbox_Free(module)                        'wait Until in mail was send
  Init_Slave = Init_Slave Or buffer
  buffer = Wait_Outbox_Full(module)                       'wait Until out mail was received
  Init_Slave = Init_Slave Or buffer
  buffer = Check_Mailbox_HW_Chk(module)                   'check out mail (hw ok)
  Init_Slave = Init_Slave Or buffer
  Ack_Mail(module)                                        'acknowledge mail

  'start_init
  buffer = Wait_Inbox_Free(module)                        'waiting Until in mailbox is free
  Init_Slave = Init_Slave Or buffer
  Set_Mailbox_Start_Init(module)                          'setting in mailbox
  Send_Mail(module)                                       'send mail
  buffer = Wait_Inbox_Free(module)                        'wait Until in mail was send
  Init_Slave = Init_Slave Or buffer
  buffer = Wait_Outbox_Full(module)                       'wait Until out mail was received
  Init_Slave = Init_Slave Or buffer
  buffer = Check_Mailbox_Start_Init(module)               'check out mail (init start ok)
  Init_Slave = Init_Slave Or buffer
  Ack_Mail(module)                                        'acknowledge mail

  'anybus_init
  buffer = Wait_Inbox_Free(module)                        'waiting Until in mailbox is free
  Init_Slave = Init_Slave Or buffer
  Set_Mailbox_Anybus_Init(module, IO_in, par_in, IO_out, par_out, input_handling, output_handling, reserved)            'setting the in mailbox
  Send_Mail(module)                                       'send mail
  buffer = Wait_Inbox_Free(module)                        'wait Until in mail was send
  Init_Slave = Init_Slave Or buffer
  buffer = Wait_Outbox_Full(module)                       'wait Until out mail was received
  Init_Slave = Init_Slave Or buffer
  buffer = Check_Mailbox_Anybus_Init(module)              'check out mail (init anybus ok)
  Init_Slave = Init_Slave Or buffer
  Ack_Mail(module)                                        'acknowledge mail

  'End_init
  buffer = Wait_Inbox_Free(module)                        'waiting Until in mailbox is free
  Init_Slave = Init_Slave Or buffer
  Set_Mailbox_End_Init(module)                            'setting in mailbox
  Send_Mail(module)                                       'send mail
  buffer = Wait_Inbox_Free(module)                        'wait Until in mail was send
  Init_Slave = Init_Slave Or buffer
  buffer = Wait_Outbox_Full(module)                       'wait Until out mail was received
  Init_Slave = Init_Slave Or buffer
  buffer = Check_Mailbox_End_Init(module)                 'check out mail (end init ok)
  Init_Slave = Init_Slave Or buffer
  Ack_Mail(module)                                        'acknowledge mail
EndFunction


'---------------------------------------------------------------
''' The Function gives the information wether the data in
'''+ the out area has changen or not. If there is new data
'''+ the return value is <> 0 Else the return value is 0.
''' module:  module address
''' outsize:  number of bytes of the out area.
'''---------------------------------------------------------------
Function Changed_Data(module, outsize) As Long
  Dim loopsize As Long
  Dim buffer As Long
  Dim count As Long

  Changed_Data = 0
  loopsize = (outsize - 1) / 8 + 1
  For count = 1 To loopsize
    buffer = Get_Pro_Byte(module, (count + 7E3h))
    Changed_Data = Changed_Data Or buffer
  Next count
EndFunction


'---------------------------------------------------------------
'''Request application access to DPRAM.
'''+The DPRAM consists of 3 parts. Each part equals a bit
'''+in the parameter area:
'''module:  module address
'''area:
'''+Bit 0:         Anybus control registers
'''+Bit 1:         Output data
'''+Bit 2:         Input data
'''-------------------------------------------------------------
Sub Request_Access(module, area) As Long
  Dim buffer As Long
  buffer = Get_Pro_Byte(module, APP_IND) And 0F8h
  toggle_flag[module + 1] = Get_Pro_Byte(module, ANY_IND) And 08h
  Set_Pro_Byte(module, APP_IND, ((buffer Or area) Or 010h))
EndSub


'---------------------------------------------------------------
'''Request application access release to DPRAM.
'''+The DPRAM consists of 3 parts. Each part equals a bit
'''+in the parameter area:
''' module:  module address
''' area
'''+ Bit 0:         Anybus control registers
'''+ Bit 1:         Output data
'''+ Bit 2:         Input data
'''-------------------------------------------------------------
Sub Request_Release_Access(module, area) As Long
  Dim buffer As Long
  buffer = Get_Pro_Byte(module, APP_IND) And 0E8h
  toggle_flag[module + 1] = Get_Pro_Byte(module, ANY_IND) And 08h
  Set_Pro_Byte(module, APP_IND, (buffer Or area))
EndSub


'---------------------------------------------------------------
'''Check access right. If bit is set the application has
'''+access right.
'''+The DPRAM consists of 3 parts. Each part equals a bit
'''+in the parameter array:
'''+Bit 0:         Anybus control registers
'''+Bit 1:         Output data
'''+Bit 2:         Input data
'''module:  module address
'''-------------------------------------------------------------
Function Check_Access(module) As Long
  If (toggle_flag[module + 1] = Get_Pro_Byte(module, ANY_IND) And 08h) Then
    Check_Access = -1
  Else
    Check_Access = Get_Pro_Byte(module, ANY_IND) And 07h
  EndIf
EndFunction
'---------------------------------------------------------------
'''Reads the input data from the DPRAM
''' module:  module address
''' array[]:         destination array for input data
''' start:         first byte (DPRAM)
''' count:         number of bytes
'''-------------------------------------------------------------
Sub Get_Read_Buffer(module, array[], start, count)
  Dim i As Long

  For i = start To (start + count - 1)
    array[i + 1 - start] = Get_Pro_Byte(module, i)
  Next i
EndSub


'---------------------------------------------------------------
'''Writes the output data to the DPRAM
''' module:  module address
''' array[]:         source array for input data
'''start:         first byte (DPRAM)
'''count:         number of bytes
'''-------------------------------------------------------------
Sub Set_Write_Buffer(module, array[], start, count)
  Dim i As Long

  For i = start To (start + count - 1)
    Set_Pro_Byte(module, i, array[i + 1])
  Next i
EndSub



'Master
'---------------------------------------------------------------
' Giving access right to DPRAM to device.
' Set Pdcom and Pdack unequal.
' Data exchange mode 3 and 4.
' module:  module address
'---------------------------------------------------------------
'  Sub Pass_Access_3(module) ''<HIDE>
'    Dim byte As Long
'    Dim flag As Long
'
'    byte = (Get_Pro_Byte(module, control_to_host) And 04h) xor 4
'    flag = (Get_Pro_Byte(module, control_to_device) And 0Bh)
'    byte = flag or byte
'    Set_Pro_Byte(module, control_to_device, byte)
'  EndSub


'---------------------------------------------------------------
' Giving access right to DPRAM to device.
' Set Pdcom and Pdack equal.
' Data exchange mode 0 and 1.
'       module  : dip switch address
'---------------------------------------------------------------
'  Sub Pass_Access_0(module)
'    Dim byte As Long
'    Dim flag As Long
'
'    byte = (Get_Pro_Byte(module, control_to_host) And 04h)
'    flag = (Get_Pro_Byte(module, control_to_device) And 0Bh)
'    byte = flag or byte
'    Set_Pro_Byte(module, control_to_device, byte)
'  EndSub


'---------------------------------------------------------------
' communication via mailbox
' slave diagnostic
'       module  : dip switch address
'       number: unique message number
'       slave : ID of the selected slave
'---------------------------------------------------------------
'  Sub Slave_Diagnostic(module, number, slave)
'    Set_Pro_Byte(module, out_mailbox_0, 3)
'    Set_Pro_Byte(module, out_mailbox_1, 16)
'    Set_Pro_Byte(module, out_mailbox_2, 8)
'    Set_Pro_Byte(module, out_mailbox_3, number)
'    Set_Pro_Byte(module, out_mailbox_4, 0)
'    Set_Pro_Byte(module, out_mailbox_5, 0)
'    Set_Pro_Byte(module, out_mailbox_6, 66)
'    Set_Pro_Byte(module, out_mailbox_7, 0)
'    Set_Pro_Byte(module, out_mailbox_8, slave)
'    Set_Pro_Byte(module, out_mailbox_9, 0)
'    Set_Pro_Byte(module, out_mailbox_a, 0)
'    Set_Pro_Byte(module, out_mailbox_b, 0)
'    Set_Pro_Byte(module, out_mailbox_c, 0)
'    Set_Pro_Byte(module, out_mailbox_d, 32)
'    Set_Pro_Byte(module, out_mailbox_e, 5)
'    Set_Pro_Byte(module, out_mailbox_f, 1)
'  EndSub



'---------------------------------------------------------------
' communication via mailbox
' global control
'       module  : dip switch address
'       number: unique number
'       slave : 127 = all selected slaves (selected by group)
'                       0 - 126 = only one slave (slavenumber)
'       command:        20h = sync
'                       10h = unsync
'                       08h = freeze
'                       04h = unfreeze
'                       02h = clear
'       group:  group for which the command is valid
'---------------------------------------------------------------
'  Sub Global_Control(module, number, slave, command, group)
'    Set_Pro_Byte(module, out_mailbox_0, 3)
'    Set_Pro_Byte(module, out_mailbox_1, 16)
'    Set_Pro_Byte(module, out_mailbox_2, 3)
'    Set_Pro_Byte(module, out_mailbox_3, number)
'    Set_Pro_Byte(module, out_mailbox_4, 0)
'    Set_Pro_Byte(module, out_mailbox_5, 0)
'    Set_Pro_Byte(module, out_mailbox_6, 70)
'    Set_Pro_Byte(module, out_mailbox_7, 0)
'    Set_Pro_Byte(module, out_mailbox_8, slave)
'    Set_Pro_Byte(module, out_mailbox_9, command)
'    Set_Pro_Byte(module, out_mailbox_a, group)
'  EndSub


'---------------------------------------------------------------
' communication via mailbox
' read statistic counter
'       module  : dip switch address
'       number: unique message number
'       start:  bus address of first slave
'       count:  number of slaves
'---------------------------------------------------------------
'  Sub Statistic(module, number, start, count)
'    Set_Pro_Byte(module, out_mailbox_0, 7)
'    Set_Pro_Byte(module, out_mailbox_1, 16)
'    Set_Pro_Byte(module, out_mailbox_2, 8)
'    Set_Pro_Byte(module, out_mailbox_3, number)
'    Set_Pro_Byte(module, out_mailbox_4, 0)
'    Set_Pro_Byte(module, out_mailbox_5, 0)
'    Set_Pro_Byte(module, out_mailbox_6, 0FEh)
'    Set_Pro_Byte(module, out_mailbox_7, 0)
'    Set_Pro_Byte(module, out_mailbox_8, start)
'    Set_Pro_Byte(module, out_mailbox_9, 0)
'    Set_Pro_Byte(module, out_mailbox_a, 0)
'    Set_Pro_Byte(module, out_mailbox_b, 0)
'    Set_Pro_Byte(module, out_mailbox_c, 0)
'    Set_Pro_Byte(module, out_mailbox_d, count)
'    Set_Pro_Byte(module, out_mailbox_e, 5)
'    Set_Pro_Byte(module, out_mailbox_f, 1)
'  EndSub


'---------------------------------------------------------------
' communication via mailbox
' clear statistic counter
'       module  : dip switch address
'       number: unique message number
'---------------------------------------------------------------
'  Sub Clear_Statistic(module, number)
'    Set_Pro_Byte(module, out_mailbox_0, 7)
'    Set_Pro_Byte(module, out_mailbox_1, 16)
'    Set_Pro_Byte(module, out_mailbox_2, 8)
'    Set_Pro_Byte(module, out_mailbox_3, number)
'    Set_Pro_Byte(module, out_mailbox_4, 0)
'    Set_Pro_Byte(module, out_mailbox_5, 0)
'    Set_Pro_Byte(module, out_mailbox_6, 0FEh)
'    Set_Pro_Byte(module, out_mailbox_7, 0)
'    Set_Pro_Byte(module, out_mailbox_8, 0)
'    Set_Pro_Byte(module, out_mailbox_9, 0)
'    Set_Pro_Byte(module, out_mailbox_a, 0)
'    Set_Pro_Byte(module, out_mailbox_b, 0)
'    Set_Pro_Byte(module, out_mailbox_c, 0)
'    Set_Pro_Byte(module, out_mailbox_d, 0)
'    Set_Pro_Byte(module, out_mailbox_e, 5)
'    Set_Pro_Byte(module, out_mailbox_f, 4)
'  EndSub
'


'---------------------------------------------------------------
'Communication via Mailbox
'check if requested message is arrived
'return value :  1 = message arrived
'                    2 = message not arrived
'  '---------------------------------------------------------------
'  Function Check_Msg(module) As Long
'    Dim byte As Long
'    Dim flag As Long
'
'    byte = Get_Pro_Byte(module, control_to_host) And 02h
'    flag = Get_Pro_Byte(module, control_to_device) And 02h
'    par_3 = flag
'    par_4 = byte
'    If (byte = flag) Then
'      Check_Msg = 1                                       ' message arrived
'    Else
'      Check_Msg = 2                                       ' message not arrived
'    EndIf
'  EndFunction


'---------------------------------------------------------------
'communicaion via mailbox.
'Sending message to note.
'After the initialisation of the Out_mailbox the message
'must be send to the profibus.
'       module  : dip switch address
'---------------------------------------------------------------
'  Sub Send_Msg_To_Note(module)
'    Dim byte As Long
'    Dim flag As Long
'
'    byte = ((Get_Pro_Byte(module, control_to_host) And 02h) xor 02h)
'    flag = (Get_Pro_Byte(module, control_to_device))
'    flag = (flag And 0Dh) or byte
'    Set_Pro_Byte(module, control_to_device, flag)
'  EndSub


'---------------------------------------------------------------
' Gives acknolage to arrived message
'       module  : dip switch address
'---------------------------------------------------------------
'  Sub Ack_Msg(module)
'    Dim byte As Long
'
'    byte = Get_Pro_Byte(module, control_to_host) And 03h
'    Set_Pro_Byte(module, control_to_device, byte)
'  EndSub
'

'---------------------------------------------------------------
'Reset the Master Module
'       access_mode:    0 = bus synchronus ; device controlled
'                               1 = bufferd ; device controlled
'                               2 = uncontrolled
'                               3 = bufferd ; user controlled
'                               4 = bus synchronus ; user controlled
'       module  :         dip switch address
'---------------------------------------------------------------
'  Sub Reset_Master(module, access_mode)
'    Set_Pro_Byte(module, set_exchange_mode, access_mode)              'set access mode
'    Set_Pro_Byte(module, control_to_device, 080h)                     'set reset flag
'  EndSub


'---------------------------------------------------------------
'Initialisation of the Master Module
'       access_mode:    0 = bus synchronus ; device controlled
'                               1 = bufferd ; device controlled
'                               2 = uncontrolled
'                               3 = bufferd ; user controlled
'                               4 = bus synchronus ; user controlled
'       module  :         dip switch address
'---------------------------------------------------------------
'  Sub Init_Master(module, access_mode)
'    Dim mode As Long
'
'    Set_Pro_Byte(module, set_exchange_mode, access_mode)
'    Set_Pro_Byte(module, control_to_device, 040h)
'  EndSub


'---------------------------------------------------------------
'Check if the device or the host has access right
'Function only valid in access_mode 0 and 1
'       module  :       dip switch address
'       return value :  1 = host
'                       2 = device
'  '---------------------------------------------------------------
'  Function Check_Access_0(module) As Long
'    Dim byte As Long
'    Dim flag As Long
'
'    byte = Get_Pro_Byte(module, control_to_host) And 04h
'    flag = Get_Pro_Byte(module, control_to_device) And 04h
'    If (flag <> byte) Then
'      Check_Access_0 = 1
'    Else
'      Check_Access_0 = 2
'    EndIf
'  EndFunction
'

'---------------------------------------------------------------
'Check if the device or the host has access right
'Function only valid in access_mode 3 and 4
'       module  :       dip switch address
'       return value :  1 = host
'                       2 = device
'---------------------------------------------------------------
'  Function Check_Access_3(module) As Long
'    Dim byte As Long
'    Dim flag As Long
'
'    byte = Get_Pro_Byte(module, control_to_host) And 04h
'    flag = Get_Pro_Byte(module, control_to_device) And 04h
'    If (flag = byte) Then
'      Check_Access_3 = 1
'    Else
'      Check_Access_3 = 2
'    EndIf
'  EndFunction


'---------------------------------------------------------------
'Shows the statue of the master
'       module  :         dip switch address
'bit7:  1 = device is ready
'               0 = device is not ready
'bit6:  1 = communication is running
'               0 = communication is not running
'bit5:  1 = data is getting exchanged
'               0 = no data exchanged
'---------------------------------------------------------------
'  Function Master_Status(module) As Long
'    Master_Status = Get_Pro_Byte(module, control_to_host) And 0F0h
'  EndFunction

#If PROZESSOR = T11 Then
Import tc.lib
#EndIf

'---------------------------------------------------------------
''' convert digit from TC4/8/16 J to temperature
''' dig_val: inputvalue
'''t_unit: 
'''+     1 = C
'''+     2 = F
'''-------------------------------------------------------------
Function TCJ_Dig_To_Temp(dig_val, t_unit) As Float
  TCJ_Dig_To_Temp = TC_Convert_Typ_J((dig_val - 32778) * 1.57758)
  If (t_unit = 2) Then  'C -> F
    TCJ_Dig_To_Temp = (TCJ_Dig_To_Temp * 1.8) + 32
  EndIf
EndFunction

'---------------------------------------------------------------
''' convert digit from TC4/8/16 K to temperature
''' dig_val: inputvalue
''' t_unit: 
'''+         1 = C
'''+         2 = F
'''-------------------------------------------------------------
Function TCK_Dig_To_Temp(dig_val, t_unit) As Float
  TCK_Dig_To_Temp = TC_Convert_Typ_K((dig_val - 32778) * 1.234192)
  If (t_unit = 2) Then  'C -> F
    TCK_Dig_To_Temp = (TCK_Dig_To_Temp * 1.8) + 32
  EndIf
EndFunction

'---------------------------------------------------------------
''' convert digit from PT-100 to temperature
''' dig_val: inputvalue
''' unit 
'''+     1 = C
'''+     2 = F
'''-------------------------------------------------------------
Function PT100_Dig_To_Temp(dig_val, t_unit) As Float
  Dim value As Float
  value = (dig_val - 32768) * 20 / 65536
  If (value <= 0) Then
    PT100_Dig_To_Temp = ((((0.0002 * value - 0.0032) * value + 0.0906) * value + 25.581) * value - 0.002)
  Else
    PT100_Dig_To_Temp = (0.1097 * value + 25.536) * value + 0.0444
  EndIf

  If (t_unit = 2) Then PT100_Dig_To_Temp = PT100_Dig_To_Temp * 1.8 + 32
EndFunction

'---------------------------------------------------------------
''' convert digit from PT-100 to resistor
'''+ return r[ohm]
''' dig_val inputvalue
'''--------------------------------------------------------------
Function PT100_Dig_To_R(dig_val) As Float
  PT100_Dig_To_R = ((dig_val - 32768) * 200 / 65536) + 100
EndFunction



'---------------------------------------------------------------
''' read value of tc iso TYP J  -210 C->1200 C
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+       0 = thermovoltage V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
Function TC_Read_J(module, channel, ret_type) As Float
  Dim addr As Long
  Dim value As Long
  Dim volt As Long
  Dim coldjunction As Long
  Dim volt2 As Float

  addr = Shift_Left(module, 8) Or 0C0h Or (channel - 1)

  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  value = Peek(D32)
  Sub_End_Critical_Section

  coldjunction = (Shift_Right(value, 16)) And 1FFFh
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h

  volt = value And 0FFFFh 'thermovoltage 409.6 digit /mV
  If(volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
  volt2 = volt * 2.44140625 'thermovoltage = > V
  volt2 = volt2  + TC_Convert_Typ_J_Inv((coldjunction / 16))

  If (ret_type>0) Then 'convert
    TC_Read_J = TC_Convert_Typ_J(volt2) '-210 C->1200 C DIN EN 60584-1
  Else
    TC_Read_J = volt2
  EndIf

  If (ret_type = 2) Then  'C -> F
    TC_Read_J = (TC_Read_J * 1.8) + 32
  EndIf
EndFunction


'---------------------------------------------------------------
''' read value of tc iso TYP N  -200C->1300 C
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+        0 = thermovoltage V
'''+        1 = C
'''+        2 = F
'''-------------------------------------------------------------
Function TC_Read_N(module, channel, ret_type) As Float
  Dim addr As Long
  Dim value As Long
  Dim volt As Long
  Dim coldjunction As Long
  Dim volt2 As Float

  addr = Shift_Left(module, 8) Or 0C0h Or (channel - 1)
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  value = Peek(D32)
  Sub_End_Critical_Section

  coldjunction = (Shift_Right(value, 16)) And 1FFFh
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h

  volt = value And 0FFFFh 'thermovoltage 409.6 digit /mV
  If(volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
  volt2 = volt * 2.44140625 'thermovoltage = > V
  volt2 = volt2  + TC_Convert_Typ_N_Inv((coldjunction / 16))

  If (ret_type>0) Then 'convert
    TC_Read_N = TC_Convert_Typ_N(volt2) '-210 C->1300 C DIN EN 60584-1
  Else
    TC_Read_N = volt2
  EndIf

  If (ret_type = 2) Then  'C -> F
    TC_Read_N = (TC_Read_N * 1.8) + 32
  EndIf
EndFunction


'---------------------------------------------------------------
''' read value of tc iso TYP K -200 C -> 1372 C
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+       0 = thermovoltage in V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
Function TC_Read_K(module, channel, ret_type) As Float
  Dim addr As Long
  Dim value As Long
  Dim volt As Long
  Dim coldjunction As Long
  Dim volt2 As Float

  addr = Shift_Left(module, 8) Or 0C0h Or (channel - 1)

  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  value = Peek(D32)
  Sub_End_Critical_Section

  coldjunction = (Shift_Right(value, 16)) And 1FFFh
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h

  volt = value And 0FFFFh 'thermovoltage 409.6 digit /mV
  If(volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h

  volt2 = volt * 2.44140625 'thermovoltage = > V

  If (coldjunction<= 400) Then '<25 C
    volt2 = volt2 + (2.5055 * coldjunction)
  Else
    volt2 = volt2 + (2.56 * (coldjunction - 9.76))
  EndIf

  If (ret_type>0) Then 'convert
    TC_Read_K = TC_Convert_Typ_K(volt2) '-200 C -> 1372 C DIN EN 60584-1
  Else
    TC_Read_K = volt2
  EndIf

  If (ret_type = 2) Then  'C -> F
    TC_Read_K = (TC_Read_K * 1.8) + 32
  EndIf
EndFunction


'---------------------------------------------------------------
''' read value of tc iso TYPE S -50 C-> 1768 C
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+        0 = thermovoltage in V
'''+        1 = C
'''+        2 = F
'''-------------------------------------------------------------
Function TC_Read_S(module, channel, ret_type) As Float
  Dim addr As Long
  Dim value As Long
  Dim volt As Long
  Dim coldjunction As Long
  Dim volt2 As Float

  addr = Shift_Left(module, 8) Or 0C0h Or (channel - 1)
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  value = Peek(D32)
  Sub_End_Critical_Section

  coldjunction = (Shift_Right(value, 16)) And 1FFFh
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h
  volt = value And 0FFFFh 'thermovoltage 409.6 digit /mV
  If(volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
  volt2 = volt * 2.44140625 'thermovoltage = > V
  volt2 = volt2  + TC_Convert_Typ_S_Inv((coldjunction / 16))
  If (ret_type>0) Then 'convert
    TC_Read_S = TC_Convert_Typ_S(volt2) '-50 C-> 1768 C DIN EN 60584-1
  Else
    TC_Read_S = volt2
  EndIf

  If (ret_type = 2) Then  'C -> F
    TC_Read_S = (TC_Read_S * 1.8) + 32
  EndIf
EndFunction


'---------------------------------------------------------------
''' read value of tc iso TYPE T -200 C-> 400 C
''' module: module address  (0..255)
''' channel: (1-8)
''' ret_type: 
'''+       0 = thermovoltage in V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
Function TC_Read_T(module, channel, ret_type) As Float
  Dim addr As Long
  Dim value As Long
  Dim volt As Long
  Dim coldjunction As Long
  Dim volt2 As Float

  addr = Shift_Left(module, 8) Or 0C0h Or (channel - 1)

  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  value = Peek(D32)
  Sub_End_Critical_Section
  coldjunction = (Shift_Right(value, 16)) And 1FFFh
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h
  volt = value And 0FFFFh 'thermovoltage 409.6 digit /mV
  If(volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
  volt2 = volt * 2.44140625 'thermovoltage = > V
  volt2 = volt2  + TC_Convert_Typ_T_Inv((coldjunction / 16))
  If (ret_type>0) Then 'convert
    TC_Read_T = TC_Convert_Typ_T(volt2) '-200 C-> 400 C DIN EN 60584-1
  Else
    TC_Read_T = volt2
  EndIf
  If (ret_type = 2) Then  'C -> F
    TC_Read_T = (TC_Read_T * 1.8) + 32
  EndIf
EndFunction


'---------------------------------------------------------------
''' read value of tc iso TYPE R -50 C-> 1768 C
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type: 
'''+       0 = thermovoltage in V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
Function TC_Read_R(module, channel, ret_type) As Float
  Dim addr As Long
  Dim value As Long
  Dim volt As Long
  Dim coldjunction As Long
  Dim volt2 As Float

  addr = Shift_Left(module, 8) Or 0C0h Or (channel - 1)
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  value = Peek(D32)
  Sub_End_Critical_Section
  coldjunction = (Shift_Right(value, 16)) And 1FFFh
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h
  volt = value And 0FFFFh 'thermovoltage 409.6 digit /mV
  If(volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
  volt2 = volt * 2.44140625 'thermovoltage = > V
  volt2 = volt2  + TC_Convert_Typ_R_Inv((coldjunction / 16))
  If (ret_type>0) Then 'convert
    TC_Read_R = TC_Convert_Typ_R(volt2)
  Else
    TC_Read_R = volt2
  EndIf
  If (ret_type = 2) Then  'C -> F
    TC_Read_R = (TC_Read_R * 1.8) + 32
  EndIf
EndFunction


'---------------------------------------------------------------
''' read value of tc iso TYPE E -200 C-> 1000 C
''' module: module address (0..255)
''' channel: (1-8)
'''ret_type:
'''+          0 = thermovoltage in V
'''+          1 = C
'''+          2 = F
'''-------------------------------------------------------------
Function TC_Read_E(module, channel, ret_type) As Float
  Dim addr As Long
  Dim value As Long
  Dim volt As Long
  Dim coldjunction As Long
  Dim volt2 As Float

  addr = Shift_Left(module, 8) Or 0C0h Or (channel - 1)
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  value = Peek(D32)
  Sub_End_Critical_Section
  coldjunction = (Shift_Right(value, 16)) And 1FFFh
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h

  volt = value And 0FFFFh 'thermovoltage 409.6 digit /mV
  If(volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
  volt2 = volt * 2.44140625 'thermovoltage = > V
  volt2 = volt2  + TC_Convert_Typ_E_Inv((coldjunction / 16))

  If (ret_type>0) Then 'convert
    TC_Read_E = TC_Convert_Typ_E(volt2)
  Else
    TC_Read_E = volt2
  EndIf

  If (ret_type = 2) Then  'C -> F
    TC_Read_E = (TC_Read_E * 1.8) + 32
  EndIf
EndFunction

'---------------------------------------------------------------
''' read value of tc iso TYPE B '250 C-1820
''' module: module address (0..255)
''' channel: (1-8)
''' ret_type:
'''+       0 = thermovoltage in V
'''+       1 = C
'''+       2 = F
'''-------------------------------------------------------------
Function TC_Read_B(module, channel, ret_type) As Float
  Dim addr As Long
  Dim value As Long
  Dim volt As Long
  Dim coldjunction As Long
  Dim volt2 As Float

  addr = Shift_Left(module, 8) Or 0C0h Or (channel - 1)
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  value = Peek(D32)
  Sub_End_Critical_Section

  volt = value And 0FFFFh 'thermovoltage 409.6 digit /mV
  If(volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
  volt2 = volt * 2.44140625 'thermovoltage = > V


  If (ret_type>0) Then 'convert
    TC_Read_B = TC_Convert_Typ_B(volt2)
  Else
    TC_Read_B = volt2
  EndIf

  If (ret_type = 2) Then  'C -> F
    TC_Read_B = (TC_Read_B * 1.8) + 32
  EndIf
EndFunction


'---------------------------------------------------------------
''' read the input voltage [v] without coldjunction correction
'''+ This function may be used if not a Thermocouple is connected
'''+ to the inputs of the TC-8 ISO, but if a voltage is applied
'''+ directly to the inputs. Max. input voltage is  + - 80 mVolt
''' module: module address  (0..255)
''' channel: (1-8)
'''-------------------------------------------------------------
Function TC_Read_Voltage(module, channel) As Float
  Dim addr As Long
  Dim value As Long
  Dim volt As Long

  addr = Shift_Left(module, 8) Or 0C0h Or (channel - 1)
  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  value = Peek(D32) And 0FFFFh
  Sub_End_Critical_Section

  If(value And 32768 = 32768) Then value = value Or 0FFFF0000h
  TC_Read_Voltage = value * 2.44140625 'voltage = > V
EndFunction


'---------------------------------------------------------------
'''Sub is setting the samplerate of tc iso modul
'''module: dip switch address (0..255)
''' rate:
'''+      1 samplerate = 3520 Hz
'''+      2 samplerate = 1760 Hz
'''+      3 samplerate = 880 Hz
'''+      4 samplerate = 440 Hz
'''+      5 samplerate = 220 Hz
'''+      6 samplerate = 110 Hz
'''+      7 samplerate = 55 Hz
'''+      8 samplerate = 27.5 Hz
'''+      9 samplerate = 13.75 Hz
'''+     15 samplerate = 6.875 Hz (default)
'''-------------------------------------------------------------
Sub TC_Set_Rate(module, rate)
  Dim addr As Long

  addr = Shift_Left(module, 8) Or 0C0h
  Sub_Begin_Critical_Section
  Poke(ADWR, addr)
  NOP_T9
  Poke_NOP(D32, rate)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''transfer the input data from channel 1-4 to an array
'''module: dip switch address  (0..255)
'''array[]: destination array
'''index: startindex in the destination array
'''-------------------------------------------------------------
Sub Read_ADCF4_Packed(module, array[], index)
  Sub_Begin_Critical_Section
  Poke(ADRDF, (040h) Or (Shift_Left(module, 8)))
  array[index] = Peek(D32I)
  array[index + 1] = Peek(D32)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''transfer the input data from channel 1-8 to an array
'''module: dip switch address (0..255)
'''array[]: destination array
'''index: startindex in the destination array
'''-------------------------------------------------------------
Sub Read_ADCF8_Packed(module, array[], index)
  Sub_Begin_Critical_Section
  Poke(ADRDF, (040h) Or (Shift_Left(module, 8)))
  array[index] = Peek(D32I)
  array[index + 1] = Peek(D32I)
  array[index + 2] = Peek(D32I)
  array[index + 3] = Peek(D32)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
'''transfer the input data from channel 1-8 to an array
'''module: dip switch address (0..255)
'''array[]: destination array
'''index: startindex in the destination array
'''-------------------------------------------------------------
Sub Read_ADCF8(module, array[], index)
  Dim value As Long

  Sub_Begin_Critical_Section
  Poke(ADRDF, (040h) Or (Shift_Left(module, 8)))
  value = Peek(D32I)'channel 1 + 2
  array[index] = value And 0FFFFh
  array[index + 1] = Shift_Right(value, 16)

  value = Peek(D32I)'channel 3 + 4
  array[index + 2] = value And 0FFFFh
  array[index + 3] = Shift_Right(value, 16)

  value = Peek(D32I)'channel 5 + 6
  array[index + 4] = value And 0FFFFh
  array[index + 5] = Shift_Right(value, 16)

  value = Peek(D32)'channel 7 + 8
  Sub_End_Critical_Section
  array[index + 6] = value And 0FFFFh
  array[index + 7] = Shift_Right(value, 16)
EndSub


'---------------------------------------------------------------
'''transfer the input data from channel 1-4 to an array
'''module: dip switch address
'''array[]: destination array
'''index: startindex in the destination array
'''-------------------------------------------------------------
Sub Read_ADCF4(module, array[], index)
  Dim value As Long

  Sub_Begin_Critical_Section
  Poke(ADRDF, (040h) Or (Shift_Left(module, 8)))
  value = Peek(D32I)'channel 1 + 2
  array[index] = value And 0FFFFh
  array[index + 1] = Shift_Right(value, 16)
  value = Peek(D32)'channel 3 + 4
  Sub_End_Critical_Section
  array[index + 2] = value And 0FFFFh
  array[index + 3] = Shift_Right(value, 16)
EndSub

'-------------------LS-BUS
'---------------------------------------------------------------
' Function only For internal use!
' receive LS-Bus
' module  : module address (0..255)
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Receive(module, channel, dev_adr, reg_adr, cnt_dat, buf[]) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart, th As Long
  Dim ret As Long
  Dim addr As Long

  addr = (Shift_Left(module, 8) Or ext) + (channel - 1) * 8
  Do
    Sub_Begin_Critical_Section              ' tx FIFO count
    Poke_NOP(ADRD, addr + 5)
    ftc = Peek(D32)
    Sub_End_Critical_Section
  Until (ftc<28)

  Sub_begin_critical_section
  Poke(ADWR, addr)                        ' Header 1
  NOP_T9
  Poke_NOP(D32, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))

  Poke(ADWR, addr)                        ' Header 2
  NOP_T9
  Poke_NOP(D32, 0 Or reg_adr)
  Sub_End_critical_section
  Bus_Sleep(6)
  Do
    Sub_Begin_Critical_Section             ' tx wait
    Poke_NOP(ADRD, addr + 5)
    ftc = Peek(D32)
    Sub_End_Critical_Section
  Until (ftc = 0)

  th = 2025                                ' first 6.75 mikrosec
  For cnt_i = 1 To cnt_dat                   ' data count
    tmstart = Read_Timer()
    Do                                     ' rx wait
      tmout = Read_Timer() - tmstart
      Sub_Begin_Critical_Section
      Poke_NOP(ADRD, addr + 2)
      frc = Peek(D32)
      Sub_End_Critical_Section
    Until ((frc>= 1) Or (tmout>th))
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD, addr)
    buf[cnt_i] = Peek(D32)
    Sub_End_Critical_Section
    th = 1800                              '  6 mikrosec
  Next cnt_i
  tmstart = Read_Timer()
  Do                                       ' ack wait
    tmout = Read_Timer() - tmstart             ' rx count
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD, addr + 2)
    frc = Peek(D32)
    Sub_End_Critical_Section
  Until ((frc>= 1) Or (tmout>1800))         ' 6 mikrosec
  If (frc>= 1) Then
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD, addr)
    ret = Peek(D32)
    Sub_End_Critical_Section
  Else
    ret = -1
  EndIf

  I_Receive = ret
EndFunction


'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus
' module  : module address (0..255)
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Send(module, channel, dev_adr, reg_adr, cnt_dat, buf[]) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart  As Long
  Dim ret As Long
  Dim addr As Long

  addr = (Shift_Left(module, 8) Or ext) + (channel - 1) * 8
  Do
    Sub_Begin_Critical_Section            ' tx FIFO count
    Poke_NOP(ADRD, addr + 5)
    ftc = Peek(D32)
    Sub_End_Critical_Section
  Until (ftc<(28 - cnt_dat))

  Sub_begin_critical_section
  Poke(ADWR, addr)                      ' Header 1
  NOP_T9
  Poke_NOP(D32, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))

  Poke(ADWR, addr)                      ' Header 2
  NOP_T9
  Poke_NOP(D32, (80h Or reg_adr))

  For cnt_i = 1 To cnt_dat                 ' data count
    Poke(ADWR, addr)
    NOP_T9
    Poke_NOP(D32, buf[cnt_i])
  Next cnt_i
  Sub_End_critical_section
  Bus_Sleep(6)
  Do
    Sub_Begin_Critical_Section           ' tx wait
    Poke_NOP(ADRD, addr + 5)
    ftc = Peek(D32)
    Sub_End_Critical_Section
  Until (ftc = 0)

  tmstart = Read_Timer()
  Do                                     ' ack wait
    tmout = Read_Timer() - tmstart
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD, addr + 2)
    frc = Peek(D32)
    Sub_End_Critical_Section
  Until ((frc>= 1) Or (tmout>1800))       ' 6 mikrosec

  If (frc >= 1) Then
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD, addr)
    ret = Peek(D32)
    Sub_End_Critical_Section
  Else
    ret = -1
  EndIf
  I_Send = ret
EndFunction


'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus no acknowlege
' module  : module address (0..255)
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'---------------------------------------------------------------
Sub I_Send_NA(module, channel, dev_adr, reg_adr, cnt_dat, buf[]) ''<HIDE>
  Dim cnt_i, ftc As Long
  Dim addr As Long

  addr = (Shift_Left(module, 8) Or ext) + (channel - 1) * 8
  Do
    Sub_Begin_Critical_Section            ' tx FIFO count
    Poke_NOP(ADRD, addr + 5)
    ftc = Peek(D32)
    Sub_End_Critical_Section
  Until (ftc<(28 - cnt_dat))

  Sub_begin_critical_section
  Poke(ADWR, addr)                      ' Header 1
  NOP_T9
  Poke_NOP(D32, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))

  Poke(ADWR, addr)                      ' Header 2
  NOP_T9
  Poke_NOP(D32, (80h Or reg_adr))

  For cnt_i = 1 To cnt_dat               ' data count
    Poke(ADWR, addr)
    NOP_T9
    Poke_NOP(D32, buf[cnt_i])
  Next cnt_i
  Sub_End_critical_section
EndSub


'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus broadcast no acknowlege
' module  : module address (0..255)
' channel : number of the LS interface on the LS module
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'---------------------------------------------------------------
Sub I_Send_BC(module, channel, reg_adr, cnt_dat, buf[]) ''<HIDE>
  Dim cnt_i, ftc As Long
  Dim addr, ftc As Long

  addr = (Shift_Left(module, 8) Or ext) + (channel - 1) * 8
  Do
    Sub_Begin_Critical_Section            ' tx FIFO count
    Poke_NOP(ADRD, addr + 5)
    ftc = Peek(D32)
    Sub_End_Critical_Section
  Until (ftc<(28 - cnt_dat))

  Sub_begin_critical_section
  Poke(ADWR, addr)                      ' Header 1
  NOP_T9
  Poke_NOP(D32, (Shift_Left(cnt_dat - 1, 4)))

  Poke(ADWR, addr)                      ' Header 2
  NOP_T9
  Poke_NOP(D32, (80h Or reg_adr))

  For cnt_i = 1 To cnt_dat               ' data count
    Poke(ADWR, addr)
    NOP_T9
    Poke_NOP(D32, buf[cnt_i])          ' data count
  Next cnt_i
  Sub_End_critical_section
EndSub


'---------------------------------------------------------------
' Request to read data
' module  : module address (0..255)
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
'---------------------------------------------------------------
Sub LS_Read_Req(module, channel, ls_module, reg_adr, cnt_dat) ''<HIDE>
  Dim addr, ftc As Long

  addr = (Shift_Left(module, 8) Or ext) + (channel - 1) * 8
  Do
    Sub_Begin_Critical_Section            ' tx FIFO count
    Poke_NOP(ADRD, addr + 5)
    ftc = Peek(D32)
    Sub_End_Critical_Section
  Until (ftc<28)

  Sub_begin_critical_section
  Poke(ADWR, addr)                      ' Header 1
  NOP_T9
  Poke_NOP(D32, (Shift_Left(cnt_dat - 1, 4) Or ls_module))

  Poke(ADWR, addr)                      ' Header 2
  NOP_T9
  Poke_NOP(D32, reg_adr)
  Sub_End_critical_section
EndSub


'---------------------------------------------------------------
' Read response (only DIG_IO request)
' module  : module address (0..255)
' channel : number of the LS interface on the LS module
' return  : state of digital outputs and inputs
'---------------------------------------------------------------
Function LS_Read_Resp_DIO(module, channel) As Long ''<HIDE>
  Dim ld[4] As Long At DM_Local
  Dim cnt_i As Long
  Dim addr As Long

  addr = (Shift_Left(module, 8) Or ext) + (channel - 1) * 8
  For cnt_i = 1 To 4             ' rx data read
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD, addr)
    ld[cnt_i] = Peek(D32)
    Sub_End_Critical_Section
  Next cnt_i
  LS_Read_Resp_DIO = ld[1] Or (Shift_Left(ld[2], 8)) Or (Shift_Left(ld[3], 16)) Or (Shift_Left(ld[4], 24))
EndFunction


'---------------------------------------------------------------
' Read response
' module  : module address (0..255)
' channel : number of the LS interface on the LS module
' cnt_dat : count of data  (1..16)
' buf[]   : array (min len is cnt_dat)
' return  : error code (0->ok)
'---------------------------------------------------------------
Function LS_Read_Resp(module, channel, cnt_dat, buf[]) As Long ''<HIDE>
  Dim cnt_i As Long
  Dim addr As Long

  addr = (Shift_Left(module, 8) Or ext) + (channel - 1) * 8
  For cnt_i = 1 To cnt_dat                  ' rx data read
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD, addr)
    buf[cnt_i] = Peek(D32)
    Sub_End_Critical_Section
  Next cnt_i

  Sub_Begin_Critical_Section
  Poke_NOP(ADRD, addr)
  LS_Read_Resp = Peek(D32)              ' acknowledge
  Sub_End_Critical_Section
EndFunction


'---------------------------------------------------------------
''' the Function reset the watchdog timer, set digital outputs and
'''+ read digital inputs.
'''+ return  : state of digital outputs and inputs
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
'''+ ls_module: device nr lsbus (FIX 1)
'''value: each bit corresponds to a channel
'''-------------------------------------------------------------
Function LS_Dig_IO(module, channel, value) As Long
  Dim ld[4] As Long At DM_Local
  Dim cnt_i As Long
  Dim addr As Long

  addr = (Shift_Left(module, 8) Or ext) + (channel - 1) * 8
  For cnt_i = 1 To 4                        ' rx data read
    Sub_Begin_Critical_Section
    Poke_NOP(ADRD, addr)
    ld[cnt_i] = Peek(D32)
    Sub_End_Critical_Section
  Next cnt_i

  LS_Dig_IO = ld[1] Or (Shift_Left(ld[2], 8)) Or (Shift_Left(ld[3], 16)) Or (Shift_Left(ld[4], 24))

  ld[1] = 1                               ' WD trigger
  I_Send_BC(module, channel, 44h, 1, ld)

  ld[1] = value And 0FFh                  ' tx data transmit
  ld[2] = Shift_Right(value, 8) And 0FFh
  ld[3] = Shift_Right(value, 16) And 0FFh
  ld[4] = Shift_Right(value, 24) And 0FFh
  I_Send_NA(module, channel, 1, 7Ch, 4, ld)   ' channel 1..32

  LS_Read_Req(module, channel, 1, 7Ch, 4)     ' request new in data
EndFunction


'---------------------------------------------------------------
''' the Function enable, disable and config the watchdog
'''+ return: error code (0->ok)
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr lsbus (1..15)
''' enable:  
'''+           0->disable
'''+           1->enable
''' time: trigger time [ms]
'''---------------------------------------------------------------
Function LS_Watchdog_Init(module, channel, ls_module, enable, time) As Long
  Dim ld[4] As Long At DM_Local
  Dim ret, t As Long

  'Watchdog disable
  ld[1] = 0ADh
  ld[2] = 0
  ret = I_Send(module, channel, ls_module, 45h, 2, ld)

  'Watchdog time
  t = time / 25e-6
  ld[1] = t And 0FFh
  ld[2] = Shift_Right(t, 8) And 0FFh
  ld[3] = Shift_Right(t, 16) And 0FFh
  ld[4] = Shift_Right(t, 24) And 0FFh
  ret = ret Or (I_Send(module, channel, ls_module, 48h, 4, ld))

  ' Watchdog enable
  ld[1] = 0ADh
  ld[2] = enable And 1
  LS_Watchdog_Init = ret Or (I_Send(module, channel, ls_module, 45h, 2, ld))
EndFunction


'---------------------------------------------------------------
''' reset the watchdog timer
'''+ If the watchdog is activated, the user program has to call
'''+ this Function at least every ....
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
'''-------------------------------------------------------------
Sub LS_Watchdog_Reset(module, channel)
  Dim ld[1] As Long At DM_Local

  ld[1] = 1
  I_Send_BC(module, channel, 44h, 1, ld)
EndSub


'---------------------------------------------------------------
''' Initialisation of a digital I/O module (channel 0-31)
'''+ return  : error code (0->ok)
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
''' value:     each bit corresponds to 8 channel
'''+           0 -> input
'''+           1 -> output
'''+           bit 0: channels 1..8
'''+               1: channels 9..16
'''+               2: channels 17..24
'''+               3: channels 25..32
'''-------------------------------------------------------------
Function LS_DigProg(module, channel, ls_module, value) As Long
  Dim ld[2] As Long At DM_Local
  Dim ret As Long

  ld[1] = Shift_Left(value, 3) And 8h
  ld[1] = ld[1] Or (Shift_Left(value, 7) And 80h)
  ld[1] = ld[1] Or 11h                    ' As after reset
  ld[2] = Shift_Left(value, 2) And 8h
  ld[2] = ld[2] Or (Shift_Left(value, 6) And 80h)
  ld[2] = ld[2] Or 11h
  ret = I_Send(module, channel, ls_module, 16h, 2, ld)

  ld[1] = Shift_Left(value, 1) And 8h
  ld[1] = ld[1] Or (Shift_Left(value, 5) And 80h)
  ld[1] = ld[1] Or 11h
  ld[2] = value And 8h
  ld[2] = ld[2] Or (Shift_Left(value, 4) And 80h)
  ld[2] = ld[2] Or 11h
  LS_DigProg = ret Or (I_Send(module, channel, ls_module, 20h + 16h, 2, ld))
EndFunction


'---------------------------------------------------------------
''' Sets the digital outputs (channel 0 - 31)
''' module: module address  (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
''' value: each bit corresponds to a channel
'''---------------------------------------------------------------
Sub LS_Digout_Long(module, channel, ls_module, value)
  Dim ld[4] As Long At DM_Local

  ld[1] = value And 0FFh
  ld[2] = Shift_Right(value, 8) And 0FFh
  ld[3] = Shift_Right(value, 16) And 0FFh
  ld[4] = Shift_Right(value, 24) And 0FFh
  I_Send_NA(module, channel, ls_module, 7Ch, 4, ld) ' channel 1..32
EndSub


'---------------------------------------------------------------
''' Reads the digital inputs (channel 0 - 31)
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
''' return: state of digital outputs and inputs
'''-------------------------------------------------------------
Function LS_Digin_Long(module, channel, ls_module) As Long
  Dim ld[4] As Long At DM_Local
  Dim ret As Long

  ret = I_Receive(module, channel, ls_module, 7Ch, 4, ld)
  LS_Digin_Long = ld[1] Or (Shift_Left(ld[2], 8)) Or (Shift_Left(ld[3], 16)) Or (Shift_Left(ld[4], 24))
EndFunction


'---------------------------------------------------------------
''' Reads the digital output status (overcurrent) (channel 0 - 31)
'''+ Return : each bit corresponds a channel 0 = OK 1 = Error
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr lsbus
'''-------------------------------------------------------------
Function LS_Get_Output_Status(module, channel, ls_module) As Long
  Dim ld[4] As Long At DM_Local
  Dim ret, t As Long

  t = I_Receive(module, channel, ls_module, 50h, 4, ld)
  ret = ld[1] Or Shift_Left(ld[2], 8) Or Shift_Left(ld[3], 16) Or Shift_Left(ld[4], 24)
  LS_Get_Output_Status = ret
EndFunction


'---------------------------------------------------------------
''' Initialize the LS-Modul
'''+ return: error code (0->ok)
''' module: module address (0..255)
''' channel: number of the LS interface on the LS module
''' ls_module: device nr LS-bus (1..15)
'''-------------------------------------------------------------
Function LS_DIO_Init(module, channel, ls_module) As Long
  Dim ld[4] As Long At DM_Local
  Dim ret As Long
  Dim addr As Long

  addr = (Shift_Left(module, 8) Or ext) + (channel - 1) * 8
  Sub_Begin_Critical_Section
  Poke(ADWR, addr + 6)                     ' autoreset rx ON
  NOP_T9
  Poke_NOP(D32, 1)
  Sub_End_Critical_Section

  ld[1] = 3
  ret = I_Send(module, channel, ls_module, 40h, 1, ld)          ' Reset JX 1, 2
  ld[1] = 1
  ret = ret Or (I_Send(module, channel, ls_module, 5Ch, 1, ld))   ' timeout reset

  ld[1] = 4
  ret = ret Or (I_Send(module, channel, ls_module, 4Ch, 1, ld))   ' Set default direction time

  ld[1] = 0
  ld[2] = 0
  ld[3] = 0
  ld[4] = 0
  LS_DIO_Init = ret Or (I_Send(module, channel, ls_module, 50h, 4, ld)) ' overcurrent reset

  ld[1] = 30h
  LS_DIO_Init = ret Or (I_Send(module, channel, ls_module, 43h, 1, ld)) ' overtemperature reset
EndFunction


#Else
#Error ("This include file can only be used with processor T11.")
#EndIf
